#!/usr/bin/env python
#!/bin/bash
#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for start the launcher
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import pygtk;pygtk.require('2.0');import gtk

from incompressibleMain import *
from heatTransferMain import *

class startWindow:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget):
        self.window.destroy()
        gtk.main_quit()

    def __init__(self):

        FOAM_USER_APPBIN = os.environ['FOAM_USER_APPBIN']
        installpath=FOAM_USER_APPBIN + '/Baram-GUI-v1.0.1'
        #installpath='/home/bykim/GUI/Baram/Baram-GUI-v1.0.1'

	caseDir='none'
	GEN=generalClass(caseDir)
  
        def start(widget,data=None):
	    aa=self.modeCombo.child;mode=aa.get_text()
	    aa=self.startCombo.child;start=aa.get_text()

	    if mode=='Incompressible Flow':
		if start=='New Project':
		    caseDir=GEN.newcase();self.window.destroy()
		    MAIN=incompressibleMainWindow(caseDir,installpath);MAIN.incompressibleMainGUI()	
		elif start=='Open Project':
		    caseDir=GEN.readcase();self.window.destroy()
		    MAIN=incompressibleMainWindow(caseDir,installpath);MAIN.incompressibleMainGUI()	
	    elif mode=='Heat Transfer':
		if start=='New Project':
		    caseDir=GEN.newcase();self.window.destroy()
		    MAIN=heatTransferMainWindow(caseDir,installpath);MAIN.heatTransferMainGUI()	
		elif start=='Open Project':
		    caseDir=GEN.readcase();self.window.destroy()
		    MAIN=heatTransferMainWindow(caseDir,installpath);MAIN.heatTransferMainGUI()	

        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL);self.window.set_title('NEXTFoam - OpenFOAM-2.3.x GUI')
        self.window.set_border_width(5);self.window.set_position(gtk.WIN_POS_CENTER)
	self.mainbox=gtk.VBox(False,0)
	self.window.add(self.mainbox)
	#-----------------------------------
	self.logobox=gtk.HBox(False,5)
	self.mainbox.pack_start(self.logobox,False,False,10)
        logo = gtk.Image();logo.set_from_file(installpath+"/baram.png")	
	self.logobox.pack_start(logo,False,False,0)
	#-----------------------------------
        self.frame=gtk.Frame()
        self.frame.set_shadow_type(gtk.SHADOW_IN)
	self.mainbox.pack_start(self.frame,False,False,5)

	self.selbox=gtk.VBox(False,5);self.frame.add(self.selbox)

	self.selectbox=gtk.HBox(False,5);self.selbox.pack_start(self.selectbox,False,False,10)
	self.label=gtk.Label('Select Density Mode')
	self.modeCombo=gtk.combo_box_entry_new_text();self.modeCombo.set_size_request(200,28)
	timelist=['Incompressible Flow','Heat Transfer']
	for vv in timelist:self.modeCombo.append_text(vv)
	self.modeCombo.set_active(0)
	self.selectbox.pack_start(self.label,False,False,5);self.selectbox.pack_end(self.modeCombo,False,False,5)

	self.startbox=gtk.HBox(False,5);self.selbox.pack_start(self.startbox,False,False,10)
	self.label=gtk.Label('Select Start Method')
	self.startCombo=gtk.combo_box_entry_new_text();self.startCombo.set_size_request(200,28)
	startList=['New Project','Open Project']
	for vv in startList:self.startCombo.append_text(vv)
	self.startCombo.set_active(0)
	self.startbox.pack_start(self.label,False,False,5);self.startbox.pack_end(self.startCombo,False,False,5)

	self.buttonbox=gtk.HBox(False,5);self.mainbox.pack_start(self.buttonbox,False,False,10)
        self.startB=gtk.Button(label='Start');self.startB.connect('clicked',start)
        self.cancelB=gtk.Button(label='Cancel');self.cancelB.connect('clicked',self.destroy)
	self.startB.set_size_request(150,30);self.cancelB.set_size_request(150,30)
	self.buttonbox.pack_end(self.cancelB,False,False,5);self.buttonbox.pack_end(self.startB,False,False,5)
        #-----------------------------------------------------------------------------------------
        self.window.show_all()

    def main(self):
        gtk.main()

if __name__=='__main__':
    win=startWindow()
    win.main()

