#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for boundary condition setup
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,glob;import pygtk;pygtk.require('2.0');import gtk

from generalSub import *

class boundaryConditionClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.covWin.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir

    def rotWallSet(self,rotwallname):

	def setCondition(widget):
	    aa=eCombo.child;rotAxis=aa.get_text()
	    rpm=TEntry.get_text()
	    orix=orixEntry.get_text();oriy=oriyEntry.get_text();oriz=orizEntry.get_text()
	    f=open(self.caseDir+'/temporary/rotatingWallVelocity_'+rotwallname,'w')
	    f.write(rotwallname+'\n')
	    f.write(orix+' '+oriy+' '+oriz+' '+rotAxis+' '+rpm+'\n')
	    f.close()
            window.destroy()

        def closethis(widget,data=None):
            window.destroy()
	#-------------------------------------------------------------------------------
        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('rotatingWallVelocity - '+rotwallname)
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame();frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	label=gtk.Label('Rot. Origin')
	orixEntry=gtk.Entry();orixEntry.set_size_request(60,28);orixEntry.set_text('0')
	oriyEntry=gtk.Entry();oriyEntry.set_size_request(60,28);oriyEntry.set_text('0')
	orizEntry=gtk.Entry();orizEntry.set_size_request(60,28);orizEntry.set_text('0')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5);hbox3.pack_end(orizEntry,False,False,5)
	hbox3.pack_end(oriyEntry,False,False,5);hbox3.pack_end(orixEntry,False,False,5)

	label=gtk.Label('Rot. axis')
	eCombo=gtk.combo_box_entry_new_text();eCombo.set_size_request(60,28)
	axisList=['x','y','z','-x','-y','-z']
	for ii in axisList:eCombo.append_text(ii)
	eCombo.set_active(2)
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5);hbox3.pack_end(eCombo,False,False,5)

	label=gtk.Label('RPM')
	TEntry=gtk.Entry();TEntry.set_size_request(120,28);TEntry.set_text('100')
	hbox4=gtk.HBox(False,5);vbox.pack_start(hbox4,False,False,5)
	hbox4.pack_start(label,False,False,5);hbox4.pack_end(TEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30);cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setCondition);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5) 

	aa=glob.glob(self.caseDir+'/temporary/rotatingWallVelocity_'+rotwallname)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    us=ff[1][:-1].split(' ')
	    orixEntry.set_text(us[0]);oriyEntry.set_text(us[1]);orizEntry.set_text(us[2])
	    if us[3]=='x':eCombo.set_active(0)
	    elif us[3]=='y':eCombo.set_active(1)
	    elif us[3]=='z':eCombo.set_active(2)
	    elif us[3]=='-x':eCombo.set_active(3)
	    elif us[3]=='-y':eCombo.set_active(4)
	    elif us[3]=='-z':eCombo.set_active(5)
	    TEntry.set_text(us[4])

        window.show_all() 
    #-------------------------------------------------------------------------------------------
    def flowBCWindow(self):

	GEN=generalClass(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

	def chType(widget,i):

	    def openrotwall(widget,nnn):self.rotWallSet(nnn)

	    aa=condition[i].child;method=aa.get_text()
	    if method=='wall':
		aa=hbox[i].get_children()
		if len(aa)==4:hbox[i].remove(aa[-1])
		elif len(aa)==6:
		    hbox[i].remove(ux[i]);hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
	    elif method=='moving-wall':
		aa=hbox[i].get_children()
		if len(aa)==4:
		    if str(aa[3])[5:11]=='Button':
			hbox[i].remove(aa[3])
			hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0);hbox[i].pack_start(uz[i],False,False,0)
		    else:
		        hbox[i].pack_start(uy[i],False,False,0);hbox[i].pack_start(uz[i],False,False,0)
		elif len(aa)==3:
		    hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0);hbox[i].pack_start(uz[i],False,False,0)
	    elif method=='fixed-U':
		aa=hbox[i].get_children()
		if len(aa)==4:
		    if str(aa[3])[5:11]=='Button':
			hbox[i].remove(aa[3])
			hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0);hbox[i].pack_start(uz[i],False,False,0)
		    else:
		        hbox[i].pack_start(uy[i],False,False,0);hbox[i].pack_start(uz[i],False,False,0)
		elif len(aa)==3:
		    hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0);hbox[i].pack_start(uz[i],False,False,0)
	    elif method=='surfaceNormal-U':
		aa=hbox[i].get_children()
		if len(aa)==6:
		    hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
		elif len(aa)==3:hbox[i].pack_start(ux[i],False,False,0)
		elif len(aa)==4:
		    if str(aa[3])[5:11]=='Button':
			hbox[i].remove(aa[3])
			hbox[i].pack_start(ux[i],False,False,0)
	    elif method=='volume-flowrate':
		aa=hbox[i].get_children()
		if len(aa)==6:
		    hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
		elif len(aa)==3:hbox[i].pack_start(ux[i],False,False,0)
		elif len(aa)==4:
		    if str(aa[3])[5:11]=='Button':
			hbox[i].remove(aa[3])
			hbox[i].pack_start(ux[i],False,False,0)
	    elif method=='mass-flowrate':
		aa=hbox[i].get_children()
		if len(aa)==6:
		    hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
		elif len(aa)==3:hbox[i].pack_start(ux[i],False,False,0)
		elif len(aa)==4:
		    if str(aa[3])[5:11]=='Button':
			hbox[i].remove(aa[3])
			hbox[i].pack_start(ux[i],False,False,0)
	    elif method=='total-pressure':
		aa=hbox[i].get_children()
		if len(aa)==6:
		    hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
		elif len(aa)==3:hbox[i].pack_start(ux[i],False,False,0)
		elif len(aa)==4:
		    if str(aa[3])[5:11]=='Button':
			hbox[i].remove(aa[3])
			hbox[i].pack_start(ux[i],False,False,0)
	    elif method=='outlet':
		aa=hbox[i].get_children()
		if len(aa)==6:
		    hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
		elif len(aa)==3:hbox[i].pack_start(ux[i],False,False,0)		
		elif len(aa)==4:
		    if str(aa[3])[5:11]=='Button':
			hbox[i].remove(aa[3])
			hbox[i].pack_start(ux[i],False,False,0)
	    elif method=='movingWallVelocity':
		aa=hbox[i].get_children()
		if len(aa)==4:hbox[i].remove(aa[-1])
		elif len(aa)==6:
		    hbox[i].remove(ux[i]);hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
	    elif method=='rotatingWallVelocity':
		aa=hbox[i].get_children()
		if len(aa)==4:hbox[i].remove(aa[-1])
		elif len(aa)==6:
		    hbox[i].remove(ux[i]);hbox[i].remove(uy[i]);hbox[i].remove(uz[i])
		nnn=bcpatch[i]
		rotWallButton=gtk.Button('Set');rotWallButton.connect('clicked',openrotwall,nnn)
		rotWallButton.set_size_request(60,28)
		hbox[i].pack_start(rotWallButton,False,False,0)

	    window.show_all()

	def setConditions(widget):
	    bcdict={};uxi=interUxEntry.get_text();uyi=interUyEntry.get_text();uzi=interUzEntry.get_text();pi=interpEntry.get_text()
	    for i in range(len(bcpatch)):
		a1=condition[i].child;con=a1.get_text()
		if con=='wall':bcdict[bcpatch[i]]=['wall','wall',['None','None','None']]
		elif con=='moving-wall':bcdict[bcpatch[i]]=['wall','moving-wall',[ux[i].get_text(),uy[i].get_text(),uz[i].get_text()]]
		elif con=='fixed-U':bcdict[bcpatch[i]]=['patch','fixed-U',[ux[i].get_text(),uy[i].get_text(),uz[i].get_text()]]
		elif con=='surfaceNormal-U':bcdict[bcpatch[i]]=['patch','surfaceNormal-U',[ux[i].get_text(),'None','None']]
		elif con=='volume-flowrate':bcdict[bcpatch[i]]=['patch','volume-flowrate',[ux[i].get_text(),'None','None']]
		elif con=='mass-flowrate':bcdict[bcpatch[i]]=['patch','mass-flowrate',[ux[i].get_text(),'None','None']]
		elif con=='total-pressure':bcdict[bcpatch[i]]=['patch','total-pressure',[ux[i].get_text(),'None','None']]
		elif con=='outlet':bcdict[bcpatch[i]]=['patch','outlet',[ux[i].get_text(),'None','None']]
		elif con=='movingWallVelocity':bcdict[bcpatch[i]]=['patch','movingWallVelocity',['None','None','None']]
		elif con=='rotatingWallVelocity':
		    aa=glob.glob(self.caseDir+'/temporary/rotatingWallVelocity_'+bcpatch[i])
		    if len(aa)!=0:
			f=open(aa[0],'r');ff=f.readlines();f.close()
	    		us=ff[1][:-1].split(' ')
			ori='('+us[0]+' '+us[1]+' '+us[2]+')';axis=us[3];rpm=us[4]
		        bcdict[bcpatch[i]]=['patch','rotatingWallVelocity',[ori,axis,rpm]]
		    else:print 'Error!! rotatingWallVelocity condition have some problem'

	    f=open(self.caseDir+'/temporary/flowBoundaryConditions','w')
	    f.write(uxi+'\n');f.write(uyi+'\n');f.write(uzi+'\n');f.write(pi+'\n')
	    for i in range(len(bcpatch)):
		aaa=bcdict[bcpatch[i]]
		f.write(bcpatch[i]+','+aaa[0]+','+aaa[1]+','+aaa[2][0]+','+aaa[2][1]+','+aaa[2][2]+'\n')
	    f.close()

	    window.destroy()

	bcName=[];bcType=[]
        aa=GEN.getBCName()
	for jj in aa:bcName.append(jj)
	bb=GEN.getBCType()
	for kk in bb:bcType.append(kk)

	bcpatch=[];nameType={}
	for i in range(len(bcName)):
	    nameType[bcName[i]]=bcType[i]
	    if bcType[i]=='wall' or bcType[i]=='patch' or bcType[i]=='mappedWall':
		bcpatch.append(bcName[i])

	bcpatch.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Boundary Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

	intervbox=gtk.VBox(False,5);interUbox=gtk.HBox(False,5);interpbox=gtk.HBox(False,5)
	mainbox.pack_start(intervbox,False,False,5)
	intervbox.pack_start(interUbox,False,False,5);intervbox.pack_start(interpbox,False,False,5)
	labelU=gtk.Label('internalField U');labelp=gtk.Label('internalField p')
	interUxEntry=gtk.Entry();interUxEntry.set_size_request(60,28);interUxEntry.set_text('0')
	interUyEntry=gtk.Entry();interUyEntry.set_size_request(60,28);interUyEntry.set_text('0')
	interUzEntry=gtk.Entry();interUzEntry.set_size_request(60,28);interUzEntry.set_text('0')
	interpEntry=gtk.Entry();interpEntry.set_size_request(60,28);interpEntry.set_text('0')
	interUbox.pack_start(labelU,False,False,5);interUbox.pack_start(interUxEntry,False,False,5)
	interUbox.pack_start(interUyEntry,False,False,5);interUbox.pack_start(interUzEntry,False,False,5)
	interpbox.pack_start(labelp,False,False,5);interpbox.pack_start(interpEntry,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        scheight=len(bcpatch)*43;
        if scheight > 750:scheight=750        
	elif scheight < 200:scheight=200     
        swin.set_size_request(630,scheight)

        mainbox.pack_start(swin,True,True,5);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)

	labelbox=gtk.HBox(False,5);itembox.pack_start(labelbox,False,False,2)

        label01=gtk.Entry();label01.set_text('Name');label01.set_size_request(180,28);labelbox.pack_start(label01,False,False,0)
        label02=gtk.Entry();label02.set_text('Type');label02.set_size_request(80,28);labelbox.pack_start(label02,False,False,0)
        label03=gtk.Entry();label03.set_text('Condition');label03.set_size_request(150,28);labelbox.pack_start(label03,False,False,0)
        label04=gtk.Entry();label04.set_text('Ux,Uy,Uz or Umag or p');label04.set_size_request(180,28);labelbox.pack_start(label04,False,False,0)
	label01.set_editable(False);label02.set_editable(False);label03.set_editable(False);label04.set_editable(False)

	label01.set_has_frame(False);label02.set_has_frame(False);label03.set_has_frame(False);label04.set_has_frame(False)

        faceName=[];Type=[];condition=[];setButton=[];hbox=[]
	ux=[];uy=[];uz=[]

        for i in range(len(bcpatch)):
            hbox.append(gtk.HBox(False,5));itembox.pack_start(hbox[i],False,False,2)                

            faceName.append(gtk.Entry());faceName[i].set_size_request(180,28)
            faceName[i].set_text(bcpatch[i]);faceName[i].set_editable(False)

            Type.append(gtk.Entry())
            Type[i].set_size_request(80,28);Type[i].set_editable(False)

	    ux.append(gtk.Entry());ux[i].set_size_request(60,28);ux[i].set_text('0')
	    uy.append(gtk.Entry());uy[i].set_size_request(60,28);uy[i].set_text('0')
	    uz.append(gtk.Entry());uz[i].set_size_request(60,28);uz[i].set_text('0')

            if nameType[bcpatch[i]]=='wall':Type[i].set_text('wall') 
            elif nameType[bcpatch[i]]=='mappedWall':Type[i].set_text('wall') 
	    else:Type[i].set_text('patch') 

            condition.append(gtk.combo_box_entry_new_text())
            condition[i].set_size_request(150,28)
            conditionList=['wall','moving-wall','fixed-U','surfaceNormal-U','volume-flowrate','mass-flowrate','total-pressure','outlet',
			   'rotatingWallVelocity','movingWallVelocity']
            for j in range(len(conditionList)):condition[i].append_text(conditionList[j])
	    hbox[i].pack_start(faceName[i],False,False,0)
	    hbox[i].pack_start(Type[i],False,False,0)
	    hbox[i].pack_start(condition[i],False,False,0)
            if nameType[bcpatch[i]]=='wall' or nameType[bcpatch[i]]=='mappedWall':condition[i].set_active(0) 
            else:
		condition[i].set_active(2);
		hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0);hbox[i].pack_start(uz[i],False,False,0)
	    
	    condition[i].connect('changed',chType,i)

        vv=glob.glob(self.caseDir+'/temporary/flowBoundaryConditions')
        if len(vv)!=0:
	    f=open(self.caseDir+'/temporary/flowBoundaryConditions','r');fff=f.readlines();f.close()
	    interUxEntry.set_text(fff[0][:-1]);interUyEntry.set_text(fff[1][:-1]);interUzEntry.set_text(fff[2][:-1])
	    interpEntry.set_text(fff[3][:-1])
	    ff=fff[4:]
	    for i in range(len(ff)):
		a1=ff[i][:-1].split(',')
		faceName[i].set_text(a1[0])
		Type[i].set_text(a1[1])
		bb=conditionList.index(a1[2]);condition[i].set_active(bb)
		if a1[2]=='fixed-U':
		    ux[i].set_text(a1[3]);uy[i].set_text(a1[4]);uz[i].set_text(a1[5])
		elif a1[2]=='surfaceNormal-U':ux[i].set_text(a1[3])
		elif a1[2]=='volume-flowrate':ux[i].set_text(a1[3])
		elif a1[2]=='mass-flowrate':ux[i].set_text(a1[3])
		elif a1[2]=='total-pressure':ux[i].set_text(a1[3])
		elif a1[2]=='outlet':ux[i].set_text(a1[3])

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(150,28)
        cll=gtk.Button(label='Close');cll.set_size_request(150,28)
        app.connect('clicked',setConditions)
	cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all() 
#-------------------------------------------------------------------------------------------
    def turBCWindow(self,turModel):

	if turModel=='kOmega' or turModel=='kOmegaSST':epsilonOrOmega='omega'
	else:epsilonOrOmega='epsilon'

	GEN=generalClass(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

	def chType(widget,i):
	    aa=condition[i].child;method=aa.get_text()
	    if method=='fixed-Value':
		aa=hbox[i].get_children()
		if len(aa)==3:
		    hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0)
	    elif method=='inletOutlet':
		aa=hbox[i].get_children()
		if len(aa)==3:
		    hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0)
	    else:
		aa=hbox[i].get_children()
		if len(aa)==5:
		    hbox[i].remove(ux[i]);hbox[i].remove(uy[i])

	    window.show_all()

	def setConditions(widget):
	    aa=inCombo.child;method=aa.get_text();ki=interkEntry.get_text();ei=intereEntry.get_text()
	    bcdict={}
	    for i in range(len(bcpatch)):
		a1=condition[i].child;con=a1.get_text()
		if con=='fixed-Value':bcdict[bcpatch[i]]=['patch','fixed-Value',[ux[i].get_text(),uy[i].get_text()]]
		elif con=='zeroGradient':bcdict[bcpatch[i]]=['patch','zeroGradient',['None','None']]
		elif con=='inletOutlet':bcdict[bcpatch[i]]=['patch','inletOutlet',[ux[i].get_text(),uy[i].get_text()]]
		else:bcdict[bcpatch[i]]=['wall','wallFunction',['None','None']]

	    f=open(self.caseDir+'/temporary/turBoundaryConditions','w')
	    f.write(method+'\n');f.write(ki+'\n');f.write(ei+'\n')
	    for i in range(len(bcpatch)):
		aaa=bcdict[bcpatch[i]]
		f.write(bcpatch[i]+','+aaa[0]+','+aaa[1]+','+aaa[2][0]+','+aaa[2][1]+'\n')
	    f.close()

	    window.destroy()

	def chmethod(widget):
	    aa=inCombo.child;method=aa.get_text()
	    if method=='intensity/vis.ratio':
		interkbox.remove(labelk);interkbox.remove(interkEntry)
		interebox.remove(labele);interebox.remove(intereEntry)
		labelbox.remove(label04);labelbox.remove(label05)
		interkbox.pack_start(labelk1,False,False,5);interkbox.pack_start(interkEntry,False,False,5)
		interebox.pack_start(labele1,False,False,5);interebox.pack_start(intereEntry,False,False,5)
		labelbox.pack_start(label041,False,False,0);labelbox.pack_start(label051,False,False,0)
	    else:
		interkbox.remove(labelk1);interkbox.remove(interkEntry)
		interebox.remove(labele1);interebox.remove(intereEntry)
		labelbox.remove(label041);labelbox.remove(label051)
		interkbox.pack_start(labelk,False,False,5);interkbox.pack_start(interkEntry,False,False,5)
		interebox.pack_start(labele,False,False,5);interebox.pack_start(intereEntry,False,False,5)
		labelbox.pack_start(label04,False,False,0);labelbox.pack_start(label05,False,False,0)
	    window.show_all()

	bcName=[];bcType=[]
        aa=GEN.getBCName()
	for jj in aa:bcName.append(jj)
	bb=GEN.getBCType()
	for kk in bb:bcType.append(kk)

	bcpatch=[];nameType={}
	for i in range(len(bcName)):
	    nameType[bcName[i]]=bcType[i]
	    if bcType[i]=='wall' or bcType[i]=='patch' or bcType[i]=='mappedWall':
		bcpatch.append(bcName[i])

	bcpatch.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Boundary Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

	methodbox=gtk.HBox(False,5);mainbox.pack_start(methodbox,False,False,5)
	tlabel=gtk.Label('turbulence input method')
        inCombo=gtk.combo_box_entry_new_text();inCombo.set_size_request(160,28)
	#methodList=['k/'+epsilonOrOmega,'intensity/vis.ratio']
	methodList=['k/'+epsilonOrOmega]
	for ii in methodList:inCombo.append_text(ii)
	inCombo.set_active(0);inCombo.connect('changed',chmethod)
	methodbox.pack_start(tlabel,False,False,5);methodbox.pack_start(inCombo,False,False,5)

	intervbox=gtk.VBox(False,5);interkbox=gtk.HBox(False,5);interebox=gtk.HBox(False,5)
	mainbox.pack_start(intervbox,False,False,5)
	intervbox.pack_start(interkbox,False,False,5);intervbox.pack_start(interebox,False,False,5)
	labelk=gtk.Label('internalField, kinetic energy, k   ');labele=gtk.Label('internalField, '+epsilonOrOmega+'  ')
	labelk1=gtk.Label('internalField, turb. intensity');labele1=gtk.Label('viscosity ratio')

	interkEntry=gtk.Entry();interkEntry.set_size_request(100,28);interkEntry.set_text('0.1')
	intereEntry=gtk.Entry();intereEntry.set_size_request(100,28);intereEntry.set_text('10')
	interkbox.pack_start(labelk,False,False,5);interkbox.pack_start(interkEntry,False,False,5)
	interebox.pack_start(labele,False,False,5);interebox.pack_start(intereEntry,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        scheight=len(bcpatch)*43;
        if scheight > 750:scheight=750    
	elif scheight < 200:scheight=200         
        swin.set_size_request(630,scheight)

        mainbox.pack_start(swin,True,True,5);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)

	labelbox=gtk.HBox(False,5);itembox.pack_start(labelbox,False,False,2)

        label01=gtk.Entry();label01.set_text('Name');label01.set_size_request(180,28);labelbox.pack_start(label01,False,False,0)
        label02=gtk.Entry();label02.set_text('Type');label02.set_size_request(80,28);labelbox.pack_start(label02,False,False,0)
        label03=gtk.Entry();label03.set_text('Condition');label03.set_size_request(150,28);labelbox.pack_start(label03,False,False,0)
        label04=gtk.Entry();label04.set_text('k ');label04.set_size_request(80,28);labelbox.pack_start(label04,False,False,0)
        label05=gtk.Entry();label05.set_text(epsilonOrOmega);label05.set_size_request(80,28);labelbox.pack_start(label05,False,False,0)
	label01.set_editable(False);label02.set_editable(False);label03.set_editable(False);label04.set_editable(False);label05.set_editable(False)
	label01.set_has_frame(False);label02.set_has_frame(False);label03.set_has_frame(False);label04.set_has_frame(False);label05.set_has_frame(False)
        label041=gtk.Entry();label041.set_text('intensity ');label041.set_size_request(80,28)
        label051=gtk.Entry();label051.set_text('vis.ratio');label051.set_size_request(80,28)
	label041.set_editable(False);label051.set_editable(False);label041.set_has_frame(False);label051.set_has_frame(False)

        faceName=[];Type=[];condition=[];setButton=[];hbox=[]
	ux=[];uy=[]

        for i in range(len(bcpatch)):
            hbox.append(gtk.HBox(False,5));itembox.pack_start(hbox[i],False,False,2)                

            faceName.append(gtk.Entry());faceName[i].set_size_request(180,28)
            faceName[i].set_text(bcpatch[i]);faceName[i].set_editable(False)

            Type.append(gtk.Entry())
            Type[i].set_size_request(80,28);Type[i].set_editable(False)

	    ux.append(gtk.Entry());ux[i].set_size_request(80,28);ux[i].set_text('0.1')
	    uy.append(gtk.Entry());uy[i].set_size_request(80,28);uy[i].set_text('10')

            if nameType[bcpatch[i]]=='wall':Type[i].set_text('wall') 
            elif nameType[bcpatch[i]]=='mappedWall':Type[i].set_text('wall') 
	    else:Type[i].set_text('patch') 

            condition.append(gtk.combo_box_entry_new_text())
            condition[i].set_size_request(150,28)
            conditionList=['wallFunction','fixed-Value','zeroGradient','inletOutlet']
            for j in range(len(conditionList)):condition[i].append_text(conditionList[j])

	    hbox[i].pack_start(faceName[i],False,False,0)
	    hbox[i].pack_start(Type[i],False,False,0)
	    hbox[i].pack_start(condition[i],False,False,0)
            if nameType[bcpatch[i]]=='wall' or nameType[bcpatch[i]]=='mappedWall':condition[i].set_active(0) 
            else:
		condition[i].set_active(1);
		hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0)
	    
	    condition[i].connect('changed',chType,i)

        vv=glob.glob(self.caseDir+'/temporary/turBoundaryConditions')
        if len(vv)!=0:
	    f=open(self.caseDir+'/temporary/turBoundaryConditions','r');fff=f.readlines();f.close()
	    aa=fff[0][:-1]
	    if aa=='k/epsilon' or aa=='k/omega':inCombo.set_active(0)
	    else:inCombo.set_active(1)
	    interkEntry.set_text(fff[1][:-1]);intereEntry.set_text(fff[2][:-1])
	    ff=fff[3:]
	    for i in range(len(ff)):
		a1=ff[i][:-1].split(',')
		faceName[i].set_text(a1[0])
		Type[i].set_text(a1[1])
		bb=conditionList.index(a1[2]);condition[i].set_active(bb)
		if a1[2]=='fixed-Value':
		    ux[i].set_text(a1[3]);uy[i].set_text(a1[4])
		elif a1[2]=='inletOutlet':
		    ux[i].set_text(a1[3]);uy[i].set_text(a1[4])

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(150,28)
        cll=gtk.Button(label='Close');cll.set_size_request(150,28)
        app.connect('clicked',setConditions)
	cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all() 
    #-------------------------------------------------------------------------------------------
    def thermalBCWindow(self):

	GEN=generalClass(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

	def chType(widget,i):
	    aa=condition[i].child;method=aa.get_text()
	    if method=='zeroGradient':
		aa=hbox[i].get_children()
		if len(aa)==4:hbox[i].remove(ux[i])
		elif len(aa)==5:
		    hbox[i].remove(ux[i]);hbox[i].remove(uy[i])
	    elif method=='fixedValue':
		aa=hbox[i].get_children()
		if len(aa)==3:hbox[i].pack_start(ux[i],False,False,0)
		elif len(aa)==5:hbox[i].remove(uy[i])
	    elif method=='heatflux':
		aa=hbox[i].get_children()
		if len(aa)==3:hbox[i].pack_start(ux[i],False,False,0)
		elif len(aa)==5:hbox[i].remove(uy[i])
	    elif method=='convection':
		aa=hbox[i].get_children()
		if len(aa)==4:hbox[i].pack_start(uy[i],False,False,0)
		elif len(aa)==3:
		    hbox[i].pack_start(ux[i],False,False,0);hbox[i].pack_start(uy[i],False,False,0)
	    #elif method=='coupled':
	    #	aa=hbox[i].get_children()
	    #	if len(aa)==5:
	    #	    hbox[i].remove(ux[i]);hbox[i].remove(uy[i])
	    #	elif len(aa)==4:
	    #	    hbox[i].remove(ux[i])

	    window.show_all()

	def setConditions(widget):
	    bcdict={}
	    for i in range(len(bcpatch)):
		a1=condition[i].child;con=a1.get_text()
		if con=='zeroGradient':bcdict[bcpatch[i]]=['zeroGradient',['None','None','None']]
		elif con=='fixedValue':bcdict[bcpatch[i]]=['fixedValue',[ux[i].get_text(),'None','None']]
		elif con=='heatflux':bcdict[bcpatch[i]]=['heatflux',[ux[i].get_text(),'None','None']]
		elif con=='convection':bcdict[bcpatch[i]]=['convection',[ux[i].get_text(),uy[i].get_text(),'None']]
		#elif con=='coupled':bcdict[bcpatch[i]]=['coupled',['None','None','None']]

	    f=open(self.caseDir+'/temporary/thermalBoundaryConditions','w')
	    Tini=interTEntry.get_text()
	    f.write(Tini+'\n')

	    for i in range(len(bcpatch)):
		aaa=bcdict[bcpatch[i]]
		f.write(bcpatch[i]+','+aaa[0]+','+aaa[1][0]+','+aaa[1][1]+','+aaa[1][2]+'\n')
	    f.close()

	    window.destroy()

	bcName=GEN.getBCName();bcType=GEN.getBCType()
	bcpatch=[];nameType={}
	for i in range(len(bcName)):
	    nameType[bcName[i]]=bcType[i]
	    if bcType[i]=='wall' or bcType[i]=='patch':bcpatch.append(bcName[i])
	bcpatch.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Boundary Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

	interTbox=gtk.HBox(False,5)
	mainbox.pack_start(interTbox,False,False,5)
	labelT=gtk.Label('internalField T')
	interTEntry=gtk.Entry();interTEntry.set_size_request(60,28);interTEntry.set_text('300')
	interTbox.pack_start(labelT,False,False,5);interTbox.pack_start(interTEntry,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
        scheight=len(bcpatch)*43
        if scheight > 750:scheight=750   
	elif scheight < 200:scheight=200     
        swin.set_size_request(610,scheight)


	labelbox=gtk.HBox(False,5);itembox.pack_start(labelbox,False,False,2)

        label01=gtk.Entry();label01.set_text('Name');label01.set_size_request(180,28);labelbox.pack_start(label01,False,False,0)
        label02=gtk.Entry();label02.set_text('Type');label02.set_size_request(80,28);labelbox.pack_start(label02,False,False,0)
        label03=gtk.Entry();label03.set_text('Condition');label03.set_size_request(150,28);labelbox.pack_start(label03,False,False,0)
        label04=gtk.Entry();label04.set_text('T or Q ');label04.set_size_request(80,28);labelbox.pack_start(label04,False,False,0)
        label05=gtk.Entry();label05.set_text('h_coeff');label05.set_size_request(80,28);labelbox.pack_start(label05,False,False,0)
	label01.set_editable(False);label02.set_editable(False);label03.set_editable(False);label04.set_editable(False);label05.set_editable(False)
	label01.set_has_frame(False);label02.set_has_frame(False);label03.set_has_frame(False);label04.set_has_frame(False);label05.set_has_frame(False)

        faceName=[];Type=[];condition=[];setButton=[];hbox=[]
	ux=[];uy=[]

        for i in range(len(bcpatch)):
            hbox.append(gtk.HBox(False,5));itembox.pack_start(hbox[i],False,False,2)                

            faceName.append(gtk.Entry());faceName[i].set_size_request(180,28)
            faceName[i].set_text(bcpatch[i]);faceName[i].set_editable(False)

            Type.append(gtk.Entry())
            Type[i].set_size_request(80,28);Type[i].set_editable(False)

	    ux.append(gtk.Entry());ux[i].set_size_request(80,28);ux[i].set_text('300')
	    uy.append(gtk.Entry());uy[i].set_size_request(80,28);ux[i].set_text('300')

            if nameType[bcpatch[i]]=='wall':Type[i].set_text('wall') 
            elif nameType[bcpatch[i]]=='mappedWall':Type[i].set_text('wall') 
	    else:Type[i].set_text('patch') 

            condition.append(gtk.combo_box_entry_new_text())
            condition[i].set_size_request(150,28)
            #conditionList=['zeroGradient','fixedValue','heatflux','convection','coupled']
            conditionList=['zeroGradient','fixedValue','heatflux','convection']
            for j in range(len(conditionList)):condition[i].append_text(conditionList[j])
	    hbox[i].pack_start(faceName[i],False,False,0)
	    hbox[i].pack_start(Type[i],False,False,0)
	    hbox[i].pack_start(condition[i],False,False,0)
            if nameType[bcpatch[i]]=='wall':condition[i].set_active(0) 
            elif nameType[bcpatch[i]]=='mappedWall':condition[i].set_active(4) 
            else:
		condition[i].set_active(1);
		hbox[i].pack_start(ux[i],False,False,0)
	    
	    condition[i].connect('changed',chType,i)

        vv=glob.glob(self.caseDir+'/temporary/thermalBoundaryConditions')
        if len(vv)!=0:
	    f=open(self.caseDir+'/temporary/thermalBoundaryConditions','r');ff=f.readlines();f.close()
	    interTEntry.set_text(ff[0][:-1])
	    for i in range(len(ff)-1):
		a1=ff[i+1][:-1].split(',')
		faceName[i].set_text(a1[0])
		bb=conditionList.index(a1[1]);condition[i].set_active(bb)
		if a1[1]=='fixedValue':ux[i].set_text(a1[2])
		elif a1[1]=='heatflux':ux[i].set_text(a1[2])
		elif a1[1]=='convection':
		    ux[i].set_text(a1[2]);uy[i].set_text(a1[3])

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(150,28)
        cll=gtk.Button(label='Close');cll.set_size_request(150,28)
        app.connect('clicked',setConditions)
	cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all() 
#-------------------------------------------------------------------------------------------
    def internalField(self):

	GEN=generalClass(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

	def setValue(widget):
	    ux=uxEntry.get_text();uy=uyEntry.get_text();uz=uzEntry.get_text()
	    uu='('+ux+' '+uy+' '+uz+')'
	    pp=pEntry.get_text();kk=kEntry.get_text();ee=eEntry.get_text()
	    f=open(self.caseDir+'/temporary/internalFieldValue','w')
	    f.write(uu+'\n');f.write(pp+'\n');f.write(kk+'\n');f.write(ee+'\n')
	    f.close()
	    window.destroy()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Boundary Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)
	frame=gtk.Frame();frame.set_label('internalField');frame.set_label_align(0.0,1.0)
        frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        
        mainbox.pack_start(frame,False,False,5)
	setbox=gtk.VBox(False,5);frame.add(setbox)
	#----------------
	label=gtk.Label('Ux, Uy, Uz')
	uxEntry=gtk.Entry();uxEntry.set_size_request(50,28);uxEntry.set_text('0')
	uyEntry=gtk.Entry();uyEntry.set_size_request(50,28);uyEntry.set_text('0')
	uzEntry=gtk.Entry();uzEntry.set_size_request(50,28);uzEntry.set_text('0')

	hbox2=gtk.HBox(False,5);setbox.pack_start(hbox2,False,False,5)
	hbox2.pack_start(label,False,False,5);hbox2.pack_end(uzEntry,False,False,2)
	hbox2.pack_end(uyEntry,False,False,2);hbox2.pack_end(uxEntry,False,False,2)
	#-----------------
	label=gtk.Label('p')
	pEntry=gtk.Entry();pEntry.set_size_request(100,28);pEntry.set_text('0')
	hbox3=gtk.HBox(False,5);setbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5);hbox3.pack_end(pEntry,False,False,5)
	#-----------------
	label=gtk.Label('k')
	kEntry=gtk.Entry();kEntry.set_size_request(100,28);kEntry.set_text('0.1')
	hbox4=gtk.HBox(False,5);setbox.pack_start(hbox4,False,False,5)
	hbox4.pack_start(label,False,False,5);hbox4.pack_end(kEntry,False,False,5)
	#-----------------
	label=gtk.Label('epsilon / omega')
	eEntry=gtk.Entry();eEntry.set_size_request(100,28);eEntry.set_text('100')
	hbox5=gtk.HBox(False,5);setbox.pack_start(hbox5,False,False,5)
	hbox5.pack_start(label,False,False,5);hbox5.pack_end(eEntry,False,False,5)
	#----------------------------------------------------------
	butbox=gtk.HBox(False,5);mainbox.pack_start(butbox,False,False,5)
        appB=gtk.Button('Set');appB.set_size_request(100,28);appB.connect('clicked',setValue)
        cllB=gtk.Button(label='Close');cllB.set_size_request(100,28);cllB.connect('clicked',closethis)
        butbox.pack_end(cllB,False,False,5);butbox.pack_end(appB,False,False,5)  
	#----------------------------------------------------------
	aaa=glob.glob(self.caseDir+'/temporary/internalFieldValue')
	if len(aaa)!=0:	
	    f=open(self.caseDir+'/temporary/internalFieldValue','r');ff=f.readlines();f.close()
	    uu=ff[0][1:-2];ru=uu.split(' ')
	    uxEntry.set_text(ru[0]);uyEntry.set_text(ru[1]);uzEntry.set_text(ru[2])
	    pEntry.set_text(ff[1][:-1]);kEntry.set_text(ff[2][:-1]);eEntry.set_text(ff[3][:-1])	        

        window.show_all() 
    #-------------------------------------------------------------------------------------------
    def openHeatSource(self):

	GEN=generalClass(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

	def setSource(widget):
	    check=[];sourceValue=[]
	    for i in range(len(zones)):
		check.append(zones[i].get_active())
		aa=values[i].get_text();sourceValue.append(aa)
	    f=open(self.caseDir+'/temporary/heatSources','w')
	    for i in range(len(zones)):
		if check[i]==True:f.write(cellZones[i]+' : '+sourceValue[i]+'\n')
		else:f.write(cellZones[i]+',None\n')
	    f.close()
            window.destroy()

	cellZones=GEN.getCellZones()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Heat Source Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        ibox=gtk.HBox(False,5);mainbox.pack_start(ibox,False,False,5)        
        label01=gtk.Label('cellZones');label01.set_size_request(150,28);ibox.pack_start(label01,False,False,5)
        label03=gtk.Label('Source[W/m3]');label03.set_size_request(150,28);ibox.pack_start(label03,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
        scheight=len(cellZones)*38
        if scheight > 750:scheight=750        
        swin.set_size_request(250,scheight)

        zones=[];values=[]
        for i in range(len(cellZones)):
            hbox1=gtk.HBox(False,5);itembox.pack_start(hbox1,False,False,2)                

            zones.append(gtk.CheckButton(cellZones[i]));zones[i].set_size_request(180,28)

	    values.append(gtk.Entry());values[i].set_size_request(110,28)

            vv=glob.glob(self.caseDir+'/temporary/heatSources')
            if len(vv)==0:
	        values[i].set_text('0')
            else:
		f=open(self.caseDir+'/temporary/heatSources','r');ff=f.readlines();f.close()
		keys=[];vals=[]
		for j in range(len(ff)):
		    aa=ff[j][:-1].split(':')
		    keys.append(aa[0].strip());vals.append(aa[1].strip())
		if vals[i]=='None':values[i].set_text('0')
		else:
		    values[i].set_text(vals[i])
		    zones[i].set_active(1)

            hbox1.pack_start(zones[i],False,False,0);hbox1.pack_start(values[i],False,False,0)

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(150,28)
        cll=gtk.Button(label='Cancel');cll.set_size_request(150,28)
        app.connect('clicked',setSource)
	cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all() 
    #-------------------------------------------------------------------------------------------
    def openProperty(self):

	GEN=generalClass(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

	def setProp(widget):
	    f=open(self.caseDir+'/temporary/properties','w')
	    vis=visEntry.get_text();rho=rhoEntry.get_text();cp=cpEntry.get_text()
	    kk=kkEntry.get_text();beta=betaEntry.get_text();tref=trefEntry.get_text()
	    f.write(vis+'\n');f.write(rho+'\n');f.write(cp+'\n');f.write(kk+'\n');f.write(beta+'\n');f.write(tref+'\n')
	    f.close()
            window.destroy()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Heat Source Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame();frame1.set_label(' Material Properties ');frame1.set_label_align(0.1, 0.5)
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame1,False,False,5)
	
	vbox1=gtk.VBox(False,3);frame1.add(vbox1)	

        labels=['viscosity[kg/ms]','density[kg/m3]','Cp[J/kgK]','Conductivity[W/mk]','Thermal expansion coeff.[1/K]','Tref[K]']
	defaultvalue=['0.08','1000','4182','0.6','0','300']

	label=gtk.Label(labels[0])
	visEntry=gtk.Entry();visEntry.set_size_request(100,28);visEntry.set_text(defaultvalue[0])	
	visbox=gtk.HBox(False,5);vbox1.pack_start(visbox,False,False,5)
	visbox.pack_start(label,False,False,5);visbox.pack_end(visEntry,False,False,5)

	label=gtk.Label(labels[1])
	rhoEntry=gtk.Entry();rhoEntry.set_size_request(100,28);rhoEntry.set_text(defaultvalue[1])	
	rhobox=gtk.HBox(False,5);vbox1.pack_start(rhobox,False,False,5)
	rhobox.pack_start(label,False,False,5);rhobox.pack_end(rhoEntry,False,False,5)

	label=gtk.Label(labels[2])
	cpEntry=gtk.Entry();cpEntry.set_size_request(100,28);cpEntry.set_text(defaultvalue[2])	
	cpbox=gtk.HBox(False,5);vbox1.pack_start(cpbox,False,False,5)
	cpbox.pack_start(label,False,False,5);cpbox.pack_end(cpEntry,False,False,5)

	label=gtk.Label(labels[3])
	kkEntry=gtk.Entry();kkEntry.set_size_request(100,28);kkEntry.set_text(defaultvalue[3])	
	kkbox=gtk.HBox(False,5);vbox1.pack_start(kkbox,False,False,5)
	kkbox.pack_start(label,False,False,5);kkbox.pack_end(kkEntry,False,False,5)

	label=gtk.Label(labels[4])
	betaEntry=gtk.Entry();betaEntry.set_size_request(100,28);betaEntry.set_text(defaultvalue[4])	
	betabox=gtk.HBox(False,5);vbox1.pack_start(betabox,False,False,5)
	betabox.pack_start(label,False,False,5);betabox.pack_end(betaEntry,False,False,5)

	label=gtk.Label(labels[5])
	trefEntry=gtk.Entry();trefEntry.set_size_request(100,28);trefEntry.set_text(defaultvalue[5])	
	trefbox=gtk.HBox(False,5);vbox1.pack_start(trefbox,False,False,5)
	trefbox.pack_start(label,False,False,5);trefbox.pack_end(trefEntry,False,False,5)
	
        vv=glob.glob(self.caseDir+'/temporary/properties')
	if len(vv)!=0:
	    f=open(self.caseDir+'/temporary/properties','r');ff=f.readlines();f.close()
	    visEntry.set_text(ff[0][:-1]);rhoEntry.set_text(ff[1][:-1]);cpEntry.set_text(ff[2][:-1])
	    kkEntry.set_text(ff[3][:-1]);betaEntry.set_text(ff[4][:-1]);trefEntry.set_text(ff[5][:-1])

        buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(150,35)
        cll=gtk.Button(label='Cancel');cll.set_size_request(150,35)
        app.connect('clicked',setProp);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5)  

        window.show_all() 
    #-------------------------------------------------------------------------------------------
    def nonNewton(self):

	GEN=generalClass(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

	def setNewton(widget):
	    f=open(self.caseDir+'/temporary/nonNewtonianProperties','w')
	    eta0=eta0Entry.get_text();etainf=etainfEntry.get_text();lamda=lambdaEntry.get_text()
	    nn=nEntry.get_text();Talpha=TalphaEntry.get_text();alpha=alphaEntry.get_text();T0=T0Entry.get_text()
	    f.write(eta0+'\n');f.write(etainf+'\n');f.write(lamda+'\n');f.write(nn+'\n');f.write(Talpha+'\n');f.write(alpha+'\n');f.write(T0+'\n')
	    f.close()
            window.destroy()

        labels=['eta0[kg/ms]','eta_inf[kg/ms]','lambda[1/s]','n','Talpha[K]','alpha[K]','T0[K]']
	defaultvalue=['100','2','0.05','0.3','273.15','500','0']

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Heat Source Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame();frame1.set_label(' nonNewtonian Properties ');frame1.set_label_align(0.1, 0.5)
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame1,False,False,5)
	
	vbox1=gtk.VBox(False,3);frame1.add(vbox1)

	label=gtk.Label(labels[0]);eta0Entry=gtk.Entry();eta0Entry.set_size_request(100,28);eta0Entry.set_text(defaultvalue[0])	
	eta0box=gtk.HBox(False,5);vbox1.pack_start(eta0box,False,False,5)
	eta0box.pack_start(label,False,False,5);eta0box.pack_end(eta0Entry,False,False,5)

	label=gtk.Label(labels[1]);etainfEntry=gtk.Entry();etainfEntry.set_size_request(100,28);etainfEntry.set_text(defaultvalue[1])	
	etainfbox=gtk.HBox(False,5);vbox1.pack_start(etainfbox,False,False,5)
	etainfbox.pack_start(label,False,False,5);etainfbox.pack_end(etainfEntry,False,False,5)

	label=gtk.Label(labels[2]);lambdaEntry=gtk.Entry();lambdaEntry.set_size_request(100,28);lambdaEntry.set_text(defaultvalue[2])	
	lambdabox=gtk.HBox(False,5);vbox1.pack_start(lambdabox,False,False,5)
	lambdabox.pack_start(label,False,False,5);lambdabox.pack_end(lambdaEntry,False,False,5)

	label=gtk.Label(labels[3]);nEntry=gtk.Entry();nEntry.set_size_request(100,28);nEntry.set_text(defaultvalue[3])	
	nbox=gtk.HBox(False,5);vbox1.pack_start(nbox,False,False,5)
	nbox.pack_start(label,False,False,5);nbox.pack_end(nEntry,False,False,5)

	label=gtk.Label(labels[4]);TalphaEntry=gtk.Entry();TalphaEntry.set_size_request(100,28);TalphaEntry.set_text(defaultvalue[4])	
	Talphabox=gtk.HBox(False,5);vbox1.pack_start(Talphabox,False,False,5)
	Talphabox.pack_start(label,False,False,5);Talphabox.pack_end(TalphaEntry,False,False,5)

	label=gtk.Label(labels[5]);alphaEntry=gtk.Entry();alphaEntry.set_size_request(100,28);alphaEntry.set_text(defaultvalue[5])	
	alphabox=gtk.HBox(False,5);vbox1.pack_start(alphabox,False,False,5)
	alphabox.pack_start(label,False,False,5);alphabox.pack_end(alphaEntry,False,False,5)

	label=gtk.Label(labels[6]);T0Entry=gtk.Entry();T0Entry.set_size_request(100,28);T0Entry.set_text(defaultvalue[6])	
	T0box=gtk.HBox(False,5);vbox1.pack_start(T0box,False,False,5)
	T0box.pack_start(label,False,False,5);T0box.pack_end(T0Entry,False,False,5)
	
        vv=glob.glob(self.caseDir+'/temporary/nonNewtonianProperties')
	if len(vv)!=0:
	    f=open(self.caseDir+'/temporary/nonNewtonianProperties','r');ff=f.readlines();f.close()
	    eta0Entry.set_text(ff[0][:-1]);etainfEntry.set_text(ff[1][:-1]);lambdaEntry.set_text(ff[2][:-1])
	    nEntry.set_text(ff[3][:-1]);TalphaEntry.set_text(ff[4][:-1]);alphaEntry.set_text(ff[5][:-1]);T0Entry.set_text(ff[6][:-1])

        buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(150,35)
        cll=gtk.Button(label='Cancel');cll.set_size_request(150,35)
        app.connect('clicked',setNewton);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5)  

        window.show_all() 

    def main(self):
        gtk.main()

if __name__=='__main__':
    solverwin=covWin()
    solverwin.main()
