#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for define cellZone conditions
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *;from writeFileIncompressibleSub import *

class cellZoneClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir
    #--------------------------------------------------------------------------------------  
    def cellZoneWindow(self):

	def opensubwindow(widget,i):
	    name=zoneEntry[i].get_text()
	    aa=combo[i].child;whattype=aa.get_text()
	    if whattype=='porous':self.porousCellZone(name)
	    elif whattype=='MRF':self.MRFCellZone(name)
	    elif whattype=='momentum-source':self.momSourceCellZone(name)
	    elif whattype=='fixed-U':self.fixedUCellZone(name)
	    elif whattype=='sliding-mesh':self.slidingMeshCellZone(name)
	    elif whattype=='energy-source':self.energySourceCellZone(name)
	    elif whattype=='fixed-T':self.fixedTCellZone(name)

	def closethis(widget):
	    window.destroy()
	
	def applythis(widget):
	    names=[];conditions=[]
	    for i in range(len(cellzonelist)):
		names.append(zoneEntry[i].get_text())
		aa=combo[i].child;conditions.append(aa.get_text())
	    f=open(self.caseDir+'/temporary/cellZoneConditions','w')
	    for i in range(len(names)):f.write(names[i]+','+conditions[i]+'\n')
	    f.close()
	    window.destroy()
	    # in case slidingMesh is changed to another
	    for i in range(len(names)):
		aa=glob.glob(self.caseDir+'/constant/SlidingMeshCellZone_'+names[i])
		if conditions[i]!='sliding-mesh' and len(aa)!=0:
		    os.system('rm '+aa[0]);os.system('rm '+self.caseDir+'/temporary/SlidingMeshCellZone_'+names[i])
		aa=glob.glob(self.caseDir+'/system/MRFCellZone_'+names[i])
		if conditions[i]!='MRF' and len(aa)!=0:
		    os.system('rm '+aa[0]);os.system('rm '+self.caseDir+'/temporary/MRFCellZone_'+names[i])
		aa=glob.glob(self.caseDir+'/system/porousCellZone_'+names[i])
		if conditions[i]!='porous' and len(aa)!=0:
		    os.system('rm '+aa[0]);os.system('rm '+self.caseDir+'/temporary/porousCellZone_'+names[i])
		aa=glob.glob(self.caseDir+'/system/fixedUCellZone_'+names[i])
		if conditions[i]!='fixed-U' and len(aa)!=0:
		    os.system('rm '+aa[0]);os.system('rm '+self.caseDir+'/temporary/fixedUCellZone_'+names[i])
		aa=glob.glob(self.caseDir+'/system/momSourceCellZone_'+names[i])
		if conditions[i]!='momentum-source' and len(aa)!=0:
		    os.system('rm '+aa[0]);os.system('rm '+self.caseDir+'/temporary/momSourceCellZone_'+names[i])


	GEN=generalClass(self.caseDir);cellzonelist=GEN.getCellZones();cellzonelist.sort()
	what=['porous','MRF','momentum-source','fixed-U','sliding-mesh','energy-source','fixed-T','none']

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('cell zone conditions')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame();frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	hbox=[];zoneEntry=[];combo=[];button=[]
	for i in range(len(cellzonelist)):
	    hbox.append(gtk.HBox(False,5))
	    zoneEntry.append(gtk.Entry())
	    zoneEntry[i].set_text(cellzonelist[i]);zoneEntry[i].set_editable(False)
	    zoneEntry[i].set_size_request(140,28)
	    combo.append(gtk.combo_box_entry_new_text());combo[i].set_size_request(180,28)
	    for ii in what:combo[i].append_text(ii)
	    combo[i].set_active(7)
	    button.append(gtk.Button('Set'))
	    button[i].connect('clicked',opensubwindow,i);button[i].set_size_request(100,28)
	    vbox.pack_start(hbox[i],False,False,5)
	    hbox[i].pack_start(zoneEntry[i],False,False,5)
	    hbox[i].pack_start(combo[i],False,False,5)
	    hbox[i].pack_start(button[i],False,False,5)

 	#-------------------------------
	buttonbox=gtk.HBox(False,5)
        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',applythis);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5)  

	aa=glob.glob(self.caseDir+'/temporary/cellZoneConditions')
	if len(aa)!=0:
            f=open(self.caseDir+'/temporary/cellZoneConditions','r');ff=f.readlines();f.close()
	    conditions=[]
	    for ii in ff:
	        aa=ii[:-1].split(',');conditions.append(aa[1])
	    for i in range(len(conditions)):
	        aa=what.index(conditions[i]);combo[i].set_active(aa)

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def porousCellZone(self,cellZone):

	def setPorousCellZone(widget):
	    ax=alphaXEntry.get_text();ay=alphaYEntry.get_text();az=alphaZEntry.get_text()
	    bx=betaXEntry.get_text();by=betaYEntry.get_text();bz=betaZEntry.get_text()
	    e1x=e1XEntry.get_text();e1y=e1YEntry.get_text();e1z=e1ZEntry.get_text()
	    e2x=e2XEntry.get_text();e2y=e2YEntry.get_text();e2z=e2ZEntry.get_text()	

	    aa=cCombo.child;selectedZone=aa.get_text()
	    print 'selected zone for porous media is ',selectedZone

	    f=open(self.caseDir+'/system/porousCellZone_'+selectedZone,'w')
	    f.write('porous_'+selectedZone+'\n')
	    f.write('{\n')
	    f.write('    type            explicitPorositySource;\n')
	    f.write('    active          true;\n')
	    f.write('    selectionMode   cellZone;\n')
	    f.write('    cellZone        '+selectedZone+';\n')
	    f.write('\n')
	    f.write('    explicitPorositySourceCoeffs\n')
	    f.write('    {\n')
	    f.write('        type            DarcyForchheimer;\n')
	    f.write('        active          yes;\n')
	    f.write('\n')
	    f.write('        DarcyForchheimerCoeffs\n')
	    f.write('        {\n')
	    f.write('            d       d [0 -2 0 0 0 0 0] ('+ax+' '+ay+' '+az+');\n')
	    f.write('            f       f [0 -1 0 0 0 0 0] ('+bx+' '+by+' '+bz+');\n')
	    f.write('\n')
	    f.write('            coordinateSystem\n')
	    f.write('            {\n')
	    f.write('                type    cartesian;\n')
	    f.write('                origin  (0 0 0);\n')
	    f.write('                coordinateRotation\n')
	    f.write('                {\n')
	    f.write('                    type    axesRotation;\n')
	    f.write('                    e1  ('+e1x+' '+e1y+' '+e1z+');\n')
	    f.write('                    e2  ('+e2x+' '+e2y+' '+e2z+');\n')
	    f.write('                }\n')
	    f.write('            }\n')
	    f.write('        }\n')
	    f.write('    }\n')
	    f.write('}\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/porousCellZone_'+selectedZone,'w')
	    f.write(selectedZone+'\n')
	    f.write(ax+' '+ay+' '+az+'\n')
	    f.write(bx+' '+by+' '+bz+'\n')
	    f.write(e1x+' '+e1y+' '+e1z+'\n')
	    f.write(e2x+' '+e2y+' '+e2z+'\n')
	    f.close()

	def delete(widget):
	    aa=cCombo.child;selectedZone=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/porousCellZone_'+selectedZone)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/porousCellZone_'+selectedZone)
		os.system('rm '+self.caseDir+'/system/porousCellZone_'+selectedZone)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/porousCellZone_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		als=ff[1][:-1].split(' ')
		bes=ff[2][:-1].split(' ')
		e1s=ff[3][:-1].split(' ')
		e2s=ff[4][:-1].split(' ')
		check.set_active(1)
		alphaXEntry.set_text(als[0]);alphaYEntry.set_text(als[1]);alphaZEntry.set_text(als[2])
		betaXEntry.set_text(bes[0]);betaYEntry.set_text(bes[1]);betaZEntry.set_text(bes[2])
		e1XEntry.set_text(e1s[0]);e1YEntry.set_text(e1s[1]);e1ZEntry.set_text(e1s[2])
		e2XEntry.set_text(e2s[0]);e2YEntry.set_text(e2s[1]);e2ZEntry.set_text(e2s[2])
	    else:check.set_active(0)

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('porous cellZone')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame()
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	check=gtk.CheckButton('porous cellZone')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('Porous cellZone')

	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	cCombo.append_text(cellZone)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)
        
	label=gtk.Label('Darcy coeff. d [1/m2]')
	alphaXEntry=gtk.Entry();alphaYEntry=gtk.Entry();alphaZEntry=gtk.Entry()
	alphaXEntry.set_size_request(60,28);alphaYEntry.set_size_request(60,28);alphaZEntry.set_size_request(60,28)
	alphaXEntry.set_text('500');alphaYEntry.set_text('1e10');alphaZEntry.set_text('1e10')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5)
	hbox3.pack_end(alphaZEntry,False,False,5);hbox3.pack_end(alphaYEntry,False,False,5);hbox3.pack_end(alphaXEntry,False,False,5)

	label=gtk.Label('Forchheimer coeff. f [1/m]')
	betaXEntry=gtk.Entry();betaYEntry=gtk.Entry();betaZEntry=gtk.Entry()
	betaXEntry.set_size_request(60,28);betaYEntry.set_size_request(60,28);betaZEntry.set_size_request(60,28)
	betaXEntry.set_text('0');betaYEntry.set_text('0');betaZEntry.set_text('0')
	hbox4=gtk.HBox(False,5);vbox.pack_start(hbox4,False,False,5)
	hbox4.pack_start(label,False,False,5)
	hbox4.pack_end(betaZEntry,False,False,5);hbox4.pack_end(betaYEntry,False,False,5);hbox4.pack_end(betaXEntry,False,False,5)

	label=gtk.Label('axes rotation e1')
	e1XEntry=gtk.Entry();e1YEntry=gtk.Entry();e1ZEntry=gtk.Entry()
	e1XEntry.set_size_request(60,28);e1YEntry.set_size_request(60,28);e1ZEntry.set_size_request(60,28)
	e1XEntry.set_text('1');e1YEntry.set_text('0');e1ZEntry.set_text('0')
	hbox5=gtk.HBox(False,5);vbox.pack_start(hbox5,False,False,5)
	hbox5.pack_start(label,False,False,5)
	hbox5.pack_end(e1ZEntry,False,False,5);hbox5.pack_end(e1YEntry,False,False,5);hbox5.pack_end(e1XEntry,False,False,5)

	label=gtk.Label('axes rotation e2')
	e2XEntry=gtk.Entry();e2YEntry=gtk.Entry();e2ZEntry=gtk.Entry()
	e2XEntry.set_size_request(60,28);e2YEntry.set_size_request(60,28);e2ZEntry.set_size_request(60,28)
	e2XEntry.set_text('0');e2YEntry.set_text('1');e2ZEntry.set_text('0')
	hbox6=gtk.HBox(False,5);vbox.pack_start(hbox6,False,False,5)
	hbox6.pack_start(label,False,False,5)
	hbox6.pack_end(e2ZEntry,False,False,5);hbox6.pack_end(e2YEntry,False,False,5);hbox6.pack_end(e2XEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5)

        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setPorousCellZone);cll.connect('clicked',closethis)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5)  

	aa=glob.glob(self.caseDir+'/temporary/porousCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    als=ff[1][:-1].split(' ')
	    bes=ff[2][:-1].split(' ')
	    e1s=ff[3][:-1].split(' ')
	    e2s=ff[4][:-1].split(' ')
	    check.set_active(1)
	    alphaXEntry.set_text(als[0]);alphaYEntry.set_text(als[1]);alphaZEntry.set_text(als[2])
	    betaXEntry.set_text(bes[0]);betaYEntry.set_text(bes[1]);betaZEntry.set_text(bes[2])
	    e1XEntry.set_text(e1s[0]);e1YEntry.set_text(e1s[1]);e1ZEntry.set_text(e1s[2])
	    e2XEntry.set_text(e2s[0]);e2YEntry.set_text(e2s[1]);e2ZEntry.set_text(e2s[2])

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def fixedUCellZone(self,cellZone):

	def setFixedU(widget):
	    ux=uxEntry.get_text();uy=uyEntry.get_text();uz=uzEntry.get_text()
	    aa=cCombo.child;selectedZone=aa.get_text()

	    print 'selected zone for fixed U is ',selectedZone

	    f=open(self.caseDir+'/system/fixedUCellZone_'+selectedZone,'w')
	    f.write('fixedU_'+selectedZone+'\n')
	    f.write('{\n')	
	    f.write('    type            vectorExplicitSetValue;\n')
	    f.write('    active          yes;\n')
	    f.write('    selectionMode   cellZone;\n')
	    f.write('    cellZone        '+selectedZone+';\n')
	    f.write('\n')
	    f.write('    vectorExplicitSetValueCoeffs\n')
	    f.write('    {\n')
	    f.write('        injectionRate\n')
	    f.write('        {;\n')
	    f.write('            U    ('+ux+' '+uy+' '+uz+');\n')
	    f.write('        }\n')
	    f.write('    }\n')
	    f.write('}\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/fixedUCellZone_'+selectedZone,'w')
	    f.write(selectedZone+'\n')
	    f.write(ux+' '+uy+' '+uz+'\n')
	    f.close()

	def delete(widget):
	    aa=cCombo.child;selectedZone=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/fixedUCellZone_'+selectedZone)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/fixedUCellZone_'+selectedZone)
		os.system('rm '+self.caseDir+'/system/fixedUCellZone_'+selectedZone)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/fixedUCellZone_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		us=ff[1][:-1].split(' ')
		check.set_active(1)
		uxEntry.set_text(us[0]);uyEntry.set_text(us[1]);uzEntry.set_text(us[2])
	    else:check.set_active(0)

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('fixed velocity')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame()
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	check=gtk.CheckButton('fixed velocity cellZone')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('CellZone for fixed velocity')
	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	cCombo.append_text(cellZone)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)
        
	label=gtk.Label('U vector')
	uxEntry=gtk.Entry();uyEntry=gtk.Entry();uzEntry=gtk.Entry()
	uxEntry.set_size_request(60,28);uyEntry.set_size_request(60,28);uzEntry.set_size_request(60,28)
	uxEntry.set_text('1');uyEntry.set_text('0');uzEntry.set_text('0')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5)
	hbox3.pack_end(uzEntry,False,False,5);hbox3.pack_end(uyEntry,False,False,5);hbox3.pack_end(uxEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5)

        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setFixedU);cll.connect('clicked',closethis)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5)  

	aa=glob.glob(self.caseDir+'/temporary/fixedUCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    us=ff[1][:-1].split(' ')
	    check.set_active(1)
	    uxEntry.set_text(us[0]);uyEntry.set_text(us[1]);uzEntry.set_text(us[2])

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def momSourceCellZone(self,cellZone):

	def setMomSource(widget):
	    ux=uxEntry.get_text();uy=uyEntry.get_text();uz=uzEntry.get_text()
	    aa=cCombo.child;selectedZone=aa.get_text()

	    print 'selected zone for momentum source is ',selectedZone

	    f=open(self.caseDir+'/system/momSourceCellZone_'+selectedZone,'w')
	    f.write('fixedU_'+selectedZone+'\n')
	    f.write('{\n')	
	    f.write('    type            pressureGradientExplicitSource;\n')
	    f.write('    active          yes;\n')
	    f.write('    selectionMode   cellZone;\n')
	    f.write('    cellZone        '+selectedZone+';\n')
	    f.write('\n')
	    f.write('    pressureGradientExplicitSourceCoeffs\n')
	    f.write('    {\n')
	    f.write('        fieldNames ( U );\n')
	    f.write('        Ubar    ('+ux+' '+uy+' '+uz+');\n')
	    f.write('    }\n')
	    f.write('}\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/momSourceCellZone_'+selectedZone,'w')
	    f.write(selectedZone+'\n')
	    f.write(ux+' '+uy+' '+uz+'\n')
	    f.close()

	def delete(widget):
	    aa=cCombo.child;selectedZone=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/momSourceCellZone_'+selectedZone)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/momSourceCellZone_'+selectedZone)
		os.system('rm '+self.caseDir+'/system/momSourceCellZone_'+selectedZone)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/momSourceCellZone_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		us=ff[1][:-1].split(' ')
		check.set_active(1)
		uxEntry.set_text(us[0]);uyEntry.set_text(us[1]);uzEntry.set_text(us[2])
	    else:check.set_active(0)

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('momentum Source')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame()
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	check=gtk.CheckButton('momentum source cellZone')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('CellZone for momentum source')
	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	cCombo.append_text(cellZone)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)
        
	label=gtk.Label('U vector')
	uxEntry=gtk.Entry();uyEntry=gtk.Entry();uzEntry=gtk.Entry()
	uxEntry.set_size_request(60,28);uyEntry.set_size_request(60,28);uzEntry.set_size_request(60,28)
	uxEntry.set_text('1');uyEntry.set_text('0');uzEntry.set_text('0')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5)
	hbox3.pack_end(uzEntry,False,False,5);hbox3.pack_end(uyEntry,False,False,5);hbox3.pack_end(uxEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5)

        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setMomSource);cll.connect('clicked',closethis)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5)  

	aa=glob.glob(self.caseDir+'/temporary/momSourceCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    us=ff[1][:-1].split(' ')
	    check.set_active(1)
	    uxEntry.set_text(us[0]);uyEntry.set_text(us[1]);uzEntry.set_text(us[2])

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def fixedTCellZone(self,cellZone):

	def setFixedT(widget):
	    TT=TEntry.get_text()
	    aa=cCombo.child;selectedZone=aa.get_text()

	    print 'selected zone for fixed T is ',selectedZone

	    f=open(self.caseDir+'/system/fixedTCellZone_'+selectedZone,'w')
	    f.write('fixedT_'+selectedZone+'\n')
	    f.write('{\n')
	    f.write('    type            fixedTemperatureConstraint;\n')
	    f.write('    active          yes;\n')
	    f.write('    selectionMode   cellZone;\n')
	    f.write('    cellZone        '+selectedZone+';\n')
	    f.write('\n')
	    f.write('    fixedTemperatureConstraintCoeffs\n')
	    f.write('    {\n')
	    f.write('        mode           uniform;\n')
	    f.write('        temperature    '+TT+';\n')
	    f.write('    }\n')
	    f.write('}\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/fixedTCellZone_'+selectedZone,'w')
	    f.write(selectedZone+'\n')
	    f.write(TT+'\n')
	    f.close()

	def delete(widget):
	    aa=cCombo.child;selectedZone=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/fixedTCellZone_'+selectedZone)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/fixedTCellZone_'+selectedZone)
		os.system('rm '+self.caseDir+'/system/fixedTCellZone_'+selectedZone)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/fixedTCellZone_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		tt=ff[1][:-1]
		check.set_active(1)
		TEntry.set_text(tt)
	    else:check.set_active(0)

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('fixed temperature')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame()
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	check=gtk.CheckButton('fixed temperature cellZone')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('Select cellZones for fixed temperature')
	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	cCombo.append_text(cellZone)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)
       
	label=gtk.Label('Fixed temperature')
	TEntry=gtk.Entry();TEntry.set_size_request(120,28);TEntry.set_text('300')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5)
	hbox3.pack_end(TEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5)

        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(100,30)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        cll=gtk.Button(label='Close');cll.set_size_request(100,30)
	app.connect('clicked',setFixedT);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5)  

	aa=glob.glob(self.caseDir+'/temporary/fixedTCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    tt=ff[1][:-1]
	    check.set_active(1)
	    TEntry.set_text(tt)

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def energySourceCellZone(self,cellZone):

	def setEnergySource(widget):
	    aa=eCombo.child;emethod=aa.get_text()
	    TT=TEntry.get_text()
	    aa=cCombo.child;selectedZone=aa.get_text()

	    print 'selected zone for energy source is ',selectedZone

	    f=open(self.caseDir+'/system/energySourceCellZone_'+selectedZone,'w')
	    f.write('energySource_'+selectedZone+'\n')
	    f.write('{\n')
	    f.write('    type            scalarSemiImplicitSource;\n')
	    f.write('    active          yes;\n')
	    f.write('    selectionMode   cellZone;\n')
	    f.write('    cellZone        '+selectedZone+';\n')
	    f.write('\n')
	    f.write('    scalarSemiImplicitSourceCoeffs\n')
	    f.write('    {\n')
	    f.write('        volumeMode     '+emethod+';\n')
	    f.write('        injectionRateSuSp\n')
	    f.write('        {\n')
	    f.write('            h    ('+TT+' 0);\n')
	    f.write('        }\n')
	    f.write('    }\n')
	    f.write('}\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/energySourceCellZone_'+selectedZone,'w')
	    f.write(selectedZone+'\n')
	    f.write(emethod+' '+TT+'\n')
	    f.close()

	def delete(widget):
	    aa=cCombo.child;selectedZone=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/energySourceCellZone_'+selectedZone)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/energySourceCellZone_'+selectedZone)
		os.system('rm '+self.caseDir+'/system/energySourceCellZone_'+selectedZone)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/energySourceCellZone_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		us=ff[1][:-1].split(' ')
		check.set_active(1)
		if us[0]=='specific':eCombo.set_active(0)
		else:eCombo.set_active(1)
		TEntry.set_text(us[1])
	    else:check.set_active(0)

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('energy source')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame()
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	check=gtk.CheckButton('energy source cellZone')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('Select cellZones for energy source')
	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	cCombo.append_text(cellZone)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)

	label=gtk.Label('source input method')
	eCombo=gtk.combo_box_entry_new_text();eCombo.set_size_request(120,28)
	eCombo.append_text('specific');eCombo.append_text('absolute')
	eCombo.set_active(0)
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5)
	hbox3.pack_end(eCombo,False,False,5)

	label=gtk.Label('Energy source')
	TEntry=gtk.Entry()
	TEntry.set_size_request(120,28)
	TEntry.set_text('300')
	hbox4=gtk.HBox(False,5);vbox.pack_start(hbox4,False,False,5)
	hbox4.pack_start(label,False,False,5)
	hbox4.pack_end(TEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5)

        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setEnergySource);cll.connect('clicked',closethis)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5) 

	aa=glob.glob(self.caseDir+'/temporary/energySourceCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    tt=ff[1][:-1].split(' ')
	    check.set_active(1)
	    if tt[0]=='specific':eCombo.set_active(0)
	    else:eCombo.set_active(1)
	    TEntry.set_text(tt[1])	

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def MRFCellZone(self,cellZone):

	GEN=generalClass(self.caseDir)

	aa=glob.glob(self.caseDir+'/temporary/MRFCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0],'r');ff=f.readlines();f.close()
	    ss=ff[2][:-2];self.nonRotPatch=ss.split(' ')
	else:self.nonRotPatch=[]

	def setMRFSource(widget):
	    aa=eCombo.child;rotAxis=aa.get_text()
	    if rotAxis=='x':axis='(1 0 0)'
	    elif rotAxis=='y':axis='(0 1 0)'
	    elif rotAxis=='z':axis='(0 0 1)'
	    elif rotAxis=='-x':axis='(-1 0 0)'
	    elif rotAxis=='-y':axis='(0 -1 0)'
	    elif rotAxis=='-z':axis='(0 0 -1)'
	    rpm=TEntry.get_text()
	    omega=float(rpm)*2*3.141592/60
	    orix=orixEntry.get_text();oriy=oriyEntry.get_text();oriz=orizEntry.get_text()
	    aa=cCombo.child;selectedZone=aa.get_text()

	    print 'selected zone for MRF is ',selectedZone

	    f=open(self.caseDir+'/system/MRFCellZone_'+selectedZone,'w')
	    f.write('MRFCellZone_'+selectedZone+'\n')
	    f.write('{\n')
	    f.write('    type            MRFSource;\n')
	    f.write('    active          yes;\n')
	    f.write('    selectionMode   cellZone;\n')
	    f.write('    cellZone        '+selectedZone+';\n')
	    f.write('\n')
	    f.write('    MRFSourceCoeffs\n')
	    f.write('    {\n')
	    f.write('        nonRotatingPatches    (')
	    for jj in self.nonRotPatch:f.write(' '+jj+' ')
	    f.write(' );\n')
	    f.write('        origin     ('+orix+' '+oriy+' '+oriz+');\n')
	    f.write('        axis       '+axis+';\n')
	    f.write('        omega      '+str(omega)+';\n')
	    f.write('    }\n')
	    f.write('}\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/MRFCellZone_'+selectedZone,'w')
	    f.write(selectedZone+'\n')
	    f.write(orix+' '+oriy+' '+oriz+' '+rotAxis+' '+rpm+'\n')
	    for ii in self.nonRotPatch:f.write(ii+' ')
	    f.write('\n')
	    f.close()
            window.destroy()

	def delete(widget):
	    aa=cCombo.child;selectedZone=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/MRFCellZone_'+selectedZone)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/MRFCellZone_'+selectedZone)
		os.system('rm '+self.caseDir+'/system/MRFCellZone_'+selectedZone)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/MRFCellZone_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		us=ff[1][:-1].split(' ')
		check.set_active(1)
		orixEntry.set_text(us[0]);oriyEntry.set_text(us[1]);orizEntry.set_text(us[2])
		if us[3]=='x':eCombo.set_active(0)
		elif us[3]=='y':eCombo.set_active(1)
		elif us[3]=='z':eCombo.set_active(2)
		elif us[3]=='-x':eCombo.set_active(3)
		elif us[3]=='-y':eCombo.set_active(4)
		elif us[3]=='-z':eCombo.set_active(5)
		TEntry.set_text(us[4])
	    else:check.set_active(0)

	def nonRot(widget):
            def closethiswin(widget,data=None):
                windo.destroy()

	    def makenonrot(widget):
		self.nonRotPatch=[]
	        for i in range(len(bcname)):
		    aa=setName[i].get_active()		   
		    if aa==True:self.nonRotPatch.append(bcname[i])		
	        print 'selected nonRotatingPatches are ',self.nonRotPatch
		windo.destroy()
	
	    bcname=GEN.getBCName();bcname.sort()

            windo=gtk.Window(gtk.WINDOW_TOPLEVEL);windo.set_title('Select Interface')
            windo.set_border_width(5);windo.set_position(gtk.WIN_POS_CENTER)
            mainbox1=gtk.VBox(False,5);windo.add(mainbox1)

            swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
            mainbox1.pack_start(swin,True,True,5)
            itembox=gtk.VBox(False,0)
            swin.add_with_viewport(itembox)
            scheight=len(bcname)*38
            if scheight > 750:scheight=750        
            swin.set_size_request(300,scheight)

            setName=[]
            for i in range(len(bcname)):
                hbox1=gtk.HBox(False,5);itembox.pack_start(hbox1,False,False,2)                
                setName.append(gtk.CheckButton(bcname[i]));setName[i].set_size_request(180,28)
                hbox1.pack_start(setName[i],False,False,0)

            hbox2=gtk.HBox(False,5);mainbox1.pack_start(hbox2,False,False,5)
            appl=gtk.Button(label='Apply');appl.set_size_request(100,28)
            clls=gtk.Button(label='Close');clls.set_size_request(100,28)
            appl.connect('clicked',makenonrot);clls.connect('clicked',closethiswin)
            hbox2.pack_end(clls,False,False,5);hbox2.pack_end(appl,False,False,5)	 

	    if len(self.nonRotPatch)!=0:
		for i in range(len(setName)):
		    if self.nonRotPatch.count(bcname[i])!=0:setName[i].set_active(1)		  

            windo.show_all()
	#-------------------------------------------------------------------------------
        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('MRF Zone')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame()
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	check=gtk.CheckButton('MRF cellZone')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('MRF cellZone')
	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	cCombo.append_text(cellZone)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)

	label=gtk.Label('Rot. Origin')
	orixEntry=gtk.Entry();orixEntry.set_size_request(60,28);orixEntry.set_text('0')
	oriyEntry=gtk.Entry();oriyEntry.set_size_request(60,28);oriyEntry.set_text('0')
	orizEntry=gtk.Entry();orizEntry.set_size_request(60,28);orizEntry.set_text('0')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5);hbox3.pack_end(orizEntry,False,False,5)
	hbox3.pack_end(oriyEntry,False,False,5);hbox3.pack_end(orixEntry,False,False,5)

	label=gtk.Label('Rot. axis')
	eCombo=gtk.combo_box_entry_new_text();eCombo.set_size_request(60,28)
	axisList=['x','y','z','-x','-y','-z']
	for ii in axisList:eCombo.append_text(ii)
	eCombo.set_active(2)
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5)
	hbox3.pack_end(eCombo,False,False,5)

	label=gtk.Label('RPM')
	TEntry=gtk.Entry()
	TEntry.set_size_request(120,28)
	TEntry.set_text('100')
	hbox4=gtk.HBox(False,5);vbox.pack_start(hbox4,False,False,5)
	hbox4.pack_start(label,False,False,5);hbox4.pack_end(TEntry,False,False,5)

	nonRotB=gtk.Button('  Select nonRotatingPatches  ');nonRotB.connect('clicked',nonRot)
	hbox41=gtk.HBox(False,5);vbox.pack_start(hbox41,False,False,5)
	hbox41.pack_end(nonRotB,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5)

        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setMRFSource);cll.connect('clicked',closethis)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5) 

	aa=glob.glob(self.caseDir+'/temporary/MRFCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    us=ff[1][:-1].split(' ')
	    check.set_active(1)
	    orixEntry.set_text(us[0]);oriyEntry.set_text(us[1]);orizEntry.set_text(us[2])
	    if us[3]=='x':eCombo.set_active(0)
	    elif us[3]=='y':eCombo.set_active(1)
	    elif us[3]=='z':eCombo.set_active(2)
	    elif us[3]=='-x':eCombo.set_active(3)
	    elif us[3]=='-y':eCombo.set_active(4)
	    elif us[3]=='-z':eCombo.set_active(5)
	    TEntry.set_text(us[4])

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def slidingMeshCellZone(self,cellZone):

	def setSMSource(widget):
	    aa=eCombo.child;rotAxis=aa.get_text()
	    if rotAxis=='x':axis='(1 0 0)'
	    elif rotAxis=='y':axis='(0 1 0)'
	    elif rotAxis=='z':axis='(0 0 1)'
	    elif rotAxis=='-x':axis='(-1 0 0)'
	    elif rotAxis=='-y':axis='(0 -1 0)'
	    elif rotAxis=='-z':axis='(0 0 -1)'
	    rpm=TEntry.get_text()
	    omega=float(rpm)*2*3.141592/60
	    orix=orixEntry.get_text();oriy=oriyEntry.get_text();oriz=orizEntry.get_text()
	    aa=cCombo.child;selectedZone=aa.get_text()

	    print 'selected zone for SlidingMesh is ',selectedZone

	    f=open(self.caseDir+'/constant/SlidingMeshCellZone_'+selectedZone,'w')
	    f.write('    '+selectedZone+'\n')
	    f.write('    {\n')
	    f.write('        cellZone	'+selectedZone+';\n')
	    f.write('        solidBodyMotionFunction  rotatingMotion;\n')
	    f.write('        rotatingMotionCoeffs\n')
	    f.write('        {\n')
	    f.write('            origin        ('+orix+' '+oriy+' '+oriz+');\n')
	    f.write('            axis          '+axis+';\n')
	    f.write('            omega         '+str(omega)+';\n')
	    f.write('        }\n')
	    f.write('    }\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/SlidingMeshCellZone_'+selectedZone,'w')
	    f.write(selectedZone+'\n')
	    f.write(orix+' '+oriy+' '+oriz+' '+rotAxis+' '+rpm+'\n')
	    f.close()
            window.destroy()

	def delete(widget):
	    aa=cCombo.child;selectedZone=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/SlidingMeshCellZone_'+selectedZone)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/SlidingMeshCellZone_'+selectedZone)
		os.system('rm '+self.caseDir+'/system/SlidingMeshCellZone_'+selectedZone)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/SlidingMeshCellZone_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		us=ff[1][:-1].split(' ')
		check.set_active(1)
		orixEntry.set_text(us[0]);oriyEntry.set_text(us[1]);orizEntry.set_text(us[2])
		if us[3]=='x':eCombo.set_active(0)
		elif us[3]=='y':eCombo.set_active(1)
		elif us[3]=='z':eCombo.set_active(2)
		elif us[3]=='-x':eCombo.set_active(3)
		elif us[3]=='-y':eCombo.set_active(4)
		elif us[3]=='-z':eCombo.set_active(5)
		TEntry.set_text(us[4])
	    else:check.set_active(0)
	#-------------------------------------------------------------------------------
        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('SlidingMesh Zone')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame();frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)
	check=gtk.CheckButton('Rotating cellZone')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5);hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('Rotating cellZone')
	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	cCombo.append_text(cellZone)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)

	label=gtk.Label('Rot. Origin')
	orixEntry=gtk.Entry();orixEntry.set_size_request(60,28);orixEntry.set_text('0')
	oriyEntry=gtk.Entry();oriyEntry.set_size_request(60,28);oriyEntry.set_text('0')
	orizEntry=gtk.Entry();orizEntry.set_size_request(60,28);orizEntry.set_text('0')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5);hbox3.pack_end(orizEntry,False,False,5)
	hbox3.pack_end(oriyEntry,False,False,5);hbox3.pack_end(orixEntry,False,False,5)

	label=gtk.Label('Rot. axis')
	eCombo=gtk.combo_box_entry_new_text();eCombo.set_size_request(60,28)
	axisList=['x','y','z','-x','-y','-z']
	for ii in axisList:eCombo.append_text(ii)
	eCombo.set_active(2)
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5);hbox3.pack_end(eCombo,False,False,5)

	label=gtk.Label('RPM')
	TEntry=gtk.Entry();TEntry.set_size_request(120,28);TEntry.set_text('100')
	hbox4=gtk.HBox(False,5);vbox.pack_start(hbox4,False,False,5)
	hbox4.pack_start(label,False,False,5);hbox4.pack_end(TEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30);cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setSMSource);cll.connect('clicked',closethis)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5) 

	aa=glob.glob(self.caseDir+'/temporary/SlidingMeshCellZone_'+cellZone)
	if len(aa)!=0:
	    f=open(aa[0]);ff=f.readlines();f.close()
	    us=ff[1][:-1].split(' ')
	    check.set_active(1)
	    orixEntry.set_text(us[0]);oriyEntry.set_text(us[1]);orizEntry.set_text(us[2])
	    if us[3]=='x':eCombo.set_active(0)
	    elif us[3]=='y':eCombo.set_active(1)
	    elif us[3]=='z':eCombo.set_active(2)
	    elif us[3]=='-x':eCombo.set_active(3)
	    elif us[3]=='-y':eCombo.set_active(4)
	    elif us[3]=='-z':eCombo.set_active(5)
	    TEntry.set_text(us[4])

        window.show_all() 
    #--------------------------------------------------------------------------------------  
    def porousJumpPatch(self):

	GEN=generalClass(self.caseDir)

	def setPorousJump(widget):
	    ii=IEntry.get_text()
	    ll=LEntry.get_text()
	    dd=DEntry.get_text()
	    aa=cCombo.child;selectedPatch=aa.get_text()

	    print 'selected patch for porous jump is ',selectedPatch

	    f=open(self.caseDir+'/system/porousJumpPatch_'+selectedPatch,'w')
	    f.write('dictionaryReplacement\n')
	    f.write('{\n')
	    f.write('    boundary\n')
	    f.write('    {\n')
	    f.write('        '+selectedPatch+'\n')
	    f.write('        {\n')
	    f.write('            type              porousBafflePressure;\n')
	    f.write('            patchType         cyclic;\n')
	    f.write('            value             $internalField;\n')
	    f.write('            D                 '+dd+';\n')
	    f.write('            I                 '+ii+';\n')
	    f.write('            length            '+ll+';\n')
	    f.write('        }\n')
	    f.write('        '+selectedPatch+'_slave\n')
	    f.write('        {\n')
	    f.write('            type              porousBafflePressure;\n')
	    f.write('            patchType         cyclic;\n')
	    f.write('            value             $internalField;\n')
	    f.write('            D                 '+dd+';\n')
	    f.write('            I                 '+ii+';\n')
	    f.write('            length            '+ll+';\n')
	    f.write('        }\n')
	    f.write('    }\n')
	    f.write('}\n')
	    f.close()

	    f=open(self.caseDir+'/temporary/porousJumpPatch_'+selectedPatch,'w')
	    f.write(selectedPatch+'\n')
	    f.write(dd+' '+ii+' '+ll+'\n')
	    f.close()

	def delete(widget):
	    aa=cCombo.child;selectedPatch=aa.get_text()
	    bb=glob.glob(self.caseDir+'/temporary/porousJumpPatch_'+selectedPatch)
	    if len(bb)!=0:
		os.system('rm '+self.caseDir+'/temporary/porousJumpPatch_'+selectedPatch)
		os.system('rm '+self.caseDir+'/system/porousJumpPatch_'+selectedPatch)
		check.set_active(0)

        def closethis(widget,data=None):
            window.destroy()

	def chcombo(widget):
	    aa=cCombo.child;czone=aa.get_text()
	    files=glob.glob(self.caseDir+'/temporary/porousJumpPatch_'+czone)
	    if len(files)!=0:
		f=open(files[0]);ff=f.readlines();f.close()
		us=ff[1][:-1].split(' ')
		check.set_active(1)
		DEntry.set_text(us[0]);IEntry.set_text(us[1]);LEntry.set_text(us[2])
	    else:check.set_active(0)

	bcname=GEN.getBCName()
	bctype=GEN.getBCType()

	cypatchesAll=[]
	cypatches=cypatchesAll
	for i in range(len(bcname)):
	    if bctype[i]=='cyclic':cypatchesAll.append(bcname[i])
	for ii in cypatchesAll:
	    if ii[-5:]=='slave':cypatches.remove(ii)

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('porous jump')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame()#;frame1.set_label('');frame1.set_label_align(0.1, 0.5)
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	check=gtk.CheckButton('porous jump patch')
	hbox0=gtk.HBox(False,5);vbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(check,False,False,5)	
	
	label=gtk.Label('Select patch for porous jump')#;label.set_size_request(150,28)
	cCombo=gtk.combo_box_entry_new_text();cCombo.set_size_request(120,28)
	for ii in cypatches:cCombo.append_text(ii)
	cCombo.set_active(0);cCombo.connect('changed',chcombo)
	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox1.pack_end(cCombo,False,False,5)
        
	label=gtk.Label('Inertial coefficient, I')
	IEntry=gtk.Entry();IEntry.set_size_request(120,28);IEntry.set_text('0')
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5)
	hbox3.pack_end(IEntry,False,False,5)

	label=gtk.Label('porous media length')
	LEntry=gtk.Entry();LEntry.set_size_request(120,28);LEntry.set_text('0.01')
	hbox4=gtk.HBox(False,5);vbox.pack_start(hbox4,False,False,5)
	hbox4.pack_start(label,False,False,5)
	hbox4.pack_end(LEntry,False,False,5)

	label=gtk.Label('Darcy coefficient, D')
	DEntry=gtk.Entry();DEntry.set_size_request(120,28);DEntry.set_text('100')
	hbox5=gtk.HBox(False,5);vbox.pack_start(hbox5,False,False,5)
	hbox5.pack_start(label,False,False,5)
	hbox5.pack_end(DEntry,False,False,5)
 	#-------------------------------
	buttonbox=gtk.HBox(False,5)

        mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
	app.connect('clicked',setPorousJump);cll.connect('clicked',closethis)
        dele=gtk.Button(label='Delete');dele.set_size_request(100,30);dele.connect('clicked',delete)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(dele,False,False,5);buttonbox.pack_end(app,False,False,5) 

	if len(cypatches)!=0:
	    aa=glob.glob(self.caseDir+'/temporary/porousJumpPatch_'+cypatches[0])
	    if len(aa)!=0:
	        f=open(aa[0]);ff=f.readlines();f.close()
	        us=ff[1][:-1].split(' ')
	        check.set_active(1)
	        DEntry.set_text(us[0]);IEntry.set_text(us[1]);LEntry.set_text(us[2])

        window.show_all() 
    #--------------------------------------------------------------------------------------  


