#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for various subfunctions
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math;import pygtk;pygtk.require('2.0');import gtk;import glob

from writeFileIncompressibleSub import *

class generalClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir
    
    #--------------------------------------------------------------------------------------  
    def newcase(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_CREATE_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            self.caseDir=dialog.get_filename()
            print dialog.get_filename(), 'selected'
        elif response == gtk.RESPONSE_CANCEL:
	    self.caseDir='None'
            print 'Closed, no files selected'
        dialog.destroy()
	return self.caseDir
    #-------------------------------------------------------------------------------------------------      
    def importMeshutil(self,util,display): 
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                        gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        filter = gtk.FileFilter();filter.set_name("All files");filter.add_pattern("*")
        dialog.add_filter(filter)
        filter = gtk.FileFilter();filter.set_name("Meshes")
        filter.add_mime_type("mesh/msh");filter.add_mime_type("mesh/cas");filter.add_mime_type("mesh/ccm")
        filter.add_pattern("*.msh");filter.add_pattern("*.cas");filter.add_pattern("*.ccm")
        dialog.add_filter(filter)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            filename=dialog.get_filename()
            print dialog.get_filename(), 'selected'
        elif response == gtk.RESPONSE_CANCEL:
	    filename='None'
            print 'Closed, no files selected'
        dialog.destroy()

	if filename!='None':

	    self.resetCase()

	    aa=os.listdir(self.caseDir+'/0/')
	    os.system('pyFoamClearCase.py '+self.caseDir)
  
            if util=='fluent3DMeshToFoam':os.system('fluent3DMeshToFoam -case '+self.caseDir+' '+filename)
            elif util=='fluentMeshToFoam':os.system('fluentMeshToFoam -writeSets -writeZones -case '+self.caseDir+' '+filename)
            elif util=='ccm26ToFoam':os.system('ccm26ToFoam -case '+self.caseDir+' '+filename)
            else:
                md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"Error! Mesh Converting Failed. Wrong type...")
                md.run();md.destroy()
	    if display==True:os.system('paraFoam -case '+self.caseDir+'&')
       
            az=self.caseDir+'/constant/polyMesh/boundary'
            filea=open(az,'r');lines=filea.readlines();filea.close();num=int(lines[17])
            line1=[];bcname=[]    
            for i in range(16,len(lines)):
                a=(lines[i]).strip()
                if a=='{':line1.append(i)
            for i in line1:
                bb=(lines[i-1]).strip();b=bb[0]
                if b=='0' or b=='1' or b=='2' or b=='3' or b=='4' or b=='5' or b=='6' or b=='7' or b=='8' or b=='9':
                    lines[i-1]='    a'+bb+'\n'
            bbb=open('bd_imsi','w')
            for i in range(len(lines)):bbb.write(lines[i])
            bbb.close()
            os.system('cp '+self.caseDir+'/constant/polyMesh/boundary '+self.caseDir+'/constant/polyMesh/boundary_old')
            os.system('mv bd_imsi '+self.caseDir+'/constant/polyMesh/boundary')

	return filename
#---------------------------------------------------------------------------------------------------------
    def readMesh(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                        gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            stmesh=dialog.get_filename()
            print dialog.get_filename(), 'selected'
        elif response == gtk.RESPONSE_CANCEL:
	    stmesh='None'
            print 'Closed, no files selected'
        dialog.destroy()        

	if stmesh!='None':
	    self.resetCase()
	    os.system('cp -r '+stmesh+' '+self.caseDir+'/constant/')

	    crFile=writeFileClassIncompressible(self.caseDir)
	    crFile.UFileBasic();crFile.pFileBasic();crFile.kFileBasic();crFile.epsilonFileBasic();crFile.omegaFileBasic();crFile.nutFileBasic()

	return stmesh   
#-------------------------------------------------------------------------------------------------
    def readcase(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            caseDir=dialog.get_filename()
            print dialog.get_filename(), 'selected'
        elif response == gtk.RESPONSE_CANCEL:
	    caseDir='None'
            print 'Closed, no files selected'
        dialog.destroy()
	return caseDir
#-------------------------------------------------------------------------------------
    def saveas(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL, 
					gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_CREATE_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            clonename=dialog.get_filename()
            print dialog.get_filename(), 'selected'
        elif response == gtk.RESPONSE_CANCEL:
	    clonename='None'
            print 'Closed, no files selected'
        dialog.destroy()
	if clonename!='None':        
	    os.system('cp -r '+self.caseDir+'/* '+clonename+'/')
	    f=open(clonename+'/inputFile','r');ff=f.readlines();f.close()
	    ff[0]='caseDir                        : '+clonename+'\n'
	    f=open(clonename+'/inputFile','w')
	    for ii in ff:f.write(ii)
	    f.close()
	return clonename
#-------------------------------------------------------------------------------------
    def clone(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL, 
					gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_CREATE_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            clonename=dialog.get_filename()
            print dialog.get_filename(), 'selected'
        elif response == gtk.RESPONSE_CANCEL:
	    clonename='None'
            print 'Closed, no files selected'
        dialog.destroy()
	if clonename!='None':
	    os.system('cp -r '+self.caseDir+'/0 '+clonename+'/')
	    os.system('cp -r '+self.caseDir+'/constant '+clonename+'/')
	    os.system('cp -r '+self.caseDir+'/system '+clonename+'/')
	    os.system('cp -r '+self.caseDir+'/temporary '+clonename+'/')
	    os.system('cp '+self.caseDir+'/incompressible.py '+clonename+'/')
	    os.system('cp '+self.caseDir+'/writeFileIncompressibleSub.py '+clonename+'/')
	    os.system('cp '+self.caseDir+'/inputFile '+clonename+'/')

	    f=open(clonename+'/inputFile','r');ff=f.readlines();f.close()
	    ff[0]='caseDir                        : '+clonename+'\n'
	    f=open(clonename+'/inputFile','w')
	    for ii in ff:f.write(ii)
	    f.close()
	return clonename
#-------------------------------------------------------------------------------------
    def checkMesh(self):
	def closethis(widget):mwin.destroy()

	os.system('checkMesh -case '+self.caseDir+' > '+self.caseDir+'/checkMeshResult')

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Mesh Information');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)
	hbox=gtk.HBox(False,5);hbox.set_size_request(750,600);mainbox.pack_start(hbox,True,True,5)
        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview=gtk.TextView()
        textbuffer=textview.get_buffer()
        sw.add(textview)
        hbox.pack_start(sw,True,True,5)

	f=open(self.caseDir+'/checkMeshResult','r');ff=f.readlines();f.close()
	res=ff[24:-2];string=''
	for ii in res:string=string+ii
        textbuffer.set_text(string)

	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
	buttonbox.pack_end(closeB,False,False,5)
        mwin.show_all()
#-- get cellZones---------------------------------------------------------------------------------------
    def getCellZones(self):
        aa=self.caseDir+'/constant/polyMesh/cellZones'
        filea=open(aa);lines=filea.readlines();filea.close()
        line1=[];cellZones=[]
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            b=(lines[i-1]).strip();cellZones.append(b)
        return cellZones
#-- get faceZones---------------------------------------------------------------------------------------
    def getfaceZones(self):
        aa=self.caseDir+'/constant/polyMesh/faceZones'
        filea=open(aa);lines=filea.readlines();filea.close()
        line1=[];faceZones=[]
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            b=(lines[i-1]).strip();faceZones.append(b)
        return faceZones
#-- get sets-------------------------------------------------------------------------------------
    def getSets(self):
        aa=self.caseDir+'/constant/polyMesh/sets/*'
	sss=glob.glob(aa)
	sets=[]
	for jj in sss:
	    bb=jj.split('/');sets.append(bb[-1])
        return sets
#-- get boundary name Multi Region --------------------------------------------------------------------------
    def getBCNameMultiRegion(self,region):
        aa=self.caseDir+'/constant/'+region+'/polyMesh/boundary'
        filea=open(aa);lines=filea.readlines();filea.close()
	for ii in lines:
	    if ii=='\n':lines.remove(ii)
	num=int(lines[16])
        line1=[];bcname=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            b=(lines[i-1]).strip();bcname.append(b)
        return bcname
#-- get boundary name---------------------------------------------------------------------------------------
    def getBCName(self):
        aa=self.caseDir+'/constant/polyMesh/boundary'
        filea=open(aa);lines=filea.readlines();filea.close()
	for ii in lines:
	    if ii=='\n':lines.remove(ii)
	num=int(lines[16])
        line1=[];bcname=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            b=(lines[i-1]).strip();bcname.append(b)
        return bcname
#-- get boundary type Multi Region ------------------------------------------------------------------
    def getBCTypeMultiRegion(self,region):
        aa=self.caseDir+'/constant/'+region+'/polyMesh/boundary'
        filea=open(aa,'r');lines=filea.readlines();filea.close()
	for ii in lines:
	    if ii=='\n':lines.remove(ii)
	num=int(lines[16])
        line1=[];bctype=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            bb=(lines[i+1]).split();bb1=(bb[1])[:-1];bctype.append(bb1)
        return bctype
#-- get boundary type from polyMesh/boundary file ------------------------------------------------------------------
    def getBCType(self):
        aa=self.caseDir+'/constant/polyMesh/boundary'
        filea=open(aa,'r');lines=filea.readlines();filea.close()
	for ii in lines:
	    if ii=='\n':lines.remove(ii)
	num=int(lines[16])
        line1=[];bctype=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            bb=(lines[i+1]).split();bb1=(bb[1])[:-1];bctype.append(bb1)
        return bctype
#--------------------------------------------------------------------------------------
    def changeBoundaryType(self,bcname,bctype):
        f=open(self.caseDir+'/constant/polyMesh/boundary','r');ff=f.readlines();f.close()
        lines=[];boundaryDic={}
        for i in range(len(ff)):lines.append((ff[i])[:-1])
        for i in range(len(bcname)):
            j=19+i*6
            boundaryDic[bcname[i]]=[lines[j+1],lines[j+2],lines[j+3],lines[j+4],lines[j+5]]

        f=open(self.caseDir+'/constant/polyMesh/boundary','w')
        for i in range(17):f.write(ff[i])
        f.write(str(len(bcname))+'\n');f.write('(\n')
        for i in range(len(bcname)):
            f.write(bcname[i]+'\n')
            f.write('{\n')
            f.write('        type        '+bctype[i]+';\n')
            aa=boundaryDic[bcname[i]]
            f.write(aa[2]+'\n')
            f.write(aa[3]+'\n')
            f.write(aa[4]+'\n')
        f.write(')\n')
        f.write('//***** End ******//')
        f.close()
# -----------------------------------------------------------------------------------
    def changeDictionaryDict(self,bcNameList,patchTypeList):
        fff=self.caseDir+'/system/changeDictionaryDict'
        aaa=['2.0','ascii','dictionary','changeDictionaryDict']
        head=self.header(aaa)    	
        f=open(fff,'w')
        for i in range(len(head)):f.write(head[i])
        f.write('dictionaryReplacement\n')
        f.write('{\n')
        f.write('    boundary\n')
        f.write('    {\n')
	for i in range(len(bcNameList)):
            f.write('        '+bcNameList[i]+'\n')
            f.write('        {\n')
            f.write('            type    '+patchTypeList[i]+';\n')
            f.write('        }\n')
        f.write('    }\n')
        f.write('}\n')
        f.close()  
# -----------------------------------------------------------------------------------
    def changeDictionaryDictNoAMINoMappedWall(self,bcNameList,patchTypeList):

	aa=glob.glob(self.caseDir+'/temporary/cyclicCondition')
	if len(aa)!=0:
	    f=open(self.caseDir+'/temporary/cyclicCondition','r');ff=f.readlines();f.close()
	    rotCenter=ff[0][:-1]
	    rotAxis=ff[1][:-1]
	    if rotAxis=='x':raxis='(1 0 0)'
	    elif rotAxis=='y':raxis='(0 1 0)'
	    elif rotAxis=='z':raxis='(0 0 1)'

	bb=glob.glob(self.caseDir+'/temporary/amiFaces')
	amiface=[]
	if len(bb)!=0:
	    f=open(self.caseDir+'/temporary/amiFaces','r');ff=f.readlines();f.close()
	    for ii in ff:amiface.append(ii[:-1])

        fff=self.caseDir+'/system/changeDictionaryDict'
        aaa=['2.0','ascii','dictionary','changeDictionaryDict']
        head=self.header(aaa)    	
        f=open(fff,'w')
        for i in range(len(head)):f.write(head[i])
        f.write('dictionaryReplacement\n')
        f.write('{\n')
        f.write('    boundary\n')
        f.write('    {\n')
	for i in range(len(bcNameList)):
	    if patchTypeList[i]!='cyclicAMI' and patchTypeList[i]!='mappedWall':
                f.write('        '+bcNameList[i]+'\n')
                f.write('        {\n')
                f.write('            type    '+patchTypeList[i]+';\n')
                f.write('        }\n')			
        f.write('    }\n')
        f.write('}\n')
        f.close()   
# -----------------------------------------------------------------------------------
    def changeDictionaryDictNoAMI(self,bcNameList,patchTypeList):

	aa=glob.glob(self.caseDir+'/temporary/cyclicCondition')
	if len(aa)!=0:
	    f=open(self.caseDir+'/temporary/cyclicCondition','r');ff=f.readlines();f.close()
	    rotCenter=ff[0][:-1]
	    rotAxis=ff[1][:-1]
	    if rotAxis=='x':raxis='(1 0 0)'
	    elif rotAxis=='y':raxis='(0 1 0)'
	    elif rotAxis=='z':raxis='(0 0 1)'

	bb=glob.glob(self.caseDir+'/temporary/amiFaces')
	amiface=[]
	if len(bb)!=0:
	    f=open(self.caseDir+'/temporary/amiFaces','r');ff=f.readlines();f.close()
	    for ii in ff:amiface.append(ii[:-1])

        fff=self.caseDir+'/system/changeDictionaryDict'
        aaa=['2.0','ascii','dictionary','changeDictionaryDict']
        head=self.header(aaa)    	
        f=open(fff,'w')
        for i in range(len(head)):f.write(head[i])
        f.write('dictionaryReplacement\n')
        f.write('{\n')
        f.write('    boundary\n')
        f.write('    {\n')
	for i in range(len(bcNameList)):
	    if patchTypeList[i]!='cyclicAMI':
                f.write('        '+bcNameList[i]+'\n')
                f.write('        {\n')
                f.write('            type    '+patchTypeList[i]+';\n')
                f.write('        }\n')			
        f.write('    }\n')
        f.write('}\n')
        f.close()     
#-----------------------------------------------------------------------------------------------------
    def changeDictionaryDictSliding(self,amiface):

        fff=self.caseDir+'/system/changeDictionaryDictSliding'
        aaa=['2.0','ascii','dictionary','changeDictionaryDict']
        head=self.header(aaa)    	
        f=open(fff,'w')
        for i in range(len(head)):f.write(head[i])
        f.write('dictionaryReplacement\n')
        f.write('{\n')
        f.write('    boundary\n')
        f.write('    {\n')

        f.write('        '+amiface[0]+'\n')
        f.write('        {\n')
        f.write('            type              cyclicAMI;\n')
        f.write('            matchTolerance    0.0001;\n')
        f.write('            transform         noOrdering;\n')
        f.write('            neighbourPatch    '+amiface[1]+';\n')
        f.write('        }\n')
        f.write('        '+amiface[1]+'\n')
        f.write('        {\n')
        f.write('            type              cyclicAMI;\n')
        f.write('            matchTolerance    0.0001;\n')
        f.write('            transform         noOrdering;\n')
        f.write('            neighbourPatch    '+amiface[0]+';\n')
        f.write('        }\n')	
			
        f.write('    }\n')
        f.write('}\n')
        f.close()     
    #-------------------------------------------------------------------------------------
    def getLatestTime(self):
	res=glob.glob(self.caseDir+'/[0-9]*')
	resToInt=[]
	for i in range(len(res)):
	    ss=res[i].split('/');sss=ss[-1]
	    if sss!='2dplot.lpt' and sss!='0.org' and sss[-4:]!='foam':
		#resToInt.append(int(sss))
		resToInt.append(sss)
	resToInt.sort()
	#finalRes=str(resToInt[-1])
	finalRes=resToInt[-1]
	return finalRes
    #------------------------------------------------------------------------------
    def getValue(inputfile,key):
        f=open(inputfile,'r');ff=f.readlines();f.close()
        itemlines=[]
        for i in ff:itemlines.append(i[:-1])
        items={}
        for aa in itemlines:
            aaa=aa.split(';')
	    if len(aaa)==2:
	        keys=aaa[0].strip();values=aaa[1].strip()
                items[keys]=values
	    elif len(aaa)==1:
	        keys=aaa[0].strip();values='none'
                items[keys]=values
	    else:
	        print 'Error!!! Something is wrong in the inputFile at ',aa
        value=items[key]
        print 'value of '+key+' is ',value
        return value
    #-----------------------------------------------------------------------------------------------------
    def header(self,content):#content=[version,format,class,object]
        foamFile=[]
        foamFile.append('FoamFile\n')
        foamFile.append('{\n')
        foamFile.append('    version    '+content[0]+';\n')
        foamFile.append('    format     '+content[1]+';\n')
        foamFile.append('    class      '+content[2]+';\n')
        foamFile.append('    object     '+content[3]+';\n')
        foamFile.append('}\n')
        foamFile.append('//****************************************//\n')
        return foamFile 
    #-----------------------------------------------------------------------------------------------------
    def killJob(self):

	def closethis(widget):mwin.destroy()
	def applythis(widget):
	    selec=[]
	    for i in range(len(pid)):
		aa=cbentry[i].get_active()
		if aa==True:selec.append(pid[i])
	    for ii in selec:os.system('kill -9 '+ii)
	    mwin.destroy()

	os.system('ps -a > '+self.caseDir+'/psLog')
	f=open(self.caseDir+'/psLog','r');ff=f.readlines();f.close()
	pid=[];tty=[];time=[];cmd=[]
	for i in range(len(ff)-1):
	    aa=ff[i+1].split()
	    pid.append(aa[0]);tty.append(aa[1]);time.append(aa[2]);cmd.append(aa[3])

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Mesh Information');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

	label=gtk.Label('       PID    TTY    TIME    CMD')
	lbox=gtk.HBox(False,5);mainbox.pack_start(lbox,False,False,5);lbox.pack_start(label,False,False,5)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,True,True,5)
	box1=gtk.VBox(False,5);frame.add(box1)
	cbentry=[]
	for i in range(len(ff)-1):
	    cbentry.append(gtk.CheckButton(pid[i]+'    '+tty[i]+'    '+time[i]+'    '+cmd[i]))
	    box1.pack_start(cbentry[i],False,False,5)

	box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
	appB=gtk.Button('Kill');closeB=gtk.Button('Close')
	appB.set_size_request(100,28);closeB.set_size_request(100,28)
	appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
	box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

	mwin.show_all()
    #-----------------------------------------------------------------------------------------------------
    def mapFields(self):
	global sourceCase

	def source(widget):
	    global sourceCase
            dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                          (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
            dialog.set_default_response(gtk.RESPONSE_OK)
            dialog.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
            response = dialog.run()
            if response == gtk.RESPONSE_OK:
                sourceCase=dialog.get_filename()
                print dialog.get_filename(), 'selected'
            elif response == gtk.RESPONSE_CANCEL:
	        sourceCase='None'
                print 'Closed, no caseDir selected'
            dialog.destroy()

	def closethis(widget):mwin.destroy()

	def applythis(widget):
	    if latestCB.get_active()==True:sourceTime='latestTime'
	    else:sourceTime=stimeEntry.get_text()
	    os.system('mapFields -consistent -case '+self.caseDir+' -sourceTime '+sourceTime+' '+sourceCase+'&')
	    mwin.destroy()

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('mapFields');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,True,True,5)
	box1=gtk.VBox(False,5);frame.add(box1)
	sourceB=gtk.Button(' Select source case ');sourceB.connect('clicked',source)
	hbox1=gtk.HBox(False,5);box1.pack_start(hbox1,False,False,5);hbox1.pack_start(sourceB,False,False,5)
	latestCB=gtk.CheckButton('SourceTime is latestTime');latestCB.set_active(1)
	hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5);hbox2.pack_start(latestCB,False,False,5)
	label=gtk.Label('sourceTime');stimeEntry=gtk.Entry();stimeEntry.set_size_request(100,28)
	hbox3=gtk.HBox(False,5);box1.pack_start(hbox3,False,False,5)
	hbox3.pack_start(label,False,False,5);hbox3.pack_end(stimeEntry,False,False,5)
	box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
	appB=gtk.Button('mapFields');closeB=gtk.Button('Close')
	appB.set_size_request(100,28);closeB.set_size_request(100,28)
	appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
	box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

	mwin.show_all()	
    #-----------------------------------------------------------------------------------------------------
    def setFields(self):
	def closethis(widget):mwin.destroy()

	def applythis(widget):
	    minx=minxEntry.get_text();miny=minyEntry.get_text();minz=minzEntry.get_text()
	    maxx=maxxEntry.get_text();maxy=maxyEntry.get_text();maxz=maxzEntry.get_text()
	    setFieldsRangeMin='('+minx+' '+miny+' '+minz+')'
	    setFieldsRangeMax='('+maxx+' '+maxy+' '+maxz+')'
	    aa=scCombo.child;scalar=aa.get_text()
	    dvalue=dvEntry.get_text();value=vEntry.get_text()	
	    crFile=writeFileClassIncompressible(self.caseDir)	    
	    crFile.setFieldsDict(setFieldsRangeMin,setFieldsRangeMax,scalar,dvalue,value)
	    os.system('setFields -case '+self.caseDir)
	    mwin.destroy()

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('setFields');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,True,True,5)
	box1=gtk.VBox(False,5);frame.add(box1)

        label=gtk.Label('Min. x,y,z ')
	minxEntry=gtk.Entry();minyEntry=gtk.Entry();minzEntry=gtk.Entry()
	minxEntry.set_size_request(60,28);minyEntry.set_size_request(60,28);minzEntry.set_size_request(60,28)
        hbox1=gtk.HBox(False,5);box1.pack_start(hbox1,False,False,5)                
        hbox1.pack_start(label,False,False,5);hbox1.pack_end(minzEntry,False,False,5)
	hbox1.pack_end(minyEntry,False,False,5);hbox1.pack_end(minxEntry,False,False,5)	

        label=gtk.Label('Max. x,y,z ')
	maxxEntry=gtk.Entry();maxyEntry=gtk.Entry();maxzEntry=gtk.Entry()
	maxxEntry.set_size_request(60,28);maxyEntry.set_size_request(60,28);maxzEntry.set_size_request(60,28)
        hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5)                
        hbox2.pack_start(label,False,False,5);hbox2.pack_end(maxzEntry,False,False,5)
	hbox2.pack_end(maxyEntry,False,False,5);hbox2.pack_end(maxxEntry,False,False,5)	

	label=gtk.Label('Select scalar')
        scCombo=gtk.combo_box_entry_new_text();scCombo.set_size_request(100,28)
	scalars=['p','k','epsilon','omega'] 
	for ii in scalars:scCombo.append_text(ii)
	scCombo.set_active(0)
	hbox3=gtk.HBox(False,5);box1.pack_start(hbox3,False,False,5)
        hbox3.pack_start(label,False,False,5);hbox3.pack_end(scCombo,False,False,5)	

	label=gtk.Label('default value');dvEntry=gtk.Entry();dvEntry.set_size_request(100,28)
	hbox4=gtk.HBox(False,5);box1.pack_start(hbox4,False,False,5)
        hbox4.pack_start(label,False,False,5);hbox4.pack_end(dvEntry,False,False,5)
	
	label=gtk.Label('fix value');vEntry=gtk.Entry();vEntry.set_size_request(100,28)
	hbox5=gtk.HBox(False,5);box1.pack_start(hbox5,False,False,5)
        hbox5.pack_start(label,False,False,5);hbox5.pack_end(vEntry,False,False,5)	

	box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
	appB=gtk.Button('setFields');closeB=gtk.Button('Close')
	appB.set_size_request(100,28);closeB.set_size_request(100,28)
	appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
	box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

	mwin.show_all()	
    #-----------------------------------------------------------------------------------------------------
    def reconstructPar(self):
	def closethis(widget):mwin.destroy()

	def applythis(widget):
	    fname=self.caseDir+'/temporary/ims'
	    f=open(fname,'w')
	    if latestCB.get_active()==True:
		f.write('reconstructPar -case '+self.caseDir+' -latestTime \n')
	    else:
		fromtime=fromEntry.get_text();totime=toEntry.get_text()
		if fromtime==totime:
		    f.write('reconstructPar -case '+self.caseDir+' -time '+fromtime+' \n')
		else:
		    aaa='reconstructPar -case '+self.caseDir+' -time <'+fromtime+':'+totime+'>'
		    f.write("reconstructPar -case "+self.caseDir+" -time '"+fromtime+':'+totime+"' \n")
	    f.write('rm -r '+self.caseDir+'/processor* \n');f.close()
	    os.system('chmod +x '+fname);os.system(fname);os.system('rm '+fname)
	    mwin.destroy()

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('reconstructPar');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,True,True,5)
	box1=gtk.VBox(False,5);frame.add(box1)

	latestCB=gtk.CheckButton('SourceTime is latestTime');latestCB.set_active(1)
	hbox1=gtk.HBox(False,5);box1.pack_start(hbox1,False,False,5);hbox1.pack_start(latestCB,False,False,5)

	label=gtk.Label('time range')
	fromEntry=gtk.Entry();fromEntry.set_size_request(100,28)
	toEntry=gtk.Entry();toEntry.set_size_request(100,28)
	hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5)
	hbox2.pack_start(label,False,False,5);hbox2.pack_start(fromEntry,False,False,5);hbox2.pack_end(toEntry,False,False,5)

	box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
	appB=gtk.Button('reconstruct');closeB=gtk.Button('Close')
	appB.set_size_request(100,28);closeB.set_size_request(100,28)
	appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
	box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

	mwin.show_all()	
    #-----------------------------------------------------------------------------------------------------
    def caseReport(self):

	def closethis(widget):mwin.destroy()

	os.system('pyFoamCaseReport.py --full-report '+self.caseDir+' > '+self.caseDir+'/caseReport')

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Case Information');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)
	hbox=gtk.HBox(False,5);hbox.set_size_request(750,600);mainbox.pack_start(hbox,True,True,5)
        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview=gtk.TextView()
        textbuffer=textview.get_buffer()
        sw.add(textview)
        hbox.pack_start(sw,True,True,5)

	f=open(self.caseDir+'/caseReport','r');ff=f.readlines();f.close()
	string=''
	for ii in ff:string=string+ii
        textbuffer.set_text(string)

	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
	buttonbox.pack_end(closeB,False,False,5)
        mwin.show_all()
    #-----------------------------------------------------------------------------------------------------
    def caseReportToPdf(self):
	os.system('pyFoamCaseReport.py --full-report '+self.caseDir+' | rst2pdf > '+self.caseDir+'/caseReport.pdf')
	os.system('evince '+self.caseDir+'/caseReport.pdf &')
    #-----------------------------------------------------------------------------------------------------
    def caseReportToTex(self):
	os.system('pyFoamCaseReport.py --full-report '+self.caseDir+' | rst2latex > '+self.caseDir+'/caseReport.tex')
	os.system('texworks '+self.caseDir+'/caseReport.tex &')
    #-----------------------------------------------------------------------------------------------------
    def extractBCDictionary(self):
	# from constant/polyMesh/boundary file, make patch list and dictionary

	f=open(self.caseDir+'/constant/polyMesh/boundary','r');ff=f.readlines();f.close()

	dictionary={}

	for i in range(len(ff)):
    	    if ff[i]=='(\n':
		start=i+1;break

	for i in range(start):del ff[0]

	j=0;patches=[];value=[]
	for i in range(len(ff)-1):
	    if ff[i]=='    {\n':	
        	patches.append(ff[i-1][:-1].strip());j=j+1
    	    value.append(ff[i+1][:-1].strip())
    	    if ff[i]=='    }\n':
		del value[-1]
		dictionary[patches[j-1]]=value
		value=[]

	newpatch=[];newdict={}
	for i in range(len(patches)):
	    newpatch.append('    '+patches[i])
	    dic=dictionary[patches[i]]
	    newvalue=[]
	    for j in range(len(dic)):
		if j==0:newvalue.append('    '+dic[j])
		elif j==len(dic)-1:newvalue.append('    '+dic[j])
		else:newvalue.append('        '+dic[j])
	    newdict[newpatch[i]]=newvalue

	#for i in range(len(newpatch)):
	#    print newpatch[i]
	#    dic=newdict[newpatch[i]]
	#    for j in range(len(dic)):
	#	print dic[j]

	boundaryDictionary=[newpatch,newdict]

	return boundaryDictionary
    #-----------------------------------------------------------------------------------------------------
    def resetCase(self):
	os.system('rm -r '+self.caseDir+'/*')
	os.system('mkdir '+self.caseDir+'/0');os.system('mkdir '+self.caseDir+'/constant');os.system('mkdir '+self.caseDir+'/system')
	os.system('mkdir '+self.caseDir+'/temporary')

	controlList=['startTime','0','endTime','100','1','no','1','1','timeStep','100','0','ascii','6','no','simpleFoam']
	solutionList=['GAMG','smoothSolver','yes','1','1','0','1e-3','1e-3','1e-3','0.3','0.7','0.7']
	schemeList=['steadyState','Gauss linear','Gauss linear corrected','linear','corrected','Gauss upwind','Gauss upwind','simpleFoam']

	crFile=writeFileClassIncompressible(self.caseDir)
	crFile.controlDict(controlList);crFile.fvSolution(solutionList,'simpleFoam');crFile.fvSchemes(schemeList)

	aa=glob.glob(self.caseDir+'/*')
	aa.remove(self.caseDir+'/constant');aa.remove(self.caseDir+'/system')
	for ii in aa:os.system('rm -r '+ii)
	os.system('mkdir '+self.caseDir+'/0');os.system('mkdir '+self.caseDir+'/temporary')
    #-----------------------------------------------------------------------------------------------------
    def getResult(self):
	resultSerial=[];resultParallel=[]

	os.system('foamListTimes -case '+self.caseDir+' -noZero > '+self.caseDir+'/temporary/resultSerial')
	f=open(self.caseDir+'/temporary/resultSerial','r');ff=f.readlines();f.close()
	for ii in ff:resultSerial.append(ii[:-1])
	os.system('rm '+self.caseDir+'/temporary/resultSerial')

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)!=0:
	    os.system('foamListTimes -case '+self.caseDir+' -noZero -processor > '+self.caseDir+'/temporary/resultParallel')
	    f=open(self.caseDir+'/temporary/resultParallel','r');ff=f.readlines();f.close()
	    for ii in ff:resultParallel.append(ii[:-1])
	    os.system('rm '+self.caseDir+'/temporary/resultParallel')

	results=[resultSerial,resultParallel]
	return results
    #-----------------------------------------------------------------------------------------------------
    def clearResult(self,times,mode):
	# mode=1 : include parallel
	# mode=0 : serial only
	# times : list of time folder
	if mode=='0':
	    for ii in times:os.system('rm -r '+self.caseDir+'/'+ii)
	else:
	    for ii in times:os.system('rm -r '+self.caseDir+'/'+ii)
	    procs=glob.glob(self.caseDir+'/processor*')
	    for jj in procs:
		for kk in times:os.system('rm -r '+jj+'/'+kk)
    #-----------------------------------------------------------------------------------------------------
    def clearParallel(self):
	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)!=0:
	    os.system('rm -r '+self.caseDir+'/processor*')	



