#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for subfunctions specified to heat transfer
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math;import pygtk;pygtk.require('2.0');import gtk;import glob
from generalSub import *

class heatTransferSubClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir
    
    #--------------------------------------------------------------------------------------  
    def materialPropertyWindow(self):

        def closethis(widget):
            window.destroy()

	def saveProperty(widget):
	    aa=rhoCombo.child;rhomethod=aa.get_text();rhovalue=rhoEntry.get_text()
	    aa=visCombo.child;vismethod=aa.get_text()
	    visvalue=visEntry.get_text();Asvalue=AsEntry.get_text();Tsvalue=TsEntry.get_text()
	    cpvalue=cpEntry.get_text()
	    kappavalue=kappaEntry.get_text()
	    f=open(self.caseDir+'/temporary/properties','w')
	    if rhomethod=='perfectGas':f.write(rhomethod+'\n')
	    else:f.write(rhovalue+'\n')
	    if vismethod=='Sutherland':f.write(vismethod+','+Asvalue+','+Tsvalue+'\n')
	    else:f.write(visvalue+'\n')
	    f.write(cpvalue+'\n');f.write(kappavalue+'\n')
	    f.close()
	    window.destroy()	    

	def chrho(widget):
	    aa=rhoCombo.child;rhomethod=aa.get_text()
	    if rhomethod=='perfectGas':
		rhobox3.remove(rhoEntry)
	    elif rhomethod=='constant':
		rhobox3.pack_start(rhoEntry,False,False,5)
	    window.show_all()

	def chvis(widget):
	    aa=visCombo.child;vismethod=aa.get_text()
	    if vismethod=='Sutherland':
		visbox1.remove(visLabel);visbox3.remove(visEntry)
		visbox1.pack_start(visLabel1,False,False,5);visbox3.pack_start(AsEntry,False,False,5);visbox4.pack_start(TsEntry,False,False,5)
	    else:
		visbox1.remove(visLabel1);visbox3.remove(AsEntry);visbox4.remove(TsEntry)
		visbox1.pack_start(visLabel,False,False,5);visbox3.pack_start(visEntry,False,False,5)
	    window.show_all()	    

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Material properties')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame();frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	rhoLabel=gtk.Label('density')
        rhoCombo=gtk.combo_box_entry_new_text();rhoCombo.set_size_request(120,28)
	rhoModels=['constant','perfectGas'] 
	for models in rhoModels:rhoCombo.append_text(models)
	rhoCombo.set_active(0);rhoCombo.connect('changed',chrho)
	rhoEntry=gtk.Entry();rhoEntry.set_text('1.2');rhoEntry.set_size_request(80,28)
        rhobox=gtk.HBox(False,5);vbox.pack_start(rhobox,False,False,5)
	rhobox1=gtk.HBox(False,5);rhobox2=gtk.HBox(False,5);rhobox3=gtk.HBox(False,5);rhobox4=gtk.HBox(False,5)
	rhobox1.set_size_request(100,28);rhobox2.set_size_request(120,28);rhobox3.set_size_request(80,28);rhobox4.set_size_request(80,28)
	rhobox.pack_start(rhobox1,False,False,5);rhobox.pack_start(rhobox2,False,False,5)
	rhobox.pack_start(rhobox3,False,False,5);rhobox.pack_start(rhobox4,False,False,5)
	rhobox1.pack_start(rhoLabel,False,False,5);rhobox2.pack_start(rhoCombo,False,False,5);rhobox3.pack_start(rhoEntry,False,False,5)

	visLabel=gtk.Label('mu');visLabel1=gtk.Label('As / Ts')
        visCombo=gtk.combo_box_entry_new_text();visCombo.set_size_request(120,28)
	visModels=['constant','Sutherland'] 
	for models in visModels:visCombo.append_text(models)
	visCombo.set_active(0);visCombo.connect('changed',chvis)
	visEntry=gtk.Entry();visEntry.set_size_request(80,28);visEntry.set_text('1e-5')
	AsEntry=gtk.Entry();AsEntry.set_size_request(80,28);AsEntry.set_text('1.6e-6')
	TsEntry=gtk.Entry();TsEntry.set_size_request(80,28);TsEntry.set_text('170')
        visbox=gtk.HBox(False,5);vbox.pack_start(visbox,False,False,5)
	visbox1=gtk.HBox(False,5);visbox2=gtk.HBox(False,5);visbox3=gtk.HBox(False,5);visbox4=gtk.HBox(False,5)
	visbox1.set_size_request(100,28);visbox2.set_size_request(120,28);visbox3.set_size_request(80,28);visbox4.set_size_request(80,28)
	visbox.pack_start(visbox1,False,False,5);visbox.pack_start(visbox2,False,False,5)
	visbox.pack_start(visbox3,False,False,5);visbox.pack_start(visbox4,False,False,5)
	visbox1.pack_start(visLabel,False,False,5);visbox2.pack_start(visCombo,False,False,5);visbox3.pack_start(visEntry,False,False,5)
	
	cpLabel=gtk.Label('Cp')
        cpCombo=gtk.combo_box_entry_new_text();cpCombo.set_size_request(120,28)
	cpModels=['constant'] 
	for ii in cpModels:cpCombo.append_text(ii)
	cpCombo.set_active(0)
	cpEntry=gtk.Entry();cpEntry.set_size_request(80,28);cpEntry.set_text('1006.43')
	cpbox=gtk.HBox(False,5);vbox.pack_start(cpbox,False,False,5)
	cpbox1=gtk.HBox(False,5);cpbox2=gtk.HBox(False,5);cpbox3=gtk.HBox(False,5);cpbox4=gtk.HBox(False,5)
	cpbox1.set_size_request(100,28);cpbox2.set_size_request(120,28);cpbox3.set_size_request(80,28);cpbox4.set_size_request(80,28)
	cpbox.pack_start(cpbox1,False,False,5);cpbox.pack_start(cpbox2,False,False,5)
	cpbox.pack_start(cpbox3,False,False,5);cpbox.pack_start(cpbox4,False,False,5)
	cpbox1.pack_start(cpLabel,False,False,5);cpbox2.pack_start(cpCombo,False,False,5);cpbox3.pack_start(cpEntry,False,False,5)

	kappaLabel=gtk.Label('conductivity')
        kappaCombo=gtk.combo_box_entry_new_text();kappaCombo.set_size_request(120,28)
	kappaModels=['constant'] 
	for ii in kappaModels:kappaCombo.append_text(ii)
	kappaCombo.set_active(0)
	kappaEntry=gtk.Entry();kappaEntry.set_size_request(80,28);kappaEntry.set_text('0.0242')
	kappabox=gtk.HBox(False,5);vbox.pack_start(kappabox,False,False,5)
	kappabox1=gtk.HBox(False,5);kappabox2=gtk.HBox(False,5);kappabox3=gtk.HBox(False,5);kappabox4=gtk.HBox(False,5)
	kappabox1.set_size_request(100,28);kappabox2.set_size_request(120,28);kappabox3.set_size_request(80,28);kappabox4.set_size_request(80,28)
	kappabox.pack_start(kappabox1,False,False,5);kappabox.pack_start(kappabox2,False,False,5)
	kappabox.pack_start(kappabox3,False,False,5);kappabox.pack_start(kappabox4,False,False,5)
	kappabox1.pack_start(kappaLabel,False,False,5);kappabox2.pack_start(kappaCombo,False,False,5);kappabox3.pack_start(kappaEntry,False,False,5)
	#-------------------------------
	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
        app.connect('clicked',saveProperty);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5)  
	#-------------------------------
	a1=glob.glob(self.caseDir+'/temporary/properties')
	if len(a1)!=0:
	    f=open(self.caseDir+'/temporary/properties','r');ff=f.readlines();f.close()
	    if ff[0][:-1]=='perfectGas':rhoCombo.set_active(1)
	    else:rhoCombo.set_active(0);rhoEntry.set_text(ff[0][:-1])
	    if ff[1][:10]=='Sutherland':
		visCombo.set_active(1)
		aa=ff[1][:-1].split(',');AsEntry.set_text(aa[1]);TsEntry.set_text(aa[2])
	    else:visCombo.set_active(0);visEntry.set_text(ff[1][:-1])
	    cpEntry.set_text(ff[2][:-1]);kappaEntry.set_text(ff[3][:-1])

        window.show_all()  
    #--------------------------------------------------------------------------------------  
    def radiationWindow(self):

	GEN=generalClass(self.caseDir)

        def closethis(widget):
            window.destroy()

	def applythis(widget):
	    if onOffCB.get_active()==True:
	        aa=modelCombo.child;radmodel=aa.get_text()
	        freq=freqEntry.get_text();absor=abEntry.get_text();emis=emEntry.get_text();ee=eeEntry.get_text()
	        nphi=nphiEntry.get_text();ntheta=nthetaEntry.get_text();con=convEntry.get_text()
	        maxi=maxEntry.get_text()
	        aa=cacheCombo.child;cache=aa.get_text()
	        f=open(self.caseDir+'/temporary/radiation','w')
	        f.write(radmodel+'\n');f.write(freq+'\n');f.write(absor+'\n');f.write(emis+'\n')
	        f.write(ee+'\n');f.write(nphi+'\n');f.write(ntheta+'\n');f.write(con+'\n')
	        f.write(maxi+'\n');f.write(cache+'\n');f.close()
	    else:
		aa=glob.glob(self.caseDir+'/temporary/radiation')
		if len(aa)!=0:os.system('rm '+aa[0])
	    window.destroy()

	def openEmiWin(widget):
	    def applyemi(widget):
		f=open(self.caseDir+'/temporary/wallEmissivity','w')
		for i in range(len(bcpatch)):
		    f.write(bcpatch[i]+','+emiss[i].get_text()+'\n')
		f.close()
		win.destroy()

	    def closeemi(widget):
		win.destroy()

	    bcName=GEN.getBCName();bcType=GEN.getBCType()
	    bcpatch=[];nameType={}
	    for i in range(len(bcName)):
		nameType[bcName[i]]=bcType[i]
	        if bcType[i]=='wall':bcpatch.append(bcName[i])
	    bcpatch.sort()

            win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('Wall Emissivity')
            win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER)
            mbox=gtk.VBox(False,5);win.add(mbox)

            swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
            mbox.pack_start(swin,True,True,5);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
            scheight=len(bcpatch)*43
            if scheight > 750:scheight=750   
	    elif scheight < 200:scheight=200     
            swin.set_size_request(280,scheight)

            hbox=[];faceName=[];emiss=[]

            for i in range(len(bcpatch)):
                hbox.append(gtk.HBox(False,5));itembox.pack_start(hbox[i],False,False,2)                
                faceName.append(gtk.Entry());faceName[i].set_size_request(180,28)
                faceName[i].set_text(bcpatch[i])
                emiss.append(gtk.Entry());emiss[i].set_size_request(80,28);emiss[i].set_text('0.7')
	        hbox[i].pack_start(faceName[i],False,False,0)
	        hbox[i].pack_start(emiss[i],False,False,0)
	    #-------------------------------
	    bubox=gtk.HBox(False,5);mbox.pack_start(bubox,False,False,5)
            app=gtk.Button(label='Apply');app.set_size_request(120,30)
            cll=gtk.Button(label='Close');cll.set_size_request(120,30)
            app.connect('clicked',applyemi);cll.connect('clicked',closeemi)
            bubox.pack_end(cll,False,False,5);bubox.pack_end(app,False,False,5)
  
	    a1=glob.glob(self.caseDir+'/temporary/wallEmissivity')
	    if len(a1)!=0:
	        f=open(a1[0],'r');ss=f.readlines();f.close()
		if len(ss)==len(bcpatch):
		    for i in range(len(ss)):
			aa=ss[i][:-1].split(',');emiss[i].set_text(aa[1])
	    win.show_all()

	def chmodel(widget):
	    aa=modelCombo.child;radmethod=aa.get_text()
	    if radmethod=='P1':
		mainbox.remove(frame1)
	    elif radmethod=='fvDOM':
		mainbox.remove(emibox);mainbox.remove(buttonbox)
		mainbox.pack_start(frame1,False,False,5);mainbox.pack_start(emibox,False,False,5)
		mainbox.pack_start(buttonbox,False,False,5)
	    else:
		md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"viewFactor is not supported yet!!!")
		md.run();md.destroy()
	    window.show_all()	    

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Material properties')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
	mainbox.pack_start(frame,False,False,5)

	rbox=gtk.VBox(False,5);frame.add(rbox)

	onOffCB=gtk.CheckButton('Radiation On')
	rbox.pack_start(onOffCB,False,False,5)

	modellabel=gtk.Label('Radiation model')
        modelCombo=gtk.combo_box_entry_new_text();modelCombo.set_size_request(120,28)
	radModels=['fvDOM','P1','viewFactor'] 
	for ii in radModels:modelCombo.append_text(ii)
	modelCombo.set_active(0);modelCombo.connect('changed',chmodel)
	modelbox=gtk.HBox(False,5);rbox.pack_start(modelbox,False,False,5)
	modelbox.pack_start(modellabel,False,False,5);modelbox.pack_end(modelCombo,False,False,5)

	freqlabel=gtk.Label('solverFrequency')
	freqEntry=gtk.Entry();freqEntry.set_text('10');freqEntry.set_size_request(80,28)
	freqbox=gtk.HBox(False,5);rbox.pack_start(freqbox,False,False,5)
	freqbox.pack_start(freqlabel,False,False,5);freqbox.pack_end(freqEntry,False,False,5)

	ablabel=gtk.Label('absorption coeff. [1/m]')
	abEntry=gtk.Entry();abEntry.set_text('0.5');abEntry.set_size_request(80,28)
	abbox=gtk.HBox(False,5);rbox.pack_start(abbox,False,False,5)
	abbox.pack_start(ablabel,False,False,5);abbox.pack_end(abEntry,False,False,5)

	emlabel=gtk.Label('emission coeff. [1/m]')
	emEntry=gtk.Entry();emEntry.set_text('0.5');emEntry.set_size_request(80,28)
	embox=gtk.HBox(False,5);rbox.pack_start(embox,False,False,5)
	embox.pack_start(emlabel,False,False,5);embox.pack_end(emEntry,False,False,5)

	eelabel=gtk.Label('E,emission contribution [kg/ms3]')
	eeEntry=gtk.Entry();eeEntry.set_text('0');eeEntry.set_size_request(80,28)
	eebox=gtk.HBox(False,5);rbox.pack_start(eebox,False,False,5)
	eebox.pack_start(eelabel,False,False,5);eebox.pack_end(eeEntry,False,False,5)

        frame1=gtk.Frame();frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
	frame1.set_label(' fvDOMCoeffs ');frame1.set_label_align(0.1, 0.5)
	mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	nphilabel=gtk.Label('nPhi')
	nphiEntry=gtk.Entry();nphiEntry.set_text('2');nphiEntry.set_size_request(80,28)
	nphibox=gtk.HBox(False,5);vbox.pack_start(nphibox,False,False,5)
	nphibox.pack_start(nphilabel,False,False,5);nphibox.pack_end(nphiEntry,False,False,5)

	nthetalabel=gtk.Label('nTheta')
	nthetaEntry=gtk.Entry();nthetaEntry.set_text('2');nthetaEntry.set_size_request(80,28)
	nthetabox=gtk.HBox(False,5);vbox.pack_start(nthetabox,False,False,5)
	nthetabox.pack_start(nthetalabel,False,False,5);nthetabox.pack_end(nthetaEntry,False,False,5)

	convlabel=gtk.Label('convergence')
	convEntry=gtk.Entry();convEntry.set_text('1e-3');convEntry.set_size_request(80,28)
	convbox=gtk.HBox(False,5);vbox.pack_start(convbox,False,False,5)
	convbox.pack_start(convlabel,False,False,5);convbox.pack_end(convEntry,False,False,5)

	maxlabel=gtk.Label('maxIter')
	maxEntry=gtk.Entry();maxEntry.set_text('10');maxEntry.set_size_request(80,28)
	maxbox=gtk.HBox(False,5);vbox.pack_start(maxbox,False,False,5)
	maxbox.pack_start(maxlabel,False,False,5);maxbox.pack_end(maxEntry,False,False,5)

	cachelabel=gtk.Label('cacheDiv')
        cacheCombo=gtk.combo_box_entry_new_text();cacheCombo.set_size_request(120,28)
	cacheList=['false','true'] 
	for ii in cacheList:cacheCombo.append_text(ii)
	cacheCombo.set_active(0)
	cachebox=gtk.HBox(False,5);vbox.pack_start(cachebox,False,False,5)
	cachebox.pack_start(cachelabel,False,False,5);cachebox.pack_end(cacheCombo,False,False,5)

	emissivityB=gtk.Button('Wall emissivity');emissivityB.connect('clicked',openEmiWin)
	emibox=gtk.HBox(False,5);mainbox.pack_start(emibox,False,False,5)
	emibox.pack_start(emissivityB,True,True,5)
	#-------------------------------
	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5)  
	#-------------------------------
	a1=glob.glob(self.caseDir+'/temporary/radiation')
	if len(a1)!=0:
	    f=open(a1[0],'r');ff=f.readlines();f.close()
	    if ff[0][:-1]=='fvDOM':modelCombo.set_active(0)
	    else:modelCombo.set_active(1)
	    freqEntry.set_text(ff[1][:-1])
	    abEntry.set_text(ff[2][:-1])
	    emEntry.set_text(ff[3][:-1])
	    eeEntry.set_text(ff[4][:-1])
	    nphiEntry.set_text(ff[5][:-1])
	    nthetaEntry.set_text(ff[6][:-1])
	    convEntry.set_text(ff[7][:-1])
	    maxEntry.set_text(ff[8][:-1])
	    if ff[9][:-1]=='false':cacheCombo.set_active(0)
	    else:cacheCombo.set_active(1)

        window.show_all()  



