#!/usr/bin/env python
#!/bin/bash
#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Main GUI code for incompressible flow
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk

from generalSub import *;from postSub import *;from cellZoneSub import *;from writeFileIncompressibleSub import *
from boundaryConditionSub import*;from meshSub import *;from runSub import *;from misc import *

class incompressibleMainWindow:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.window.destroy()
        gtk.main_quit()

    def __init__(self,caseDir,installpath):
	self.caseDir=caseDir;self.installpath=installpath
	self.timemode='Steady'

    def incompressibleMainGUI(self):
 
        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL);self.window.set_title('Baram-v1.0.1 - Incompressible Flow Solver')
        self.window.set_border_width(5);self.window.set_position(gtk.WIN_POS_CENTER)

        self.swin=gtk.ScrolledWindow();self.swin.set_border_width(5);self.swin.set_policy(gtk.POLICY_ALWAYS,gtk.POLICY_ALWAYS)
	self.swin.set_size_request(1080,810)
	self.window.add(self.swin)
	self.table=gtk.Table(4,3,False);self.table.set_row_spacings(5);self.table.set_col_spacings(5)
	self.mainbox=gtk.VBox(False,5);self.swin.add_with_viewport(self.mainbox)
	self.menubox=gtk.HBox(False,5);self.vvbox=gtk.HBox(False,5)
	self.mainbox.pack_start(self.menubox,False,False,0);self.mainbox.pack_start(self.vvbox,True,True,0)
	self.vvbox.pack_start(self.table,True,True,0)
	self.mb=gtk.MenuBar();self.menubox.pack_start(self.mb,False,False,0)
        self.toolframe=gtk.Frame();self.toolframe.set_shadow_type(gtk.SHADOW_IN)
	self.table.attach(self.toolframe,0,4,0,1)
	self.toollogobox=gtk.HBox(False,0);self.toolframe.add(self.toollogobox)
	self.toolbarbox=gtk.HBox(False,5);self.logobox=gtk.HBox(False,5)
	self.toollogobox.pack_start(self.toolbarbox,False,False,0);self.toollogobox.pack_end(self.logobox,False,False,0)

	self.meshbox=gtk.HBox(True,5);self.table.attach(self.meshbox,0,1,1,2)
	self.generalbox=gtk.HBox(True,5);self.table.attach(self.generalbox,1,2,1,2)
	self.numericbox=gtk.HBox(True,5);self.table.attach(self.numericbox,2,3,1,2)
	self.runbox=gtk.HBox(True,5);self.table.attach(self.runbox,3,4,1,2)
	self.runbox.set_size_request(240,680)
	self.tailbox=gtk.HBox(True,5);self.table.attach(self.tailbox,0,4,2,3)
        #------------------------------------------------------------------------------------------
        def setfolder():
	    MISC=miscClass(self.caseDir)
	    aa=glob.glob(self.caseDir+'/*')
	    if len(aa)==0:
		os.system('mkdir '+self.caseDir+'/0');os.system('mkdir '+self.caseDir+'/constant')
                os.system('mkdir '+self.caseDir+'/system');os.system('mkdir '+self.caseDir+'/temporary')
		MISC.basicfvsolution();MISC.basicfvschemes();MISC.basiccontroldict()
        #------------------------------------------------------------------------------------------
        def newcase():
	    GEN=generalClass(self.caseDir);self.caseDir=GEN.newcase()
	    if self.caseDir!='None':        
	        setfolder()
	        self.tvbox.remove(self.label);self.label=gtk.Label(self.caseDir);self.tvbox.pack_start(self.label,False,False,5) 
	        self.window.show_all()
        #-------------------------------------------------------------------------------------------------    
        def readcase():
	    GEN=generalClass(self.caseDir);caseDir=GEN.readcase()
	    if caseDir!='None':
		self.caseDir=caseDir;self.tvbox.remove(self.label);self.label=gtk.Label(self.caseDir)
	        self.tvbox.pack_start(self.label,False,False,5)
	        self.window.show_all()
	    setValue()
        #------------------------------------------------------------------------------------------
	def openCellZoneWindow(widget):
	    CELLZONE=cellZoneClass(self.caseDir);CELLZONE.cellZoneWindow()
        #------------------------------------------------------------------------------------------
	def openFlowBCWindow(widget):
	    BC=boundaryConditionClass(self.caseDir);BC.flowBCWindow()
        #------------------------------------------------------------------------------------------
	def openTurBCWindow(widget):
	    aa=self.turCombo.child;turModel=aa.get_text()
	    BC=boundaryConditionClass(self.caseDir);BC.turBCWindow(turModel)
        #------------------------------------------------------------------------------------------
	def openPorousJump(widget):
	    CELLZONE=cellZoneClass(self.caseDir);CELLZONE.porousJumpPatch()
        #------------------------------------------------------------------------------------------
	def bcSummary(widget):
	    POST=postClass(self.caseDir);POST.patchSummary()	
        #------------------------------------------------------------------------------------------
	def openProbe(widget): 
	    POST=postClass(self.caseDir);POST.pointProbe()	
        #------------------------------------------------------------------------------------------
	def openSurface(widget): 
	    POST=postClass(self.caseDir);POST.surfaceProbe()
        #------------------------------------------------------------------------------------------
	def openFlowRate(widget): 
	    POST=postClass(self.caseDir);POST.flowrate()
        #------------------------------------------------------------------------------------------
	def openForce():
	    POST=postClass(self.caseDir);POST.openForce()
        #------------------------------------------------------------------------------------------
        def plotprobe(widget):
	    POST=postClass(self.caseDir);POST.plotprobe()
        #------------------------------------------------------------------------------------------
        def plotSurface(widget):
	    POST=postClass(self.caseDir);POST.plotsurface()	
        #------------------------------------------------------------------------------------------
        def plotFlowRate(widget):
	    POST=postClass(self.caseDir);POST.plotflowrate()	
        #------------------------------------------------------------------------------------------
        def plotForce(widget): 
	    POST=postClass(self.caseDir);POST.plotforce()
        #------------------------------------------------------------------------------------------
	def importmesh(widget):
	    if self.caseDir=='none':
		md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error!!! caseDir is not selected")
		md.run();md.destroy()
	    else:
	        MESH=meshClass(self.caseDir);MESH.importmesh()
        #------------------------------------------------------------------------------------------
	def readMesh(widget):
	    GEN=generalClass(self.caseDir);ofmesh=GEN.readMesh()
	    f=open(self.caseDir+'/temporary/importedMesh','w');f.write(ofmesh);f.close()
        #------------------------------------------------------------------------------------------
	def checkMesh(widget):
	    GEN=generalClass(self.caseDir);GEN.checkMesh()
        #------------------------------------------------------------------------------------------
	def createBaffle(widget):
	    MESH=meshClass(self.caseDir);MESH.createBaffle()
        #------------------------------------------------------------------------------------------
	def createInterface(widget):
	    MESH=meshClass(self.caseDir);MESH.createInterface()
        #------------------------------------------------------------------------------------------
	def createCyclicAMI(widget):
	    MESH=meshClass(self.caseDir);MESH.createCyclicAMI()
        #------------------------------------------------------------------------------------------
	def createInterior(widget):
	    MESH=meshClass(self.caseDir);MESH.createInterior()
        #------------------------------------------------------------------------------------------
	def scaleMesh():
	    MESH=meshClass(self.caseDir);MESH.scaleMesh()
        #------------------------------------------------------------------------------------------
	def translateMesh():
	    MESH=meshClass(self.caseDir);MESH.translateMesh()
        #------------------------------------------------------------------------------------------
	def boundarySet(widget):
	    MESH=meshClass(self.caseDir);MESH.boundarySet()
        #------------------------------------------------------------------------------------------
	def selhostfile():
	    RUN=runClass(self.caseDir);hostfilename=RUN.selhostfile()
	    if hostfilename!='None':
	        f=open(self.caseDir+'/temporary/hostfile','w');f.write(hostfilename);f.close()
	    else:
		self.machineCombo.set_active(0)
        #------------------------------------------------------------------------------------------
	def initialize(widget):
	    sm=self.slidingCB.get_active();sol=self.solCombo.get_active()
	    if self.timemode=='Transient' and sm==True:
		if sol==0:solver='pimpleDyMFoam'
		else:solver='nPimpleDyMFoam'
	    elif self.timemode=='Transient' and sm==False:
		if sol==0:solver='pimpleFoam'	  
		else:solver='nPimpleFoam'	      
	    elif self.timemode=='Steady':
		if sol==0:solver='simpleFoam'
		else:solver='nSimpleFoam'

	    GEN=generalClass(self.caseDir);resu=GEN.getResult()

	    if self.startCombo.get_active()==1:#latestTime
	        if len(resu[0])==0 and len(resu[1])==0:
		    md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE," There is no data. 'start from' is set to startTime!")
		    md.run();md.destroy()
		    self.startCombo.set_active(0)

	    self.startCombo.set_active(0)

	    inputvalues=save()
	    in1=inputvalues[0];in2=inputvalues[1];in3=inputvalues[2]
	    RUN=runClass(self.caseDir);RUN.pimpleFoamStart(in1,in2,in3,solver,'initialize')
        #------------------------------------------------------------------------------------------
	def startRun(widget):
	    sm=self.slidingCB.get_active();sol=self.solCombo.get_active()
	    if self.timemode=='Transient' and sm==True:
		if sol==0:solver='pimpleDyMFoam'
		else:solver='nPimpleDyMFoam'
	    elif self.timemode=='Transient' and sm==False:
		if sol==0:solver='pimpleFoam'	  
		else:solver='nPimpleFoam'	      
	    elif self.timemode=='Steady':
		if sol==0:solver='simpleFoam'
		else:solver='nSimpleFoam'

	    GEN=generalClass(self.caseDir);resu=GEN.getResult()

	    if self.startCombo.get_active()==1:#latestTime
	        if len(resu[0])==0 and len(resu[1])==0:
		    md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE," There is no data. 'start from' is set to startTime!")
		    md.run();md.destroy()
		    self.startCombo.set_active(0)

	    inputvalues=save()
	    in1=inputvalues[0];in2=inputvalues[1];in3=inputvalues[2]

	    RUN=runClass(self.caseDir);RUN.pimpleFoamStart(in1,in2,in3,solver,'run')
        #------------------------------------------------------------------------------------------
	def savestop(widget):
	    RUN=runClass(self.caseDir);RUN.savestop()
        #------------------------------------------------------------------------------------------
	def stop(widget):
	    RUN=runClass(self.caseDir);RUN.stop()
        #----------------------------------------------------------------------------------------------
	def resplot():
	    sm=self.slidingCB.get_active()
	    sol=self.solCombo.get_active()
	    if self.timemode=='Transient' and sm==True and sol==0:solver='pimpleDyMFoam'
	    elif self.timemode=='Transient' and sm==True and sol==1:solver='nPimpleDyMFoam'
	    elif self.timemode=='Transient' and sm==False and sol==0:solver='pimpleFoam'	    
	    elif self.timemode=='Transient' and sm==False and sol==1:solver='nPimpleFoam'	    
	    elif self.timemode=='Steady' and sol==0:solver='simpleFoam'
	    elif self.timemode=='Steady' and sol==1:solver='nSimpleFoam'

	    if solver=='simpleFoam' or solver=='nSimpleFoam':
                bb=glob.glob(self.caseDir+'/PyFoamRunner.mpirun.logfile')
	        if len(bb)!=0:
		    aa='pyFoamPlotWatcher.py PyFoamRunner.mpirun.logfile &'
	        else:
		    aa='pyFoamPlotWatcher.py PyFoamRunner.'+solver+'.logfile &'
	        os.chdir(self.caseDir);os.system(aa)
	    elif solver=='pimpleFoam' or solver=='pimpleDyMFoam' or solver=='nPimpleFoam' or solver=='nPimpleDyMFoam':	
                bb=glob.glob(self.caseDir+'/PyFoamRunner.mpirun.logfile')
	        if len(bb)!=0:
		    aa='pyFoamPlotWatcher.py PyFoamRunner.mpirun.logfile &'
	        else:
		    cc=glob.glob(self.caseDir+'/PyFoamRunner.pimpleFoam.logfile')
		    if len(cc)!=0:aa='pyFoamPlotWatcher.py PyFoamRunner.'+solver+'.logfile &'
		    else:aa='pyFoamPlotWatcher.py PyFoamRunner.'+solver+'.logfile &'
	        os.chdir(self.caseDir);os.system(aa)
	    else:
	        md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, 'solver is '+solver+'  : something is wrong')
	        md.run();md.destroy()
        #----------------------------------------------------------------------------------------------
	def closeplot():
            os.chdir(self.caseDir);os.system('pkill -9 pyFoamPlotWatch')
	#---------------------------------------------------------------------------------------------
	def saveAs():
	    GEN=generalClass(self.caseDir);clonename=GEN.saveas()
	    if clonename!='None':        
	        self.tvbox.remove(self.label);self.label=gtk.Label(clonename);self.tvbox.pack_start(self.label,False,False,5) 
	        self.window.show_all();self.caseDir=clonename
	#---------------------------------------------------------------------------------------------
	def cloneCase():
	    GEN=generalClass(self.caseDir);clonename=GEN.clone()
	    if clonename!='None':
	        self.tvbox.remove(self.label);self.label=gtk.Label(clonename);self.tvbox.pack_start(self.label,False,False,5) 
	        self.window.show_all();self.caseDir=clonename
	#---------------------------------------------------------------------------------------------
	def clearData():
	    os.system('pyFoamClearCase.py '+self.caseDir)
	#---------------------------------------------------------------------------------------------
        def paraFoam():
	    os.system('paraFoam -builtin -case '+self.caseDir+'&')
	#---------------------------------------------------------------------------------------------
        def monitoring():
	    POST=postClass(self.caseDir);POST.monitoring()
	#---------------------------------------------------------------------------------------------
        def patchIntegrate():
	    POST=postClass(self.caseDir);POST.patchIntegrate()	
	#---------------------------------------------------------------------------------------------
        def patchAverage():
	    POST=postClass(self.caseDir);POST.patchAverage()	
	#---------------------------------------------------------------------------------------------
        def probeLocation():
	    POST=postClass(self.caseDir);POST.probeLocation()	
	#---------------------------------------------------------------------------------------------
        def fieldview():
	    #f=open(self.caseDir+'/fvimsi','w')
	    #f.write('cd '+self.caseDir+'\n')
	    #f.write('touch aa.foam\n')
	    #f.write('fv -fvx /apps/fv15/fv/myfvx/offv.fvx\n')
	    #f.close()
	    #os.system('chmod +x '+self.caseDir+'/fvimsi')
	    #os.system(self.caseDir+'/fvimsi &')
	    os.system('myfv &')
	#---------------------------------------------------------------------------------------------
        def mapFields():
	    GEN=generalClass(self.caseDir);GEN.mapFields()
	#---------------------------------------------------------------------------------------------
        def setFields():
	    GEN=generalClass(self.caseDir);GEN.setFields()
	#---------------------------------------------------------------------------------------------
        def reconstructPar():
	    GEN=generalClass(self.caseDir);GEN.reconstructPar()
	#---------------------------------------------------------------------------------------------
        def settransient(widget):	    
	    slide=self.slidingCB.get_active()
	    if widget.get_active()==False:
		steadyset(self);self.timemode='Steady'
		if slide==True:self.slidingCB.set_active(0)
	    else:
		transientset(self);self.timemode='Transient'
	#---------------------------------------------------------------------------------------------
        def checkSliding(widget):
	    time=self.timeCB.get_active()
	    sol=self.solCombo.get_active()
	    if widget.get_active()==True:
		if time==False:
	            md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error!!! Current Setting is Steady")
	            md.run();md.destroy()
		    widget.set_active(0)
	#	else:
	#	    if sol==1:
	#                md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Sorry!!! nextfoam solver is not supported yet")
	#                md.run();md.destroy()
	#		self.solCombo.set_active(0)
        #----------------------------------------------------------------------------------------------
	def transientset(self):
	    self.schemeBox.remove(self.gradBox);self.schemeBox.remove(self.laplaceBox);self.schemeBox.remove(self.snBox)
	    self.schemeBox.remove(self.divUBox);self.schemeBox.remove(self.divBox)

            self.schemeBox.pack_start(self.ddtBox,False,False,2);self.schemeBox.pack_start(self.gradBox,False,False,2)
            self.schemeBox.pack_start(self.laplaceBox,False,False,2);self.schemeBox.pack_start(self.snBox,False,False,2)
            self.schemeBox.pack_start(self.divUBox,False,False,2);self.schemeBox.pack_start(self.divBox,False,False,2)

	    self.solutionBox.remove(self.pSolverBox);self.solutionBox.remove(self.USolverBox);self.solutionBox.remove(self.nonOrthoBox)
	    self.solutionBox.remove(self.resBox);self.solutionBox.remove(self.resBox1)
	    self.solutionBox.remove(self.relaxBox);self.solutionBox.remove(self.relaxBox1)

            self.solutionBox.pack_start(self.pSolverBox,False,False,5);self.solutionBox.pack_start(self.USolverBox,False,False,2)
	    self.solutionBox.pack_start(self.correctphiCB,False,False,5);self.solutionBox.pack_start(self.nOutBox,False,False,0)
            self.solutionBox.pack_start(self.nCorrBox,False,False,2);self.solutionBox.pack_start(self.nonOrthoBox,False,False,2)
            self.solutionBox.pack_start(self.relaxBox,False,False,5);self.solutionBox.pack_start(self.relaxBox1,False,False,5)

	    self.rbox.remove(self.startBox);self.rbox.remove(self.startTimeBox);self.rbox.remove(self.endTimeBox)
	    self.rbox.remove(self.writeIntervalBox);self.rbox.remove(self.purgeBox);self.rbox.remove(self.formatBox)
	    self.rbox.remove(self.precisionBox);self.rbox.remove(self.compressB);self.rbox.remove(self.potentialB)
	    self.rbox.remove(self.plotresB);self.rbox.remove(self.parBox);self.rbox.remove(self.machineBox)
	    self.rbox.remove(self.buttonBox1);self.rbox.remove(self.buttonBox2)

            self.rbox.pack_start(self.startBox,False,False,2);self.rbox.pack_start(self.startTimeBox,False,False,2)                
            self.rbox.pack_start(self.endTimeBox,False,False,2);self.rbox.pack_start(self.deltaTBox,False,False,2)
	    self.rbox.pack_start(self.adjustCB,False,False,2);self.rbox.pack_start(self.maxcoBox,False,False,2)
            self.rbox.pack_start(self.maxdtBox,False,False,2);self.rbox.pack_start(self.wcontrolBox,False,False,2)
            self.rbox.pack_start(self.writeIntervalBox,False,False,2);self.rbox.pack_start(self.purgeBox,False,False,2)                
            self.rbox.pack_start(self.formatBox,False,False,2);self.rbox.pack_start(self.precisionBox,False,False,2)                
	    self.rbox.pack_start(self.compressB,False,False,2);self.rbox.pack_start(self.potentialB,False,False,5)
	    self.rbox.pack_start(self.plotresB,False,False,2);self.rbox.pack_start(self.parBox,False,False,2)
            self.rbox.pack_start(self.machineBox,False,False,2)
	    self.rbox.pack_start(self.buttonBox1,False,False,2);self.rbox.pack_start(self.buttonBox2,False,False,2)

	    self.window.show_all()
        #----------------------------------------------------------------------------------------------
	def steadyset(self):
	    self.schemeBox.remove(self.ddtBox);self.schemeBox.remove(self.gradBox);self.schemeBox.remove(self.laplaceBox)
	    self.schemeBox.remove(self.snBox);self.schemeBox.remove(self.divUBox);self.schemeBox.remove(self.divBox)

            self.schemeBox.pack_start(self.gradBox,False,False,2);self.schemeBox.pack_start(self.laplaceBox,False,False,2)
            self.schemeBox.pack_start(self.snBox,False,False,2);self.schemeBox.pack_start(self.divUBox,False,False,2)
            self.schemeBox.pack_start(self.divBox,False,False,2)

	    self.solutionBox.remove(self.pSolverBox);self.solutionBox.remove(self.USolverBox);self.solutionBox.remove(self.correctphiCB)
	    self.solutionBox.remove(self.nOutBox);self.solutionBox.remove(self.nCorrBox);self.solutionBox.remove(self.nonOrthoBox)
	    self.solutionBox.remove(self.relaxBox);self.solutionBox.remove(self.relaxBox1)

            self.solutionBox.pack_start(self.pSolverBox,False,False,5);self.solutionBox.pack_start(self.USolverBox,False,False,2)
            self.solutionBox.pack_start(self.nonOrthoBox,False,False,2)
	    self.solutionBox.pack_start(self.resBox,False,False,5);self.solutionBox.pack_start(self.resBox1,False,False,5)
	    self.solutionBox.pack_start(self.relaxBox,False,False,5);self.solutionBox.pack_start(self.relaxBox1,False,False,5)

	    self.rbox.remove(self.startBox);self.rbox.remove(self.startTimeBox);self.rbox.remove(self.endTimeBox)
	    self.rbox.remove(self.deltaTBox);self.rbox.remove(self.adjustCB);self.rbox.remove(self.maxcoBox)
	    self.rbox.remove(self.maxdtBox);self.rbox.remove(self.wcontrolBox);self.rbox.remove(self.writeIntervalBox)
	    self.rbox.remove(self.purgeBox);self.rbox.remove(self.formatBox);self.rbox.remove(self.precisionBox)
	    self.rbox.remove(self.compressB);self.rbox.remove(self.potentialB);self.rbox.remove(self.plotresB)
	    self.rbox.remove(self.parBox);self.rbox.remove(self.machineBox)
	    self.rbox.remove(self.buttonBox1);self.rbox.remove(self.buttonBox2)

            self.rbox.pack_start(self.startBox,False,False,2);self.rbox.pack_start(self.startTimeBox,False,False,2)                
            self.rbox.pack_start(self.endTimeBox,False,False,2);self.rbox.pack_start(self.writeIntervalBox,False,False,2)                
            self.rbox.pack_start(self.purgeBox,False,False,2);self.rbox.pack_start(self.formatBox,False,False,2)                
            self.rbox.pack_start(self.precisionBox,False,False,2);self.rbox.pack_start(self.compressB,False,False,2)
	    self.rbox.pack_start(self.potentialB,False,False,2);self.rbox.pack_start(self.plotresB,False,False,2)
            self.rbox.pack_start(self.parBox,False,False,2);self.rbox.pack_start(self.machineBox,False,False,2)                
            self.rbox.pack_start(self.buttonBox1,False,False,2);self.rbox.pack_start(self.buttonBox2,False,False,2)

	    self.window.show_all()
        #----------------------------------------------------------------------------------------------
	def edit_controlDict():os.system('gedit '+self.caseDir+'/system/controlDict &')
	def edit_fvSolution():os.system('gedit '+self.caseDir+'/system/fvSolution &')
	def edit_fvSchemes():os.system('gedit '+self.caseDir+'/system/fvSchemes &')
	def edit_fvOptions():os.system('gedit '+self.caseDir+'/system/fvOptions &')
	def edit_RASProperties():os.system('gedit '+self.caseDir+'/constant/RASProperties &')
	def edit_transportProperties():os.system('gedit '+self.caseDir+'/constant/transportProperties &')
	def edit_U():os.system('gedit '+self.caseDir+'/0/U &')
	def edit_p():os.system('gedit '+self.caseDir+'/0/p &')
	def edit_k():os.system('gedit '+self.caseDir+'/0/k &')
	def edit_epsilon():os.system('gedit '+self.caseDir+'/0/epsilon &')
	def edit_omega():os.system('gedit '+self.caseDir+'/0/omega &')
        #------------------------------------------------------------------------------------------
	def killjob():
	    GEN=generalClass(self.caseDir);GEN.killJob()
	def caseReport():
	    GEN=generalClass(self.caseDir);GEN.caseReport()	    
	def caseReportToPdf():
	    GEN=generalClass(self.caseDir);GEN.caseReportToPdf()
	def caseReportToTex():
	    GEN=generalClass(self.caseDir);GEN.caseReportToTex()
	def usersGuide():
	    os.system('evince '+self.installpath+'/Baram-v1.0_usersGuid.pdf &')
	def exit():
	    self.window.destroy()
            gtk.main_quit()
	#-----------------------------------------------------------------------------------------------
	def chsolver(widget):
	    stdModels=['kEpsilon','realizableKE','RNGkEpsilon','kOmegaSST','kOmega','laminar'] 
	    nfModels=['standardKEpsilon','realizableKEpsilon','renormalizationGroupKEpsilon','shearStressTransportKOmega'] 
	    newsolver=widget.get_active()
	    oldmodel=self.turCombo.get_active()
	    self.turbox.remove(self.turlabel);self.turbox.remove(self.turCombo)
	    if newsolver==0:
        	self.turCombo=gtk.combo_box_entry_new_text()
		for ii in stdModels:self.turCombo.append_text(ii)
		if oldmodel < 6:self.turCombo.set_active(oldmodel)
		else:self.turCombo.set_active(0)
		self.turCombo.set_size_request(140,28)
		self.turbox.pack_start(self.turlabel,False,False,5);self.turbox.pack_end(self.turCombo,False,False,5)
	    else:
        	self.turCombo=gtk.combo_box_entry_new_text()
		for ii in stdModels:self.turCombo.append_text(ii)
		for ii in nfModels:self.turCombo.append_text(ii)
		self.turCombo.set_active(oldmodel);self.turCombo.set_size_request(140,28)
		self.turbox.pack_start(self.turlabel,False,False,5);self.turbox.pack_end(self.turCombo,False,False,5)
	    self.window.show_all()
	#-----------------------------------------------------------------------------------------------
	def chtur(widget):
	    aa=widget.child;turmod=aa.get_text()
	    bb=self.solCombo.child;solv=bb.get_text()
	    if turmod=='standardKEpsilon' or turmod=='realizableKEpsilon' or turmod=='renormalizationGroupKEpsilon' or turmod=='shearStressTransportKOmega':
		if solv=='standard solver':
		    md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,turmod+" Cannot used with standard solver!")
		    md.run();md.destroy()
		    widget.set_active(0)
        #----------------------------------------------------------------------------------------------
	def save():

	    aa=self.solCombo.child;solverType=aa.get_text()

	    aa=glob.glob(self.caseDir+'/temporary/hostfile')
	    if len(aa)==0:hostfilename='None'
	    else:
		f=open(self.caseDir+'/temporary/hostfile','r');hostfilename=f.readline();f.close()

	    if self.timeCB.get_active()==True:transientmode='yes'
	    else:transientmode='no'
	    if self.slidingCB.get_active()==True:smmode='yes'
	    else:smmode='no'	    
	    viscosity=self.visEntry.get_text();density=self.rhoEntry.get_text()
	    aa=self.turCombo.child;turbulenceModel=aa.get_text()
	    f=open(self.caseDir+'/temporary/generalConditions','w')
	    f.write(viscosity+'\n');f.write(density+'\n');f.write(turbulenceModel+'\n')
	    f.write(transientmode+'\n');f.write(smmode+'\n');f.write(solverType+'\n')
	    f.close()

	    s1=self.startCombo.child;startFrom=s1.get_text()
	    startTime=self.startTimeEntry.get_text();stopAt='endTime'
	    endTime=self.endTimeEntry.get_text();timeStepSize=self.deltaTEntry.get_text()
	    adj=self.adjustCB.get_active()
	    if adj==True:adjustTimeStep='yes'
	    else:adjustTimeStep='no'
	    maxco=self.maxcoEntry.get_text();maxdt=self.maxdtEntry.get_text()
	    aa=self.wcontrolCombo.child;wcontrol=aa.get_text()
	    writeInterval=self.writeIntervalEntry.get_text();purgeWrite=self.purgeEntry.get_text()
	    aa=self.formatCombo.child;writeFormat=aa.get_text();writePrecision=self.precisionEntry.get_text()
	    compress=self.compressB.get_active()
	    if compress==True:writeCompression='compressed'
	    else:writeCompression='uncompressed'
	    nCore=self.nparEntry.get_text();aa=self.machineCombo.child;smpOrCluster=aa.get_text();hostfile=hostfilename
	    if self.potentialB.get_active()==True:potential='yes'
	    else:potential='no'
	    if self.plotresB.get_active()==True:plotresidual='yes'
	    else:plotresidual='no'	
	    f=open(self.caseDir+'/temporary/runCondition','w')
	    f.write(startFrom+'\n');f.write(startTime+'\n');f.write(endTime+'\n');f.write(timeStepSize+'\n')
	    f.write(adjustTimeStep+'\n');f.write(maxco+'\n');f.write(maxdt+'\n');f.write(wcontrol+'\n');f.write(writeInterval+'\n')
	    f.write(purgeWrite+'\n');f.write(writeFormat+'\n');f.write(writePrecision+'\n');f.write(writeCompression+'\n')
	    f.write(plotresidual+'\n');f.write(nCore+'\n');f.write(smpOrCluster+'\n');f.write(hostfile+'\n');f.write(potential+'\n');f.close()

	    aa=self.ddtCombo.child;ddt=aa.get_text()
	    a1=self.gradCombo.child;grad=a1.get_text();a2=self.laplaceCombo.child;laplace=a2.get_text()
	    a4=self.snCombo.child;snGrad=a4.get_text();a5=self.divUCombo.child;divU=a5.get_text();a6=self.divCombo.child;divTur=a6.get_text()
	    b1=self.pSolverCombo.child;pSolver=b1.get_text();b2=self.USolverCombo.child;USolver=b2.get_text()
	    cor=self.correctphiCB.get_active()
	    if cor==True:corrphi='yes'
	    else:corrphi='no'
	    nout=self.nOutEntry.get_text();ncorr=self.nCorrEntry.get_text()
	    nonOrtho=self.nonOrthoEntry.get_text()
	    resp=self.respEntry.get_text();resU=self.resUEntry.get_text();restur=self.resturEntry.get_text()
	    relaxp=self.relaxpEntry.get_text();relaxU=self.relaxUEntry.get_text();relaxtur=self.relaxturEntry.get_text()
	    f=open(self.caseDir+'/temporary/numerics','w')
	    f.write(ddt+'\n');f.write(grad+'\n');f.write(laplace+'\n');f.write(snGrad+'\n');f.write(divU+'\n');f.write(divTur+'\n')
	    f.write(pSolver+'\n');f.write(USolver+'\n');f.write(corrphi+'\n');f.write(nout+'\n');f.write(ncorr+'\n')
	    f.write(nonOrtho+'\n')
	    f.write(resp+'\n');f.write(resU+'\n');f.write(restur+'\n')
	    f.write(relaxp+'\n');f.write(relaxU+'\n');f.write(relaxtur+'\n');f.close()

	    in1=[viscosity,density,turbulenceModel]
	    in2=[startFrom,startTime,stopAt,endTime,timeStepSize,adjustTimeStep,maxco,maxdt,wcontrol,writeInterval,purgeWrite,writeFormat,
		writePrecision,writeCompression,nCore,smpOrCluster,hostfile,plotresidual,potential]
	    in3=[ddt,grad,laplace,snGrad,divU,divTur,pSolver,USolver,corrphi,nout,ncorr,nonOrtho,resp,resU,restur,relaxp,relaxU,relaxtur]

	    saved=[in1,in2,in3]

	    return saved
        #----------------------------------------------------------------------------------------------
        def setValue():

	    aa=glob.glob(self.caseDir+'/temporary/generalConditions')
	    if len(aa)!=0:
	        ss=open(self.caseDir+'/temporary/generalConditions','r');sss=ss.readlines();ss.close()
		self.visEntry.set_text(sss[0][:-1]);self.rhoEntry.set_text(sss[1][:-1])		
		aa=self.turModels.index(sss[2][:-1]);self.turCombo.set_active(aa)
		if sss[3][:-1]=='yes':self.timeCB.set_active(1)
		else:self.timeCB.set_active(0)
		if sss[4][:-1]=='yes':self.slidingCB.set_active(1)
		else:self.slidingCB.set_active(0)
		if sss[5][:-1]=='standard solver':self.solCombo.set_active(0)
		else:self.solCombo.set_active(1)

	    aa=glob.glob(self.caseDir+'/temporary/numerics')
	    if len(aa)!=0:
	        ss=open(self.caseDir+'/temporary/numerics','r');sss=ss.readlines();ss.close()
	        ddt=sss[0][:-1];grad=sss[1][:-1];laplace=sss[2][:-1];snGrad=sss[3][:-1];divU=sss[4][:-1];divTur=sss[5][:-1]
	        pSolver=sss[6][:-1];USolver=sss[7][:-1];corrphi=sss[8][:-1];nout=sss[9][:-1];ncorr=sss[10][:-1];
		nonOrtho=sss[11][:-1]
		resp=sss[12][:-1];resU=sss[13][:-1];restur=sss[14][:-1]
		relaxp=sss[15][:-1];relaxU=sss[16][:-1];relaxtur=sss[17][:-1]
		if self.timemode=='Transient':
		    self.ddtCombo.set_active(ddtList.index(ddt))
	        self.gradCombo.set_active(gradient.index(grad));self.laplaceCombo.set_active(laplacian.index(laplace))
		self.snCombo.set_active(snGradient.index(snGrad))
	        self.divUCombo.set_active(divergenceU.index(divU));self.divCombo.set_active(divergence.index(divTur))
	        self.pSolverCombo.set_active(pSolverList.index(pSolver));self.USolverCombo.set_active(USolverList.index(USolver))
		if self.timemode=='Transient':
		    if corrphi=='yes':self.correctphiCB.set_active(1)
		    else:self.correctphiCB.set_active(0)
		    self.nOutEntry.set_text(nout);self.nCorrEntry.set_text(ncorr);self.nonOrthoEntry.set_text(nonOrtho)
	            self.respEntry.set_text(resp);self.resUEntry.set_text(resU);self.resturEntry.set_text(restur)
	            self.relaxpEntry.set_text(relaxp);self.relaxUEntry.set_text(relaxU);self.relaxturEntry.set_text(relaxtur)

	    aa=glob.glob(self.caseDir+'/temporary/runCondition')
	    if len(aa)!=0:
	        ss=open(self.caseDir+'/temporary/runCondition','r');sss=ss.readlines();ss.close()		
		if sss[0][:-1]=='startTime':self.startCombo.set_active(0)
		else:self.startCombo.set_active(1)
		self.startTimeEntry.set_text(sss[1][:-1]);self.endTimeEntry.set_text(sss[2][:-1])
		if self.timemode=='Transient':
		    self.deltaTEntry.set_text(sss[3][:-1])
		    if sss[4][:-1]=='no':self.adjustCB.set_active(0)
		    else:self.adjustCB.set_active(1)	
		    self.maxcoEntry.set_text(sss[5][:-1]);self.maxdtEntry.set_text(sss[6][:-1])
		    self.wcontrolCombo.set_active(wcontrol.index(sss[7][:-1]))
		self.writeIntervalEntry.set_text(sss[8][:-1]);self.purgeEntry.set_text(sss[9][:-1])
		if sss[10][:-1]=='ascii':self.formatCombo.set_active(0)
		else:self.formatCombo.set_active(1)
		self.precisionEntry.set_text(sss[11][:-1])
		if sss[12][:-1]=='uncompressed':self.compressB.set_active(0)
		else:self.compressB.set_active(1)
		if sss[13][:-1]=='yes':self.plotresB.set_active(1)
		else:self.plotresB.set_active(0)
		#self.nparEntry.set_text(sss[14][:-1])
		#if sss[15][:-1]=='SMP':self.machineCombo.set_active(0)
		#else:self.machineCombo.set_active(1)
		if sss[17][:-1]=='yes':self.potentialB.set_active(1)
		else:self.potentialB.set_active(0)
        #------------------------------------------------------------------------------------------
	def chmachine(widget):
	    machinetype=widget.get_active()
	    if machinetype==1:
		if self.nparEntry.get_text()!='1':selhostfile()
		else:
		    md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"Error! No. of cores is 1")
		    md.run();md.destroy()
		    widget.set_active(0)
	    else:pass
        #------------------------------------------------------------------------------------------
        def menuitem_response(widget,string):
            if string=='Save':save()
            elif string=='Save As':saveAs() 
	    elif string=='Clone Case':cloneCase()
	    elif string=='Clear Data':clearData()
	    elif string=='reconstructPar':reconstructPar()
	    elif string=='Exit':exit()
	    elif string=='Scale mesh':scaleMesh()
	    elif string=='Translate mesh':translateMesh()
	    elif string=='Monitoring':monitoring()
	    elif string=='Force report':openForce()
	    elif string=='probeLocation':probeLocation()
	    elif string=='patchIntegrate':patchIntegrate()
	    elif string=='patchAverage':patchAverage()
	    elif string=='Fieldview':fieldview()
	    elif string=='Plot residual':resplot()
	    elif string=='Close residual':closeplot()
	    elif string=='mapFields':mapFields()
	    elif string=='setFields':setFields()
	    elif string=='controlDict':edit_controlDict()
	    elif string=='fvSolution':edit_fvSolution()
	    elif string=='fvSchemes':edit_fvSchemes()
	    elif string=='fvOptions':edit_fvOptions()
	    elif string=='RASProperties':edit_RASProperties()
	    elif string=='transportProperties':edit_transportProperties()
	    elif string=='U':edit_U()
	    elif string=='p':edit_p()
	    elif string=='k':edit_k()
	    elif string=='epsilon':edit_epsilon()
	    elif string=='omega':edit_omega()
	    #elif string=='just run':justRun()
	    elif string=='kill-job':killjob()
	    elif string=='caseReport':caseReport()
	    elif string=='createPdf':caseReportToPdf()
	    elif string=='createTex':caseReportToTex()
	    elif string=='users guide':usersGuide()
        #--- create menu -------------------------------------------------------------------------------------    
	#sep=gtk.SeparatorMenuItem()
        self.fmenu=gtk.Menu();files=['Save','Save As','Clone Case','Clear Data','reconstructPar','Exit']
        for i in range(len(files)):
            self.mi=gtk.MenuItem(files[i]);self.fmenu.append(self.mi);self.mi.connect('activate',menuitem_response,files[i])
        self.mmenu=gtk.Menu();meshes=['Scale mesh','Translate mesh']
        for i in range(len(meshes)):
            self.mi=gtk.MenuItem(meshes[i]);self.mmenu.append(self.mi);self.mi.connect('activate',menuitem_response,meshes[i])
        self.pmenu=gtk.Menu();posts=['Monitoring','Force report','probeLocation','patchIntegrate','patchAverage','Fieldview','Plot residual','Close residual']
        for i in range(len(posts)):
            self.mi=gtk.MenuItem(posts[i]);self.pmenu.append(self.mi);self.mi.connect('activate',menuitem_response,posts[i])
        self.edmenu=gtk.Menu();filess=['controlDict','fvSolution','fvSchemes','fvOptions','RASProperties','transportProperties','U','p','k','epsilon','omega']
        for i in range(len(filess)):
            self.mi=gtk.MenuItem(filess[i]);self.edmenu.append(self.mi);self.mi.connect('activate',menuitem_response,filess[i])
        self.kmenu=gtk.Menu();kills=['kill-job']
        for i in range(len(kills)):
            self.mi=gtk.MenuItem(kills[i]);self.kmenu.append(self.mi);self.mi.connect('activate',menuitem_response,kills[i])
        self.fimenu=gtk.Menu();fields=['mapFields','setFields']
        for i in range(len(fields)):
            self.mi=gtk.MenuItem(fields[i]);self.fimenu.append(self.mi);self.mi.connect('activate',menuitem_response,fields[i])
        self.remenu=gtk.Menu();report=['caseReport','createPdf','createTex']
        for i in range(len(report)):
            self.mi=gtk.MenuItem(report[i]);self.remenu.append(self.mi);self.mi.connect('activate',menuitem_response,report[i])
        self.hmenu=gtk.Menu();help=['users guide']
        for i in range(len(help)):
            self.mi=gtk.MenuItem(help[i]);self.hmenu.append(self.mi);self.mi.connect('activate',menuitem_response,help[i])

        self.filemenu=gtk.MenuItem('File  ');self.filemenu.set_submenu(self.fmenu)
        self.meshmenu=gtk.MenuItem('Mesh  ');self.meshmenu.set_submenu(self.mmenu)
        self.postmenu=gtk.MenuItem('PostProcessing  ');self.postmenu.set_submenu(self.pmenu)
        self.editmenu=gtk.MenuItem('ViewFile  ');self.editmenu.set_submenu(self.edmenu)
        self.killmenu=gtk.MenuItem('Kill-job  ');self.killmenu.set_submenu(self.kmenu)
        self.fieldmenu=gtk.MenuItem('Fields  ');self.fieldmenu.set_submenu(self.fimenu)
        self.reportmenu=gtk.MenuItem('Report  ');self.reportmenu.set_submenu(self.remenu)
        self.helpmenu=gtk.MenuItem('Help  ');self.helpmenu.set_submenu(self.hmenu)

	self.mb.append(self.filemenu);self.mb.append(self.meshmenu);self.mb.append(self.postmenu);self.mb.append(self.fieldmenu)
	self.mb.append(self.reportmenu);self.mb.append(self.editmenu);self.mb.append(self.killmenu);self.mb.append(self.helpmenu)	
        #--- create toolbar------------------------------------------------------------------------------------
        self.toolbox=gtk.HBox(False,5);self.handlebox=gtk.HandleBox();self.toolbarbox.pack_start(self.toolbox,True,True,0)
        self.toolbox.pack_start(self.handlebox,True,True,0)
        self.toolbar=gtk.Toolbar();self.toolbar.set_orientation(gtk.ORIENTATION_HORIZONTAL)
        self.toolbar.set_style(gtk.TOOLBAR_BOTH);self.toolbar.set_border_width(0)
        self.handlebox.add(self.toolbar)

        def tnew(widget,date=None):newcase()
        def topen(widget,date=None):readcase()
        def tpara(widget,data=None):paraFoam()

        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/new.gif")
        self.toolbar.append_item(None,'New Simulation','Private',self.iconw,tnew)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/open1.png")
        self.toolbar.append_item(None,'Open Simulation','Private',self.iconw,topen)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/para.jpg")
        self.toolbar.append_item(None,'ParaFoam','Private',self.iconw,tpara)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/close.png")
        self.toolbar.append_item(None,'Closes this app','Private',self.iconw,self.destroy)

        logo = gtk.Image();logo.set_from_file(self.installpath+"/logo.png")	
	self.logobox.pack_end(logo,True,True,5)
        #----------------------------------------------------------------------------------------------------#
	#   MAIN GUI 											     #
        #----------------------------------------------------------------------------------------------------#
	if self.caseDir!='None':setfolder()
	#---- mesh box----------------------------------------------------------------------------------------
        self.meshframe=gtk.Frame();self.meshframe.set_label(' Mesh Setup ');self.meshframe.set_label_align(0.1, 0.5)
        self.meshframe.set_shadow_type(gtk.SHADOW_IN)
	self.meshbox.pack_start(self.meshframe,True,True,5)

	self.mhbox=gtk.HBox(True,5);self.meshframe.add(self.mhbox)	
	self.mbox=gtk.VBox(False,5);self.mhbox.pack_start(self.mbox,False,False,5)

        self.importB=gtk.Button(label=' import mesh ');self.importB.set_size_request(60,28);self.importB.connect('clicked',importmesh)	
	self.mbox.pack_start(self.importB,False,False,5)

        self.readB=gtk.Button(label=' read mesh ');self.readB.set_size_request(60,28);self.readB.connect('clicked',readMesh)    
	self.mbox.pack_start(self.readB,False,False,5)
        
        self.checkB=gtk.Button(label='check mesh');self.checkB.connect('clicked',checkMesh)
	self.mbox.pack_start(self.checkB,False,False,5)

        self.baffleB=gtk.Button(label='create baffle');self.baffleB.connect('clicked',createBaffle)
	self.mbox.pack_start(self.baffleB,False,False,5)

        self.interfaceB=gtk.Button(label='create interface');self.interfaceB.connect('clicked',createInterface)
	self.mbox.pack_start(self.interfaceB,False,False,5)

        self.interiorB=gtk.Button(label=' create interior patch ');self.interiorB.connect('clicked',createInterior)
	self.mbox.pack_start(self.interiorB,False,False,5)

        self.cyclicB=gtk.Button(label='  create cyclic condition  ');self.cyclicB.connect('clicked',createCyclicAMI)
	self.mbox.pack_start(self.cyclicB,False,False,5)

        self.btypeB=gtk.Button(label='boundary type');self.btypeB.connect('clicked',boundarySet)
	self.mbox.pack_start(self.btypeB,False,False,5)
	#---- general box----------------------------------------------------------------------------------------
        self.generalframe=gtk.Frame();self.generalframe.set_label(' General Conditions ');self.generalframe.set_label_align(0.1, 0.5)
        self.generalframe.set_shadow_type(gtk.SHADOW_IN);self.generalbox.pack_start(self.generalframe,True,True,5)
	
	self.ghbox=gtk.HBox(True,5);self.generalframe.add(self.ghbox)
	self.gbox=gtk.VBox(False,5);self.ghbox.pack_start(self.gbox,False,False,5)

	self.label=gtk.Label('Solver')
        self.solCombo=gtk.combo_box_entry_new_text();self.solCombo.set_size_request(150,28)
	soltype=['standard solver','nextfoam solver'] 
	for ii in soltype:self.solCombo.append_text(ii)
	self.solCombo.set_active(1);self.solCombo.connect('changed',chsolver)
	self.solbox=gtk.HBox(False,5);self.gbox.pack_start(self.solbox,False,False,5)
	self.solbox.pack_start(self.label,False,False,5);self.solbox.pack_end(self.solCombo,False,False,5)

	self.timeCB=gtk.CheckButton('transient');self.slidingCB=gtk.CheckButton('Sliding-mesh')
	self.timeCB.connect('toggled',settransient);self.slidingCB.connect('toggled',checkSliding)
	self.timebox=gtk.HBox(False,5);self.gbox.pack_start(self.timebox,False,False,5)
	self.timebox.pack_start(self.timeCB,True,True,5);self.timebox.pack_end(self.slidingCB,True,True,5)

	self.label=gtk.Label('mu [kg/ms]')
	self.visEntry=gtk.Entry();self.visEntry.set_size_request(100,28);self.visEntry.set_text('1e-5')
	self.vbox1_h21=gtk.HBox(False,5);self.gbox.pack_start(self.vbox1_h21,False,False,5)
	self.vbox1_h21.pack_start(self.label,False,False,5);self.vbox1_h21.pack_end(self.visEntry,False,False,5)

	self.label=gtk.Label('Density [kg/m3] ')
	self.rhoEntry=gtk.Entry();self.rhoEntry.set_size_request(100,28);self.rhoEntry.set_text('1.2')
	self.vbox1_h22=gtk.HBox(False,5);self.gbox.pack_start(self.vbox1_h22,False,False,5)
	self.vbox1_h22.pack_start(self.label,False,False,5);self.vbox1_h22.pack_end(self.rhoEntry,False,False,5)

	self.turlabel=gtk.Label('Tur. Model')
        self.turCombo=gtk.combo_box_entry_new_text();self.turCombo.set_size_request(140,28)
	self.turModels=['kEpsilon','realizableKE','RNGkEpsilon','kOmegaSST','kOmega','laminar','standardKEpsilon','realizableKEpsilon',
		  'renormalizationGroupKEpsilon','shearStressTransportKOmega'] 
	for models in self.turModels:self.turCombo.append_text(models)
	self.turCombo.set_active(0);self.turCombo.connect('changed',chtur)
	self.turbox=gtk.HBox(False,5);self.gbox.pack_start(self.turbox,False,False,5)
	self.turbox.pack_start(self.turlabel,False,False,5);self.turbox.pack_end(self.turCombo,False,False,5)
	#----------------------------------
        self.frame2=gtk.Frame();self.frame2.set_label('  Boundary Condition  ');self.frame2.set_label_align(0.5, 0.5)
        self.frame2.set_shadow_type(gtk.SHADOW_ETCHED_OUT);self.gbox.pack_start(self.frame2,False,False,5)

	self.vbox2=gtk.VBox(False,5);self.frame2.add(self.vbox2)

	self.flowBCB=gtk.Button('Flow / Pressure condition');self.flowBCB.connect('clicked',openFlowBCWindow)
        self.flowbcbox=gtk.HBox(False,5);self.vbox2.pack_start(self.flowbcbox,False,False,5)
	self.flowbcbox.pack_start(self.flowBCB,True,True,5)
	self.turBCB=gtk.Button(' Turbulence condition ');self.turBCB.connect('clicked',openTurBCWindow)
        self.turbcbox=gtk.HBox(False,5);self.vbox2.pack_start(self.turbcbox,False,False,5)
	self.turbcbox.pack_start(self.turBCB,True,True,5)

	self.porousjumpB=gtk.Button('Set PorousJump');self.porousjumpB.connect('clicked',openPorousJump)
	self.vbox2_h2=gtk.HBox(False,5);self.vbox2.pack_start(self.vbox2_h2,False,False,5)
	self.vbox2_h2.pack_start(self.porousjumpB,True,True,5)
	#-------------------------------
	self.cellzoneB=gtk.Button(' Cell Zone Conditions ');self.cellzoneB.connect('clicked',openCellZoneWindow)
	self.cellzonebox=gtk.HBox(False,5);self.gbox.pack_start(self.cellzonebox,False,False,5)
	self.cellzonebox.pack_start(self.cellzoneB,True,True,5)
	#---- numeric box----------------------------------------------------------------------------------------
        self.numericframe=gtk.Frame();self.numericframe.set_label(' Numerical Conditions ');self.numericframe.set_label_align(0.1, 0.5)
        self.numericframe.set_shadow_type(gtk.SHADOW_IN);self.numericbox.pack_start(self.numericframe,True,True,5)
	
	self.nhbox=gtk.HBox(True,5);self.numericframe.add(self.nhbox)
	self.nbox=gtk.VBox(False,5);self.nhbox.pack_start(self.nbox,False,False,5)

        self.schemeBox=gtk.VBox(False,5);self.solutionBox=gtk.VBox(False,5)
        self.schemeFrame=gtk.Frame()
        self.schemeFrame.set_label('  fvScheme setup  ');self.schemeFrame.set_label_align(0.5,0.5)
        self.schemeFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.solutionFrame=gtk.Frame()
        self.solutionFrame.set_label('  fvSolution setup  ');self.solutionFrame.set_label_align(0.5,0.5)
        self.solutionFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        
        self.nbox.pack_start(self.schemeFrame,False,False,5);self.nbox.pack_start(self.solutionFrame,False,False,5)        
        self.schemeFrame.add(self.schemeBox);self.solutionFrame.add(self.solutionBox)

        self.ddtlabel=gtk.Label('time')
        self.ddtCombo=gtk.combo_box_entry_new_text();self.ddtCombo.set_size_request(160,28)
        ddtList=['Euler','backward']
        for ii in ddtList:self.ddtCombo.append_text(ii)        

        self.gradlabel=gtk.Label('gradient')
        self.gradCombo=gtk.combo_box_entry_new_text();self.gradCombo.set_size_request(160,28)
        gradient=['Gauss linear','leastSquares','cellLimited Gauss linear 1']
        for i in range(len(gradient)):self.gradCombo.append_text(gradient[i])                

        self.laplabel=gtk.Label('laplacian')
        self.laplaceCombo=gtk.combo_box_entry_new_text();self.laplaceCombo.set_size_request(160,28)
        laplacian=['Gauss linear corrected','Gauss linear limited 0.5','Gauss linear limited 0.333']
        for i in range(len(laplacian)):self.laplaceCombo.append_text(laplacian[i])               
       
        self.snlabel=gtk.Label('snGradient')
        self.snCombo=gtk.combo_box_entry_new_text();self.snCombo.set_size_request(160,28)
        snGradient=['corrected','limited 0.5','limited 0.333']
        for i in range(len(snGradient)):self.snCombo.append_text(snGradient[i])

        self.divulabel=gtk.Label('div. U')
        self.divUCombo=gtk.combo_box_entry_new_text();self.divUCombo.set_size_request(160,28)
        divergenceU=['upwind','linearUpwindV Gauss linear','limitedLinearV 1','linearUpwindV cellLimited Gauss linear 1']
        for i in range(len(divergenceU)):self.divUCombo.append_text(divergenceU[i])               

        self.divturlabel=gtk.Label('div. tur.')
        self.divCombo=gtk.combo_box_entry_new_text();self.divCombo.set_size_request(160,28)
        divergence=['upwind','linearUpwind Gauss linear','limitedLinear 1','linearUpwind cellLimited Gauss linear 1']
        for i in range(len(divergence)):self.divCombo.append_text(divergence[i])                

        self.ddtBox=gtk.HBox(False,5)
	self.ddtBox.pack_start(self.ddtlabel,False,False,5);self.ddtBox.pack_end(self.ddtCombo,False,False,5)
	if self.timemode=='Transient':self.schemeBox.pack_start(self.ddtBox,False,False,2)
        self.gradBox=gtk.HBox(False,5);self.schemeBox.pack_start(self.gradBox,False,False,2)
	self.gradBox.pack_start(self.gradlabel,False,False,5);self.gradBox.pack_end(self.gradCombo,False,False,5)
        self.laplaceBox=gtk.HBox(False,5);self.schemeBox.pack_start(self.laplaceBox,False,False,2)
	self.laplaceBox.pack_start(self.laplabel,False,False,5);self.laplaceBox.pack_end(self.laplaceCombo,False,False,5)  
        self.snBox=gtk.HBox(False,5);self.schemeBox.pack_start(self.snBox,False,False,2)
	self.snBox.pack_start(self.snlabel,False,False,5);self.snBox.pack_end(self.snCombo,False,False,5)  
        self.divUBox=gtk.HBox(False,5);self.schemeBox.pack_start(self.divUBox,False,False,2)
	self.divUBox.pack_start(self.divulabel,False,False,5);self.divUBox.pack_end(self.divUCombo,False,False,5)
        self.divBox=gtk.HBox(False,5);self.schemeBox.pack_start(self.divBox,False,False,2)
	self.divBox.pack_start(self.divturlabel,False,False,5);self.divBox.pack_end(self.divCombo,False,False,5)
	#------------------------------------------------
        self.psolverlabel=gtk.Label('pSolver')
        self.pSolverCombo=gtk.combo_box_entry_new_text();self.pSolverCombo.set_size_request(160,28)
        pSolverList=['GAMG','PCG']
        for i in range(len(pSolverList)):self.pSolverCombo.append_text(pSolverList[i])          

        self.usolverlabel=gtk.Label('USolver')
        self.USolverCombo=gtk.combo_box_entry_new_text();self.USolverCombo.set_size_request(160,28)
        USolverList=['smoothSolver','PBiCG']
        for i in range(len(USolverList)):self.USolverCombo.append_text(USolverList[i])          

        self.correctphiCB=gtk.CheckButton('correctPhi')

        self.noutlabel=gtk.Label('nOuterCorrectors');self.nOutEntry=gtk.Entry();self.nOutEntry.set_size_request(60,28)            

        self.ncorrlabel=gtk.Label('nCorrectors');self.nCorrEntry=gtk.Entry();self.nCorrEntry.set_size_request(60,28)    
        
        self.ortholabel=gtk.Label('non-Ortho.Correctors');self.nonOrthoEntry=gtk.Entry();self.nonOrthoEntry.set_size_request(60,28)    

        self.label=gtk.Label('converge criteria: p|U|tur.')
	self.respEntry=gtk.Entry();self.resUEntry=gtk.Entry();self.resturEntry=gtk.Entry()
	self.respEntry.set_size_request(70,28);self.resUEntry.set_size_request(70,28);self.resturEntry.set_size_request(70,28)

        self.relaxlabel=gtk.Label('relaxation factor: p|U|tur.')
	self.relaxpEntry=gtk.Entry();self.relaxUEntry=gtk.Entry();self.relaxturEntry=gtk.Entry()
	self.relaxpEntry.set_size_request(70,28);self.relaxUEntry.set_size_request(70,28);self.relaxturEntry.set_size_request(70,28)        

	self.ddtCombo.set_active(0);self.gradCombo.set_active(0);self.laplaceCombo.set_active(0)
	self.snCombo.set_active(0);self.divUCombo.set_active(0);self.divCombo.set_active(0)
        self.pSolverCombo.set_active(0);self.USolverCombo.set_active(0)
	self.correctphiCB.set_active(0)
	self.nOutEntry.set_text('3');self.nCorrEntry.set_text('3');self.nonOrthoEntry.set_text('0')  
	self.respEntry.set_text('1e-3');self.resUEntry.set_text('1e-3');self.resturEntry.set_text('1e-3')   
	self.relaxpEntry.set_text('0.3');self.relaxUEntry.set_text('0.7');self.relaxturEntry.set_text('0.7')

        self.pSolverBox=gtk.HBox(False,5);self.solutionBox.pack_start(self.pSolverBox,False,False,5)
	self.pSolverBox.pack_start(self.psolverlabel,False,False,5);self.pSolverBox.pack_end(self.pSolverCombo,False,False,5)
        self.USolverBox=gtk.HBox(False,5);self.solutionBox.pack_start(self.USolverBox,False,False,2)
	self.USolverBox.pack_start(self.usolverlabel,False,False,5);self.USolverBox.pack_end(self.USolverCombo,False,False,5)
        self.nOutBox=gtk.HBox(False,5)
	self.nOutBox.pack_start(self.noutlabel,False,False,5);self.nOutBox.pack_end(self.nOutEntry,False,False,5)
        self.nCorrBox=gtk.HBox(False,5)
	self.nCorrBox.pack_start(self.ncorrlabel,False,False,5);self.nCorrBox.pack_end(self.nCorrEntry,False,False,5)
	if self.timemode=='Transient':
	    self.solutionBox.pack_start(self.correctphiCB,False,False,5)
	    self.solutionBox.pack_start(self.nOutBox,False,False,0)
	    self.solutionBox.pack_start(self.nCorrBox,False,False,2)
        self.nonOrthoBox=gtk.HBox(False,5);self.solutionBox.pack_start(self.nonOrthoBox,False,False,2)
	self.nonOrthoBox.pack_start(self.ortholabel,False,False,5);self.nonOrthoBox.pack_end(self.nonOrthoEntry,False,False,5)

        self.resBox=gtk.HBox(False,5);self.resBox1=gtk.HBox(False,5)
	self.resBox.pack_start(self.label,False,False,5)
	self.resBox1.pack_end(self.resturEntry,False,False,5)
        self.resBox1.pack_end(self.resUEntry,False,False,2);self.resBox1.pack_end(self.respEntry,False,False,5)
	if self.timemode=='Steady':
            self.solutionBox.pack_start(self.resBox,False,False,5);self.solutionBox.pack_start(self.resBox1,False,False,5)

	self.relaxBox=gtk.HBox(False,5);self.relaxBox1=gtk.HBox(False,5)
        self.solutionBox.pack_start(self.relaxBox,False,False,5);self.solutionBox.pack_start(self.relaxBox1,False,False,5)
	self.relaxBox.pack_start(self.relaxlabel,False,False,5);self.relaxBox1.pack_end(self.relaxturEntry,False,False,2)
        self.relaxBox1.pack_end(self.relaxUEntry,False,False,5);self.relaxBox1.pack_end(self.relaxpEntry,False,False,5)	
	#---- run box----------------------------------------------------------------------------------------
        self.runframe=gtk.Frame();self.runframe.set_label(' Run Conditions ');self.runframe.set_label_align(0.1, 0.5)
        self.runframe.set_shadow_type(gtk.SHADOW_IN);self.runbox.pack_start(self.runframe,True,True,3)
	
	self.rhbox=gtk.HBox(True,5);self.runframe.add(self.rhbox)
	self.rbox=gtk.VBox(False,3);self.rhbox.pack_start(self.rbox,False,False,5)
       
        self.startlabel=gtk.Label('start from')
        self.startCombo=gtk.combo_box_entry_new_text();self.startCombo.set_size_request(120,28)
        self.startCombo.append_text('startTime');self.startCombo.append_text('latestTime');self.startCombo.set_active(0)

        self.stimelabel=gtk.Label('start Time')
        self.startTimeEntry=gtk.Entry();self.startTimeEntry.set_size_request(100,28);self.startTimeEntry.set_text('0')

        self.etimelabel=gtk.Label('end time')
        self.endTimeEntry=gtk.Entry();self.endTimeEntry.set_size_request(100,28);self.endTimeEntry.set_text('0')

        self.dtlabel=gtk.Label('time step size')
        self.deltaTEntry=gtk.Entry();self.deltaTEntry.set_size_request(100,28);self.deltaTEntry.set_text('1')

        self.adjustCB=gtk.CheckButton('adjustTimeStep')

        self.maxcolabel=gtk.Label('maxCo')
        self.maxcoEntry=gtk.Entry();self.maxcoEntry.set_size_request(100,28);self.maxcoEntry.set_text('1.0')

        self.maxdtlabel=gtk.Label('maxDeltaT')
        self.maxdtEntry=gtk.Entry();self.maxdtEntry.set_size_request(100,28);self.maxdtEntry.set_text('1')

        self.wcontrollabel=gtk.Label('write control')
        self.wcontrolCombo=gtk.combo_box_entry_new_text();self.wcontrolCombo.set_size_request(100,28)
	wcontrol=['timeStep','runTime','adjustableRunTime','clockTime','cpuTime']
	for ii in wcontrol:self.wcontrolCombo.append_text(ii)
	self.wcontrolCombo.set_active(1)

        self.wintervallabel=gtk.Label('write interval')
        self.writeIntervalEntry=gtk.Entry();self.writeIntervalEntry.set_size_request(100,28);self.writeIntervalEntry.set_text('100')

        self.purgelabel=gtk.Label('purge write')
        self.purgeEntry=gtk.Entry();self.purgeEntry.set_size_request(100,28);self.purgeEntry.set_text('0')

        self.formatlabel=gtk.Label('write format')
        self.formatCombo=gtk.combo_box_entry_new_text();self.formatCombo.set_size_request(100,28)
        self.formatCombo.append_text('ascii');self.formatCombo.append_text('binary');self.formatCombo.set_active(0)

        self.precisionlabel=gtk.Label('write precision')
        self.precisionEntry=gtk.Entry();self.precisionEntry.set_size_request(100,28);self.precisionEntry.set_text('6')

        self.compressB=gtk.CheckButton('Data Compression')
        self.potentialB=gtk.CheckButton('Potential initialize')
        self.plotresB=gtk.CheckButton('Plot Residual')
	self.plotresB.set_active(1)

        self.corelabel=gtk.Label('number of cores')
        self.nparEntry=gtk.Entry();self.nparEntry.set_size_request(100,28);self.nparEntry.set_text('1')        

	self.label=gtk.Label('Parallel type')
        self.machineCombo=gtk.combo_box_entry_new_text()
        self.machineCombo.set_size_request(100,28);self.machineCombo.append_text('SMP');self.machineCombo.append_text('Cluster')
        self.machineCombo.set_active(0);self.machineCombo.connect('changed',chmachine)
        #self.hostfileB=gtk.Button(label='   host file   ');self.hostfileB.connect('clicked',selhostfile)

        self.initializeB=gtk.Button(label='Initialize');self.initializeB.connect('clicked',initialize)
        self.startB=gtk.Button(label='Start');self.stopB=gtk.Button(label='Stop')
        self.startB.connect('clicked',startRun);self.stopB.connect('clicked',savestop)
	self.startB.set_size_request(80,28);self.stopB.set_size_request(80,28)
	self.buttonBox1=gtk.HBox(False,5);self.buttonBox2=gtk.HBox(False,5)

        self.startBox=gtk.HBox(False,5);self.rbox.pack_start(self.startBox,False,False,2)                
        self.startBox.pack_start(self.startlabel,False,False,5);self.startBox.pack_end(self.startCombo,False,False,5)
        self.startTimeBox=gtk.HBox(False,5);self.rbox.pack_start(self.startTimeBox,False,False,2)                
        self.startTimeBox.pack_start(self.stimelabel,False,False,5);self.startTimeBox.pack_end(self.startTimeEntry,False,False,5)
        self.endTimeBox=gtk.HBox(False,5);self.rbox.pack_start(self.endTimeBox,False,False,2)
	self.endTimeBox.pack_start(self.etimelabel,False,False,5);self.endTimeBox.pack_end(self.endTimeEntry,False,False,5)

        self.deltaTBox=gtk.HBox(False,5)
	self.deltaTBox.pack_start(self.dtlabel,False,False,5);self.deltaTBox.pack_end(self.deltaTEntry,False,False,5)
        self.maxcoBox=gtk.HBox(False,5)
	self.maxcoBox.pack_start(self.maxcolabel,False,False,5);self.maxcoBox.pack_end(self.maxcoEntry,False,False,5)
        self.maxdtBox=gtk.HBox(False,5)
	self.maxdtBox.pack_start(self.maxdtlabel,False,False,5);self.maxdtBox.pack_end(self.maxdtEntry,False,False,5)
        self.wcontrolBox=gtk.HBox(False,5)
	self.wcontrolBox.pack_start(self.wcontrollabel,False,False,5);self.wcontrolBox.pack_end(self.wcontrolCombo,False,False,5)
	if self.timemode=='Transient':
	    self.rbox.pack_start(self.deltaTBox,False,False,2)
	    self.rbox.pack_start(self.adjustCB,False,False,2)
	    self.rbox.pack_start(self.maxcoBox,False,False,2)
	    self.rbox.pack_start(self.maxdtBox,False,False,2)
	    self.rbox.pack_start(self.wcontrolBox,False,False,2)

        self.writeIntervalBox=gtk.HBox(False,5);self.rbox.pack_start(self.writeIntervalBox,False,False,2)                
        self.writeIntervalBox.pack_start(self.wintervallabel,False,False,5);self.writeIntervalBox.pack_end(self.writeIntervalEntry,False,False,5)
        self.purgeBox=gtk.HBox(False,5);self.rbox.pack_start(self.purgeBox,False,False,2)                
        self.purgeBox.pack_start(self.purgelabel,False,False,5);self.purgeBox.pack_end(self.purgeEntry,False,False,5)
        self.formatBox=gtk.HBox(False,5);self.rbox.pack_start(self.formatBox,False,False,2)                
        self.formatBox.pack_start(self.formatlabel,False,False,5);self.formatBox.pack_end(self.formatCombo,False,False,5)
        self.precisionBox=gtk.HBox(False,5);self.rbox.pack_start(self.precisionBox,False,False,2)                
        self.precisionBox.pack_start(self.precisionlabel,False,False,5);self.precisionBox.pack_end(self.precisionEntry,False,False,5)
	self.rbox.pack_start(self.compressB,False,False,2)
	self.rbox.pack_start(self.potentialB,False,False,5)
	self.rbox.pack_start(self.plotresB,False,False,2)
        self.parBox=gtk.HBox(False,5);self.rbox.pack_start(self.parBox,False,False,2)
        self.parBox.pack_start(self.corelabel,False,False,5);self.parBox.pack_end(self.nparEntry,False,False,5)
        self.machineBox=gtk.HBox(False,5);self.rbox.pack_start(self.machineBox,False,False,2)                
        #self.machineBox.pack_start(self.machineCombo,False,False,5)#;self.machineBox.pack_end(self.hostfileB,False,False,5)
        self.machineBox.pack_start(self.label,False,False,5);self.machineBox.pack_end(self.machineCombo,False,False,5)

        self.rbox.pack_start(self.buttonBox1,False,False,5);self.rbox.pack_start(self.buttonBox2,False,False,5)
	self.buttonBox1.pack_start(self.initializeB,True,True,5);self.buttonBox1.pack_start(self.startB,True,True,5)
	self.buttonBox2.pack_end(self.stopB,True,True,5)
        #--------------------------------------------------------------------------------------
        self.tailframe=gtk.Frame()
        self.tailframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);self.tailbox.pack_start(self.tailframe,True,True,5)

	self.tv1box=gtk.VBox(False,5);self.tvbox=gtk.HBox(False,5)
	self.tailframe.add(self.tv1box);self.tv1box.pack_start(self.tvbox,False,False,5)

	self.label=gtk.Label(self.caseDir)
	self.tvbox.pack_start(self.label,False,False,5)     
        #-----------------------------------------------------------------------------------------
	if self.timemode=='Steady':self.timeCB.set_active(0)
	else:self.timeCB.set_active(1)	
        #-----------------------------------------------------------------------------------------
        self.window.show_all()

	setValue()

    def main(self):
        gtk.main()

if __name__=='__main__':
    win=mainWindow()
    win.main()
        
