#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for mesh handling
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,glob;import pygtk;pygtk.require('2.0');import gtk

from writeFileIncompressibleSub import *;from writeFileHeatTransferSub import *
from generalSub import *

class meshClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.meshWindow.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir

    def closeMeshPanel(self,widget):
	self.meshWindow.destroy()

    #---------------------------------------------------------------------------------------------------------
    def importmesh(self):

	GEN=generalClass(self.caseDir)
	crFile=writeFileClassIncompressible(self.caseDir)

	def closethis(widget):
	    window.destroy()

	def selectMesh(widget):
	    aa=ccombo.child;util=aa.get_text()
	    display=displaycheck.get_active()

            meshFileName=GEN.importMeshutil(util,display)
	    window.destroy()

	    if meshFileName!='None':
	        f=open(self.caseDir+'/temporary/importedMesh','w')
	        f.write(meshFileName);f.close()
	    #aa=glob.glob(self.caseDir+'/temporary/*Faces')
	    #if len(aa)!=0:os.system('rm '+self.caseDir+'/temporary/*Faces')		

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Import mesh')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame1=gtk.Frame();frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame1,False,False,5)

	vbox=gtk.VBox(False,5);frame1.add(vbox)

	label=gtk.Label('   Select mesh converting utility for msh/cas file   ')

        ccombo=gtk.combo_box_entry_new_text();ccombo.set_size_request(220,28)
	utils=['fluentMeshToFoam','fluent3DMeshToFoam','ccm26ToFoam']
	for ii in utils:ccombo.append_text(ii)
        ccombo.set_active(0)

	displaycheck=gtk.CheckButton('Display Mesh')

	selB=gtk.Button('Select file');selB.connect('clicked',selectMesh);selB.set_size_request(160,28)
	celB=gtk.Button('Close');celB.connect('clicked',closethis);celB.set_size_request(160,28)

	hbox1=gtk.HBox(False,5);vbox.pack_start(hbox1,False,False,5)
	hbox2=gtk.HBox(False,5);vbox.pack_start(hbox2,False,False,5)
	cbbox=gtk.HBox(False,5);vbox.pack_start(cbbox,False,False,5)
	hbox3=gtk.HBox(False,5);vbox.pack_start(hbox3,False,False,5)
	hbox1.pack_start(label,False,False,5);hbox2.pack_start(ccombo,False,False,5)
	cbbox.pack_start(displaycheck,False,False,5)
	hbox3.pack_start(selB,False,False,5);hbox3.pack_start(celB,False,False,5)
	window.show_all()
    #---------------------------------------------------------------------------------------------------------            
    def scaleMesh(self):
	def closethis(widget):
	    window.destroy()

	def applythis(widget):
	    xscale=scalex.get_text();yscale=scaley.get_text();zscale=scalez.get_text()
            os.system("transformPoints -case "+self.caseDir+" -scale '("+xscale+' '+yscale+' '+zscale+")'")
	    md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"Scale Mesh completed "+xscale+" "+yscale+" "+zscale)
	    md.run();md.destroy()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Scale mesh')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame,False,False,5)

	vbox=gtk.VBox(False,5);frame.add(vbox)

	label=gtk.Label('Set scale factor for x,y,z')
	labelbox=gtk.HBox(False,5);vbox.pack_start(labelbox,False,False,5)
	labelbox.pack_start(label,False,False,5)

	scalex=gtk.Entry();scalex.set_size_request(80,28);scalex.set_text('0.001')
	scaley=gtk.Entry();scaley.set_size_request(80,28);scaley.set_text('0.001')
	scalez=gtk.Entry();scalez.set_size_request(80,28);scalez.set_text('0.001')
	scalebox=gtk.HBox(False,5);vbox.pack_start(scalebox,False,False,5)
	scalebox.pack_start(scalex,False,False,5);scalebox.pack_start(scaley,False,False,5);scalebox.pack_start(scalez,False,False,5)

	appB=gtk.Button('Apply');clsB=gtk.Button('Close')
	appB.connect('clicked',applythis);clsB.connect('clicked',closethis)
	appB.set_size_request(100,28);clsB.set_size_request(100,28)
	bubox=gtk.HBox(False,5);vbox.pack_start(bubox,False,False,5)
	bubox.pack_end(clsB,False,False,5);bubox.pack_end(appB,False,False,5)
	window.show_all()
    #---------------------------------------------------------------------------------------------------------            
    def translateMesh(self):
	def closethis(widget):
	    window.destroy()

	def applythis(widget):
	    xscale=scalex.get_text();yscale=scaley.get_text();zscale=scalez.get_text()
            os.system("transformPoints -case "+self.caseDir+" -translate '("+xscale+' '+yscale+' '+zscale+")'")
	    md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"Translate Mesh completed "+xscale+" "+yscale+" "+zscale)
	    md.run();md.destroy()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Translate mesh')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame,False,False,5)

	vbox=gtk.VBox(False,5);frame.add(vbox)

	label=gtk.Label('Set vector for x,y,z')
	labelbox=gtk.HBox(False,5);vbox.pack_start(labelbox,False,False,5)
	labelbox.pack_start(label,False,False,5)

	scalex=gtk.Entry();scalex.set_size_request(80,28);scalex.set_text('1')
	scaley=gtk.Entry();scaley.set_size_request(80,28);scaley.set_text('0')
	scalez=gtk.Entry();scalez.set_size_request(80,28);scalez.set_text('0')
	scalebox=gtk.HBox(False,5);vbox.pack_start(scalebox,False,False,5)
	scalebox.pack_start(scalex,False,False,5);scalebox.pack_start(scaley,False,False,5);scalebox.pack_start(scalez,False,False,5)

	appB=gtk.Button('Apply');clsB=gtk.Button('Close')
	appB.connect('clicked',applythis);clsB.connect('clicked',closethis)
	appB.set_size_request(100,28);clsB.set_size_request(100,28)
	bubox=gtk.HBox(False,5);vbox.pack_start(bubox,False,False,5)
	bubox.pack_end(clsB,False,False,5);bubox.pack_end(appB,False,False,5)
	window.show_all()
    #---------------------------------------------------------------------------------------------------------            
    def boundarySet(self):

	GEN=generalClass(self.caseDir)
	crFile=writeFileClassIncompressible(self.caseDir)

        def changePatchType(bcNameList,bcTypeList):
	    patchTypeList=[]
	    for ii in bcTypeList:
		if ii=='wall':patchTypeList.append('wall')
		elif ii=='patch':patchTypeList.append('patch')
		elif ii=='symmetry':patchTypeList.append('symmetry')
		elif ii=='cyclicAMI':patchTypeList.append('cyclicAMI')
		elif ii=='cyclic':patchTypeList.append('cyclic')
		elif ii=='empty':patchTypeList.append('empty')
		elif ii=='mappedWall':patchTypeList.append('mappedWall')
            GEN.changeDictionaryDictNoAMINoMappedWall(bcNameList,patchTypeList)
	    os.system('changeDictionary -disablePatchGroups -case '+self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

        def setBound(widget,data=None):
            facetype=[];wallFaces=[];patchFaces=[];symmetryFaces=[];cyclicAMIFaces=[];cyclicFaces=[];emptyFaces=[];mappedWallFaces=[]
            for i in range(len(bcName)):
                ccc=Type[i].child;cccc=ccc.get_text()
                facetype.append(cccc)
            for i in range(len(facetype)):
                if facetype[i]=='wall':wallFaces.append(bcName[i])
                if facetype[i]=='patch':patchFaces.append(bcName[i])
                if facetype[i]=='symmetry':symmetryFaces.append(bcName[i])
                if facetype[i]=='cyclicAMI':cyclicAMIFaces.append(bcName[i])
                if facetype[i]=='cyclic':cyclicFaces.append(bcName[i])
                if facetype[i]=='empty':emptyFaces.append(bcName[i])
                if facetype[i]=='mappedWall':mappedWallFaces.append(bcName[i])

	    if len(wallFaces)!=0:
                f=open(self.caseDir+'/temporary/wallFaces','w')
		for i in range(len(wallFaces)):f.write(wallFaces[i]+'\n')
		f.close()
	    else:os.system('rm '+self.caseDir+'/temporary/wallFaces')
	    if len(patchFaces)!=0:
                f=open(self.caseDir+'/temporary/patchFaces','w')
		for i in range(len(patchFaces)):f.write(patchFaces[i]+'\n')
		f.close()
	    else:os.system('rm '+self.caseDir+'/temporary/patchFaces')
	    if len(symmetryFaces)!=0:
                f=open(self.caseDir+'/temporary/symmetryFaces','w')
		for i in range(len(symmetryFaces)):f.write(symmetryFaces[i]+'\n')
		f.close()
	    else:os.system('rm '+self.caseDir+'/temporary/symmetryFaces')
	    if len(cyclicAMIFaces)!=0:
                f=open(self.caseDir+'/temporary/cyclicAMIFaces','w')
		for i in range(len(cyclicAMIFaces)):f.write(cyclicAMIFaces[i]+'\n')
		f.close()
	    else:os.system('rm '+self.caseDir+'/temporary/cyclicAMIFaces')
	    if len(cyclicFaces)!=0:
                f=open(self.caseDir+'/temporary/cyclicFaces','w')
		for i in range(len(cyclicFaces)):f.write(cyclicFaces[i]+'\n')
		f.close()
	    else:os.system('rm '+self.caseDir+'/temporary/cyclicFaces')
	    if len(emptyFaces)!=0:
                f=open(self.caseDir+'/temporary/emptyFaces','w')
		for i in range(len(emptyFaces)):f.write(emptyFaces[i]+'\n')
		f.close()
	    else:os.system('rm '+self.caseDir+'/temporary/emptyFaces')
	    if len(mappedWallFaces)!=0:
                f=open(self.caseDir+'/temporary/mappedWallFaces','w')
		for i in range(len(mappedWallFaces)):f.write(mappedWallFaces[i]+'\n')
		f.close()
	    else:os.system('rm '+self.caseDir+'/temporary/mappedWallFaces')
	    changePatchType(bcName,facetype)

            window.destroy()

        def savenread():
            wallFaces=[];patchFaces=[];cyclicAMIFaces=[];symmetryFaces=[];cyclicFaces=[];emptyFaces=[];bcdict={}
            a1=glob.glob(self.caseDir+'/temporary/wallFaces');a2=glob.glob(self.caseDir+'/temporary/patchFaces')
	    a3=glob.glob(self.caseDir+'/temporary/symmetryFaces');a4=glob.glob(self.caseDir+'/temporary/cyclicAMIFaces')
	    a5=glob.glob(self.caseDir+'/temporary/cyclicFaces');a6=glob.glob(self.caseDir+'/temporary/emptyFaces')
	    a7=glob.glob(self.caseDir+'/temporary/mappedWallFaces')

            if len(a1)!=0:
                f=open(self.caseDir+'/temporary/wallFaces','r');ff=f.readlines();f.close()
                for ii in ff:bcdict[ii[:-1]]='wall'
            if len(a2)!=0:
                f=open(self.caseDir+'/temporary/patchFaces','r');ff=f.readlines();f.close()
                for ii in ff:bcdict[ii[:-1]]='patch'
            if len(a3)!=0:
                f=open(self.caseDir+'/temporary/symmetryFaces','r');ff=f.readlines();f.close()
                for ii in ff:bcdict[ii[:-1]]='symmetry'
            if len(a4)!=0:
                f=open(self.caseDir+'/temporary/cyclicAMIFaces','r');ff=f.readlines();f.close()
                for ii in ff:bcdict[ii[:-1]]='cyclicAMI'
            if len(a5)!=0:
                f=open(self.caseDir+'/temporary/cyclicFaces','r');ff=f.readlines();f.close()
                for ii in ff:bcdict[ii[:-1]]='cyclic'
            if len(a6)!=0:
                f=open(self.caseDir+'/temporary/emptyFaces','r');ff=f.readlines();f.close()
                for ii in ff:bcdict[ii[:-1]]='empty'
            if len(a7)!=0:
                f=open(self.caseDir+'/temporary/mappedWallFaces','r');ff=f.readlines();f.close()
                for ii in ff:bcdict[ii[:-1]]='mappedWall'
            return bcdict

        bcdict=savenread()
	bcdictkey=bcdict.keys()

        bcName=GEN.getBCName();bcType=GEN.getBCType() 	    

	if len(bcdictkey)==0:
	    for i in range(len(bcName)):bcdict[bcName[i]]=bcType[i]

	bcName.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Boundary Setup')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5)
        window.add(mainbox)

        ibox=gtk.HBox(False,5);mainbox.pack_start(ibox,False,False,5)        
        label01=gtk.Label('Boundary name');label01.set_size_request(150,28);ibox.pack_start(label01,False,False,5)
        label03=gtk.Label('B.Condition type');label03.set_size_request(150,28);ibox.pack_start(label03,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5)
        itembox=gtk.VBox(False,0)
        swin.add_with_viewport(itembox)
        scheight=len(bcName)*38
        if scheight > 750:scheight=750        
        swin.set_size_request(380,scheight)

        faceName=[];patchType=[];Type=[];hbox1=[]
        for i in range(len(bcName)):
            hbox1.append(gtk.HBox(False,5));itembox.pack_start(hbox1[i],False,False,2)                
            faceName.append(gtk.Entry());faceName[i].set_size_request(180,28)
            faceName[i].set_text(bcName[i])

            Type.append(gtk.combo_box_entry_new_text())
            Type[i].set_size_request(180,28)
            bcTypes=['wall','patch','symmetry','cyclicAMI','cyclic','empty','mappedWall']
            for j in range(len(bcTypes)):Type[i].append_text(bcTypes[j])
            if bcdict[bcName[i]]=='wall':Type[i].set_active(0) 
            elif bcdict[bcName[i]]=='patch':Type[i].set_active(1);
            elif bcdict[bcName[i]]=='symmetryPlane' or bcdict[bcName[i]]=='symmetry':Type[i].set_active(2) 
            elif bcdict[bcName[i]]=='cyclicAMI':
		Type[i].set_active(3);Type[i].set_sensitive(0)
            elif bcdict[bcName[i]]=='cyclic':
		Type[i].set_active(4);Type[i].set_sensitive(0)		
            elif bcdict[bcName[i]]=='empty':
		Type[i].set_active(5);Type[i].set_sensitive(0)
            elif bcdict[bcName[i]]=='mappedWall':
		Type[i].set_active(6);Type[i].set_sensitive(0)

            hbox1[i].pack_start(faceName[i],False,False,0)
            hbox1[i].pack_start(Type[i],False,False,0)

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,28)
        cll=gtk.Button(label='Cancel');cll.set_size_request(120,28)
        app.connect('clicked',setBound);cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all()       
    #---------------------------------------------------------------------------------------------------------
    def createCyclicAMI(self): # to Create cyclicAMI(rotational & translational)

	GEN=generalClass(self.caseDir)
	crFile=writeFileClassIncompressible(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

        def makeAMI(widget,data=None):
	    aa=cyclicCombo.child;cmode=aa.get_text()

	    selectedSet=[];tf=[]
	    for i in range(len(sets)):
		aa=setName[i].get_active()		   
		if aa==True:selectedSet.append(sets[i])		
	    if len(selectedSet)!=2:print 'Error!!! Selected patch is not 2'
	    else:
		if cmode=='Translation':		
		    cc1=c1Entry.get_text();cc2=c2Entry.get_text();cc3=c3Entry.get_text()
		    f=open(self.caseDir+'/temporary/cyclicConditionTransition','w')
		    f.write('('+cc1+' '+cc2+' '+cc3+')\n')
		    f.close()
		    crFile.createAMIFileTransition(selectedSet,cc1,cc2,cc3)
		    os.system('changeDictionary -disablePatchGroups -dict '+self.caseDir+'/system/changeDictionaryDictCyclic -case '+self.caseDir)
		else:
		    rr1=r1Entry.get_text();rr2=r2Entry.get_text();rr3=r3Entry.get_text()		
		    dd=axisCombo.child;axis=dd.get_text()
		    f=open(self.caseDir+'/temporary/cyclicCondition','w')
		    f.write('('+rr1+' '+rr2+' '+rr3+')\n');f.write(axis+'\n')
		    f.close()
		    crFile.createAMIFile(selectedSet,rr1,rr2,rr3,axis)
		    os.system('changeDictionary -disablePatchGroups -dict '+self.caseDir+'/system/changeDictionaryDictAMI -case '+self.caseDir)

	def chmode(widget):
	    aa=cyclicCombo.child;mode=aa.get_text()
	    if mode=='Rotation':
		rotbox2.remove(label3);rotbox2.remove(c1Entry);rotbox2.remove(c2Entry);rotbox2.remove(c3Entry)
		rotbox.pack_start(label1,False,False,5);rotbox.pack_end(r3Entry,False,False,5)
		rotbox.pack_end(r2Entry,False,False,5);rotbox.pack_end(r1Entry,False,False,5)
		rotbox1.pack_start(label2,False,False,5);rotbox1.pack_end(axisCombo,False,False,5)
	    else:
		rotbox.remove(label1);rotbox.remove(r3Entry);rotbox.remove(r2Entry);rotbox.remove(r1Entry)
		rotbox1.remove(label2);rotbox1.remove(axisCombo)
		rotbox2.pack_start(label3,False,False,5);rotbox2.pack_start(c1Entry,False,False,5)
		rotbox2.pack_start(c2Entry,False,False,5);rotbox2.pack_start(c3Entry,False,False,5)
	    window.show_all()

        sets=GEN.getBCName()
	sets.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Select Cyclic pair')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

	clabel=gtk.Label('Cyclic mode')
        cyclicCombo=gtk.combo_box_entry_new_text();cyclicCombo.set_size_request(140,28)
	cyclicModels=['Rotation','Translation'] 
	for models in cyclicModels:cyclicCombo.append_text(models)
	cyclicCombo.set_active(0);cyclicCombo.set_size_request(160,28);cyclicCombo.connect('changed',chmode)
	modebox=gtk.HBox(False,5);mainbox.pack_start(modebox,False,False,5)
	modebox.pack_start(clabel,False,False,5);modebox.pack_start(cyclicCombo,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5)
        itembox=gtk.VBox(False,0)
        swin.add_with_viewport(itembox)
        scheight=len(sets)*38
        if scheight > 750:scheight=750        
        swin.set_size_request(300,scheight)

        setName=[]
        for i in range(len(sets)):
            hbox1=gtk.HBox(False,5);itembox.pack_start(hbox1,False,False,2)                
            setName.append(gtk.CheckButton(sets[i],use_underline=False));setName[i].set_size_request(180,28)
            hbox1.pack_start(setName[i],False,False,0)

	rotbox=gtk.HBox(False,5)
	label1=gtk.Label('rotationCenter')
	r1Entry=gtk.Entry();r1Entry.set_size_request(60,28);r1Entry.set_text('0')
	r2Entry=gtk.Entry();r2Entry.set_size_request(60,28);r2Entry.set_text('0')
	r3Entry=gtk.Entry();r3Entry.set_size_request(60,28);r3Entry.set_text('0')
	mainbox.pack_start(rotbox,False,False,5)
	rotbox.pack_start(label1,False,False,5);rotbox.pack_end(r3Entry,False,False,5)
	rotbox.pack_end(r2Entry,False,False,5);rotbox.pack_end(r1Entry,False,False,5)

	rotbox1=gtk.HBox(False,5)
	label2=gtk.Label('rotationAxis')
	axisCombo=gtk.combo_box_entry_new_text();axisCombo.set_size_request(120,28)
	axisCombo.append_text('x');axisCombo.append_text('y');axisCombo.append_text('z')
	axisCombo.set_active(2)
	mainbox.pack_start(rotbox1,False,False,5)
	rotbox1.pack_start(label2,False,False,5);rotbox1.pack_end(axisCombo,False,False,5)


	rotbox2=gtk.HBox(False,5)
	label3=gtk.Label('vector, 1st to 2nd')
	c1Entry=gtk.Entry();c1Entry.set_size_request(60,28);c1Entry.set_text('0')
	c2Entry=gtk.Entry();c2Entry.set_size_request(60,28);c2Entry.set_text('0')
	c3Entry=gtk.Entry();c3Entry.set_size_request(60,28);c3Entry.set_text('0')
	mainbox.pack_start(rotbox2,False,False,5)

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(100,28)
        cll=gtk.Button(label='Close');cll.set_size_request(100,28)
        app.connect('clicked',makeAMI);cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all()  
    #---------------------------------------------------------------------------------------------------------
    def createInterior(self):

	GEN=generalClass(self.caseDir)
	crFile=writeFileClassIncompressible(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

        def makeInterior(widget,data=None):
	    mode=scombo.get_active()
	    if mode==0:
		selectedSet=[];tf=[]
		for i in range(len(sets)):
		    aa=setName[i].get_active()		   
		    if aa==True:selectedSet.append(sets[i])		
		print 'selected baffle sets is ',selectedSet
		crFile.createBafflesDictInterior(selectedSet)
		os.system('setsToZones -noFlipMap -case '+self.caseDir)
		os.system('createBaffles -case '+self.caseDir+' -overwrite')
		#os.system('rm -r '+self.caseDir+'/constant/polyMesh/sets')
                window.destroy()
	    else:
		selectedZone=[];tff=[]
		for i in range(len(zones)):
		    aa=zoneName[i].get_active()		   
		    if aa==True:selectedZone.append(zones[i])		
		print 'selected baffle zones is ',selectedZone
		crFile.createBafflesDictInterior(selectedZone)
		os.system('createBaffles -case '+self.caseDir+' -overwrite')
                window.destroy()
	def chscombo(widget,sets,zones,hbox1,hbox11,setName,zoneName):
	    sss=scombo.get_active()
	    if sss==1:
                for i in range(len(sets)):itembox.remove(hbox1[i])
		for i in range(len(zones)):itembox.pack_start(hbox11[i],False,False,2)
		scombo.set_active(1)
		window.show_all()
	    else: 
                for i in range(len(zones)):itembox.remove(hbox11[i])
		for i in range(len(sets)):itembox.pack_start(hbox1[i],False,False,2)
		scombo.set_active(0)
		window.show_all()

	sets=GEN.getSets()
	zones=GEN.getfaceZones()

	sets.sort();zones.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('create interior - porous jump')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        scombo=gtk.combo_box_entry_new_text();scombo.set_size_request(200,28)
	scombo.append_text('use faceSet');scombo.append_text('use faceZone')
	scombo.set_active(1)

        hbox0=gtk.HBox(False,5);mainbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(scombo,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5)
        itembox=gtk.VBox(False,0)
        swin.add_with_viewport(itembox)
        scheight=len(sets)*38
        if scheight > 750:scheight=750        
        #swin.set_size_request(300,scheight)
        swin.set_size_request(300,500)

        setName=[];hbox1=[]
	    
        for i in range(len(sets)):
            hbox1.append(gtk.HBox(False,5))#;itembox.pack_start(hbox1[i],False,False,2)                
            setName.append(gtk.CheckButton(sets[i],use_underline=False));setName[i].set_size_request(180,28)
            hbox1[i].pack_start(setName[i],False,False,0)

        zoneName=[];hbox11=[]
        for i in range(len(zones)):
            hbox11.append(gtk.HBox(False,5));itembox.pack_start(hbox11[i],False,False,2)                
            zoneName.append(gtk.CheckButton(zones[i],use_underline=False));zoneName[i].set_size_request(180,28)
            hbox11[i].pack_start(zoneName[i],False,False,0)

	scombo.connect('changed',chscombo,sets,zones,hbox1,hbox11,setName,zoneName)

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(100,28)
        cll=gtk.Button(label='Cancel');cll.set_size_request(100,28)
        app.connect('clicked',makeInterior);cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all()  
    #---------------------------------------------------------------------------------------------------------
    def createBaffle(self):

	GEN=generalClass(self.caseDir);crFile=writeFileClassIncompressible(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

        def makeBaffle(widget,data=None):
	    mode=scombo.get_active()
	    if mode==0:
		selectedSet=[];tf=[]
		for i in range(len(sets)):
		    aa=setName[i].get_active()		   
		    if aa==True:selectedSet.append(sets[i])		
		print 'selected baffle sets is ',selectedSet
	        crFile.topoSetDict(selectedSet);crFile.createBafflesDict(selectedSet)
		os.system('setsToZones -noFlipMap -case '+self.caseDir)
		os.system('createBaffles -case '+self.caseDir+' -overwrite')
		#f.write('rm -r '+self.caseDir+'/constant/polyMesh/sets \n')
                window.destroy()
	    else:
		selectedZone=[];tff=[]
		for i in range(len(zones)):
		    aa=zoneName[i].get_active()		   
		    if aa==True:selectedZone.append(zones[i])		
		print 'selected baffle zones is ',selectedZone
		crFile.createBafflesDictInterior(selectedZone);crFile.createBafflesDict(selectedZone)
		os.system('createBaffles -case '+self.caseDir+' -overwrite')
                window.destroy()
	def chscombo(widget,sets,zones,hbox1,hbox11,setName,zoneName):
	    sss=scombo.get_active()
	    if sss==1:
                for i in range(len(sets)):itembox.remove(hbox1[i])
		for i in range(len(zones)):itembox.pack_start(hbox11[i],False,False,2)
		scombo.set_active(1)
		window.show_all()
	    else: 
                for i in range(len(zones)):itembox.remove(hbox11[i])
		for i in range(len(sets)):itembox.pack_start(hbox1[i],False,False,2)
		scombo.set_active(0)
		window.show_all()

	sets=GEN.getSets()
	zones=GEN.getfaceZones()

	sets.sort();zones.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('create baffle')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        scombo=gtk.combo_box_entry_new_text();scombo.set_size_request(200,28)
	scombo.append_text('use faceSet');scombo.append_text('use faceZone')
	scombo.set_active(0)

        hbox0=gtk.HBox(False,5);mainbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(scombo,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5)
        itembox=gtk.VBox(False,0)
        swin.add_with_viewport(itembox)
        scheight=len(sets)*38
        if scheight > 750:scheight=750        
        #swin.set_size_request(300,scheight)
        swin.set_size_request(300,500)

        setName=[];hbox1=[]
	    
        for i in range(len(sets)):
            hbox1.append(gtk.HBox(False,5));itembox.pack_start(hbox1[i],False,False,2)                
            setName.append(gtk.CheckButton(sets[i],use_underline=False));setName[i].set_size_request(180,28)
            hbox1[i].pack_start(setName[i],False,False,0)

        zoneName=[];hbox11=[]
        for i in range(len(zones)):
            hbox11.append(gtk.HBox(False,5))#;itembox.pack_start(hbox11[i],False,False,2)                
            zoneName.append(gtk.CheckButton(zones[i],use_underline=False));zoneName[i].set_size_request(180,28)
            hbox11[i].pack_start(zoneName[i],False,False,0)

	scombo.connect('changed',chscombo,sets,zones,hbox1,hbox11,setName,zoneName)

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(100,28)
        cll=gtk.Button(label='Cancel');cll.set_size_request(100,28)
        app.connect('clicked',makeBaffle);cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all()  
    #---------------------------------------------------------------------------------------------------------
    def createThermalBaffle(self):

	GEN=generalClass(self.caseDir);crFile=writeFileClassHeatTransfer(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

        def makeBaffle(widget,data=None):
	    mode=scombo.get_active()
	    if mode==0:
		selectedSet=[];tf=[]
		for i in range(len(sets)):
		    aa=setName[i].get_active()		   
		    if aa==True:selectedSet.append(sets[i])		
		print 'selected baffle sets is ',selectedSet
	        crFile.topoSetDict(selectedSet);crFile.createBafflesDictThermal(selectedSet)
		os.system('setsToZones -noFlipMap -case '+self.caseDir)
		os.system('createBaffles -case '+self.caseDir+' -overwrite')
		#f.write('rm -r '+self.caseDir+'/constant/polyMesh/sets \n')
                window.destroy()
	    else:
		selectedZone=[];tff=[]
		for i in range(len(zones)):
		    aa=zoneName[i].get_active()		   
		    if aa==True:selectedZone.append(zones[i])		
		print 'selected baffle zones is ',selectedZone
		crFile.createBafflesDictInterior(selectedZone);crFile.createBafflesDict(selectedZone)
		os.system('createBaffles -case '+self.caseDir+' -overwrite')
                window.destroy()
	def chscombo(widget,sets,zones,hbox1,hbox11,setName,zoneName):
	    sss=scombo.get_active()
	    if sss==1:
                for i in range(len(sets)):itembox.remove(hbox1[i])
		for i in range(len(zones)):itembox.pack_start(hbox11[i],False,False,2)
		scombo.set_active(1)
		window.show_all()
	    else: 
                for i in range(len(zones)):itembox.remove(hbox11[i])
		for i in range(len(sets)):itembox.pack_start(hbox1[i],False,False,2)
		scombo.set_active(0)
		window.show_all()

	sets=GEN.getSets()
	zones=GEN.getfaceZones()

	sets.sort();zones.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('create baffle - porous jump')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        scombo=gtk.combo_box_entry_new_text();scombo.set_size_request(200,28)
	scombo.append_text('use faceSet');scombo.append_text('use faceZone')
	scombo.set_active(0)

        hbox0=gtk.HBox(False,5);mainbox.pack_start(hbox0,False,False,5)
	hbox0.pack_start(scombo,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5)
        itembox=gtk.VBox(False,0)
        swin.add_with_viewport(itembox)
        scheight=len(sets)*38
        if scheight > 750:scheight=750        
        #swin.set_size_request(300,scheight)
        swin.set_size_request(300,500)

        setName=[];hbox1=[]
	    
        for i in range(len(sets)):
            hbox1.append(gtk.HBox(False,5));itembox.pack_start(hbox1[i],False,False,2)                
            setName.append(gtk.CheckButton(sets[i],use_underline=False));setName[i].set_size_request(180,28)
            hbox1[i].pack_start(setName[i],False,False,0)

        zoneName=[];hbox11=[]
        for i in range(len(zones)):
            hbox11.append(gtk.HBox(False,5))#;itembox.pack_start(hbox11[i],False,False,2)                
            zoneName.append(gtk.CheckButton(zones[i],use_underline=False));zoneName[i].set_size_request(180,28)
            hbox11[i].pack_start(zoneName[i],False,False,0)

	scombo.connect('changed',chscombo,sets,zones,hbox1,hbox11,setName,zoneName)

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(100,28)
        cll=gtk.Button(label='Cancel');cll.set_size_request(100,28)
        app.connect('clicked',makeBaffle);cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all()  
    #---------------------------------------------------------------------------------------------------------
    def createInterface(self):

	GEN=generalClass(self.caseDir)
	crFile=writeFileClassIncompressible(self.caseDir)

        def closethis(widget,data=None):
            window.destroy()

        def makeInterface(widget,data=None):
	    selectedFaces=[];tf=[]
	    for i in range(len(bcname)):
		aa=setName[i].get_active()		   
		if aa==True:selectedFaces.append(bcname[i])		
	    print 'selected patch sets are ',selectedFaces
	    GEN.changeDictionaryDictSliding(selectedFaces)
	    os.system('changeDictionary -case '+self.caseDir+' -disablePatchGroups -dict '+self.caseDir+'/system/changeDictionaryDictSliding')

	bcname=GEN.getBCName();bcname.sort()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Select Interface')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,5)
        itembox=gtk.VBox(False,0)
        swin.add_with_viewport(itembox)
        scheight=len(bcname)*38
        if scheight > 750:scheight=750        
        swin.set_size_request(300,scheight)

        setName=[]
        for i in range(len(bcname)):
            hbox1=gtk.HBox(False,5);itembox.pack_start(hbox1,False,False,2)                
            setName.append(gtk.CheckButton(bcname[i],use_underline=False));setName[i].set_size_request(180,28)
            hbox1.pack_start(setName[i],False,False,0)

        hbox2=gtk.HBox(False,5)
        mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(100,28)
        cll=gtk.Button(label='Close');cll.set_size_request(100,28)
        app.connect('clicked',makeInterface);cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  

        window.show_all()

