#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for miscellaneous functions
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math;import pygtk;pygtk.require('2.0');import gtk;import glob

class miscClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir
    
    #--------------------------------------------------------------------------------------  
    def basicfvsolution(self):
	f=open(self.caseDir+'/system/fvSolution','w')
	f.write('FoamFile\n')
	f.write('{\n')
	f.write('    version     2.0;\n')
	f.write('    format      ascii;\n')
	f.write('    class       dictionary;\n')
	f.write('    location    "system";\n')
	f.write('    object      fvSolution;\n')
	f.write('}\n')
	f.write('solvers\n')
	f.write('{\n')
	f.write('    p\n')
	f.write('    {\n')
	f.write('        solver          PCG;\n')
	f.write('        preconditioner  DILU;\n')
	f.write('        tolerance       1e-5;\n')
	f.write('        relTol          0;\n')
	f.write('    };\n')
	f.write('    "(U|k|omega).*"\n')
	f.write('    {\n')
	f.write('        solver          smoothSolver;\n')
	f.write('        smoother        symGaussSeidel;\n')
	f.write('        tolerance       1e-7;\n')
	f.write('        relTol          0.1;\n')
	f.write('    };\n')
	f.write('}\n')
	f.write('SIMPLE\n')
	f.write('{\n')
	f.write('    nNonOrthogonalCorrectors 0;\n')
	f.write('}\n')
	f.write('relaxationFactors\n')
	f.write('{\n')
	f.write('    fields\n')
	f.write('    {\n')
	f.write('    }\n')
	f.write('    equations\n')
	f.write('    {\n')
	f.write('        ".*" 1;\n')
	f.write('    }\n')
	f.write('}\n')
	f.write('cache\n')
	f.write('{\n')
	f.write('    grad(U);\n')
	f.write('}\n')

	f.close()

    def basicfvschemes(self):
	f=open(self.caseDir+'/system/fvSchemes','w')
	f.write('FoamFile\n')
	f.write('{\n')
	f.write('    version     2.0;\n')
	f.write('    format      ascii;\n')
	f.write('    class       dictionary;\n')
	f.write('    location    "system";\n')
	f.write('    object      fvSchemes;\n')
	f.write('}\n')
	f.write('ddtSchemes\n')
	f.write('{\n')
	f.write('    default         localEuler rDeltaT;\n')
	f.write('}\n')
	f.write('gradSchemes\n')
	f.write('{\n')
	f.write('    default         Gauss linear;\n')
	f.write('    limitedGrad     cellLimited Gauss linear 1;\n')
	f.write('}\n')
	f.write('divSchemes\n')
	f.write('{\n')
	f.write('    default	     Gauss linear;\n')
	f.write('}\n')
	f.write('laplacianSchemes\n')
	f.write('{\n')
	f.write('    default         Gauss linear corrected;\n')
	f.write('}\n')
	f.write('interpolationSchemes\n')
	f.write('{\n')
	f.write('    default         linear;\n')
	f.write('}\n')
	f.write('snGradSchemes\n')
	f.write('{\n')
	f.write('    default         corrected;\n')
	f.write('}\n')
	f.write('fluxRequired\n')
	f.write('{\n')
	f.write('    default         no;\n')
	f.write('    p;\n')
	f.write('}\n')

	f.close()
    def basiccontroldict(self):
	f=open(self.caseDir+'/system/controlDict','w')
	f.write('FoamFile\n')
	f.write('{\n')
	f.write('    version     2.0;\n')
	f.write('    format      ascii;\n')
	f.write('    class       dictionary;\n')
	f.write('    location    "system";\n')
	f.write('    object      controlDict;\n')
	f.write('}\n')
	f.write('\n')
	f.write('application     simpleFoam;\n')
	f.write('startFrom       startTime;\n')
	f.write('startTime       0;\n')
	f.write('stopAt          endTime;\n')
	f.write('endTime         10000;\n')
	f.write('deltaT          1;\n')
	f.write('writeControl    timeStep;\n')
	f.write('writeInterval   1000;\n')
	f.write('purgeWrite      10;\n')
	f.write('writeFormat     ascii;//binary;\n')
	f.write('writePrecision  6;\n')
	f.write('writeCompression uncompressed;\n')
	f.write('timeFormat      general;\n')
	f.write('timePrecision   6;\n')
	f.write('runTimeModifiable yes;\n')
	f.close()


