#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for postprocessing functions
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,glob;import pygtk;pygtk.require('2.0');import gtk

from generalSub import * 
from writeFileIncompressibleSub import *

class postClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir

    #------------------------------------------------------------------------------------------
    def monitoring(self):
	def pointSet(widget):self.pointProbe()
	def pointPlot(widget):self.plotprobe()	
	def surfSet(widget):self.surfaceProbe()
	def surfPlot(widget):self.plotsurface()
	def flowSet(widget):self.flowrate()
	def flowPlot(widget):self.plotflowrate()
	def forceSet(widget):self.forceSet()
	def forcePlot(widget):self.plotforce()
	def closethis(widget):window.destroy()

        window=gtk.Window(gtk.WINDOW_TOPLEVEL)
        window.set_border_width(10);window.set_title('Set Monitoring')
	window.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,5);window.add(mainbox)
	frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        mainbox.pack_start(frame,False,False,5)
	vbox=gtk.VBox(False,5);frame.add(vbox)

	label=gtk.Label('Point value')
	pointSetB=gtk.Button('Set');pointSetB.set_size_request(100,28);pointSetB.connect('clicked',pointSet)
	pointPlotB=gtk.Button('Plot');pointPlotB.set_size_request(100,28);pointPlotB.connect('clicked',pointPlot)
	pointbox=gtk.HBox(False,5);vbox.pack_start(pointbox,False,False,5)
	pointbox.pack_start(label,False,False,5)
	pointbox.pack_end(pointPlotB,False,False,5);pointbox.pack_end(pointSetB,False,False,5)

	label=gtk.Label('Surface average')
	surfSetB=gtk.Button('Set');surfSetB.set_size_request(100,28);surfSetB.connect('clicked',surfSet)
	surfPlotB=gtk.Button('Plot');surfPlotB.set_size_request(100,28);surfPlotB.connect('clicked',surfPlot)
	surfbox=gtk.HBox(False,5);vbox.pack_start(surfbox,False,False,5)
	surfbox.pack_start(label,False,False,5)
	surfbox.pack_end(surfPlotB,False,False,5);surfbox.pack_end(surfSetB,False,False,5)

	label=gtk.Label('Flowrate')
	flowSetB=gtk.Button('Set');flowSetB.set_size_request(100,28);flowSetB.connect('clicked',flowSet)
	flowPlotB=gtk.Button('Plot');flowPlotB.set_size_request(100,28);flowPlotB.connect('clicked',flowPlot)
	flowbox=gtk.HBox(False,5);vbox.pack_start(flowbox,False,False,5)
	flowbox.pack_start(label,False,False,5)
	flowbox.pack_end(flowPlotB,False,False,5);flowbox.pack_end(flowSetB,False,False,5)

	label=gtk.Label('Force')
	forceSetB=gtk.Button('Set');forceSetB.set_size_request(100,28);forceSetB.connect('clicked',forceSet)
	forcePlotB=gtk.Button('Plot');forcePlotB.set_size_request(100,28);forcePlotB.connect('clicked',forcePlot)
	forcebox=gtk.HBox(False,5);vbox.pack_start(forcebox,False,False,5)
	forcebox.pack_start(label,False,False,5)
	forcebox.pack_end(forcePlotB,False,False,5);forcebox.pack_end(forceSetB,False,False,5)

	clsB=gtk.Button('Close');clsB.set_size_request(100,28);clsB.connect('clicked',closethis)
	bubox=gtk.HBox(False,5);mainbox.pack_start(bubox,False,False,5)
	bubox.pack_end(clsB,False,False,5)

	window.show_all()
    #------------------------------------------------------------------------------------------
    def plotprobe(self):

	a1=glob.glob(self.caseDir+'/temporary/probepoint')
	if len(a1)!=0:
	    f=open(self.caseDir+'/temporary/probepoint','r');ff=f.readlines();f.close()
	    if ff[0][:-1]=='True':pCheck='yes'
	    else:pCheck='no'
	    if ff[1][:-1]=='True':UCheck='yes'
	    else:UCheck='no'
	else:
	    print 'Error!! Probe point is set'

	aa=glob.glob(self.caseDir+'/postProcessing/probes/*')
	times=[]
	for ii in aa:
	    bb=ii.split('/')
	    times.append(bb[-1])
	times.sort()
	lastTime=times[-1]

	f=open(self.caseDir+'/plotcmd','w')
	f.write('set terminal wxt\n')
	f.write('set xlabel "time"\n')
	path=self.caseDir+'/postProcessing/probes/'
	if pCheck=='yes':
	    if UCheck=='yes':
	        f.write("plot '"+path+lastTime+"/p' u 1:2 w l title 'p','"+path+lastTime+"/U' u 1:3 w l title 'Uy'\n")
	    elif UCheck=='no':
	        f.write("plot '"+path+lastTime+"/p' u 1:2 w l title 'p'\n")
	elif pCheck=='no':
	    if UCheck=='yes':
	        f.write("plot '"+path+lastTime+"/U' u 1:3 w l title 'Uy'\n")
	    elif UCheck=='no':
	        pass
	f.close()

	ccc='gnuplot -persist '+self.caseDir+'/plotcmd'
	os.system(ccc)   
    #------------------------------------------------------------------------------------------
    def pointProbe(self):

	def start(widget,data=None):
	    global xCoords,yCoords,zCoords
	    selp=self.pCheck.get_active()
	    selu=self.uCheck.get_active()
	    inter=self.interval.get_text()
	    aa=self.numCombo.child;number=int(aa.get_text())
	    xyz=[]
	    x0=self.locEntry1.get_text();y0=self.locEntry2.get_text();z0=self.locEntry3.get_text()
	    xyz.append('('+x0+' '+y0+' '+z0+')')
	    
	    for i in range(number-1):
		xx=xCoords[i].get_text();yy=yCoords[i].get_text();zz=zCoords[i].get_text()
		xyz.append('('+xx+' '+yy+' '+zz+')')

	    f=open(self.caseDir+'/system/probeFunction','w')
	    f.write('    probes\n')
	    f.write('    {\n')
	    f.write('        functionObjectLibs ( "libsampling.so" );\n')
	    f.write('        type            probes;\n')
	    f.write('        name            probes;\n')
	    f.write('        outputControl   timeStep;\n')
	    f.write('        outputInterval  '+inter+';\n')
	    f.write('\n')
	    f.write('        fields\n')
	    f.write('        (\n')
	    if selp==True:
	        f.write('            p\n')
	    if selu==True:
	        f.write('            U\n')
	    f.write('        );\n')
	    f.write('\n')
	    f.write('        probeLocations\n')
	    f.write('        (\n')
	    f.write('            '+xyz[0]+'\n')
	    for i in range(len(xyz)-1):
		f.write('            '+xyz[i+1]+'\n')
	    f.write('        );\n')
	    f.write('    }\n') 
	    f.close()

	    ff=open(self.caseDir+'/temporary/probepoint','w')
	    if selp==True:ff.write('True'+'\n')
	    else:ff.write('False'+'\n')
	    if selu==True:ff.write('True'+'\n')
	    else:ff.write('False'+'\n')
	    ff.write(inter+'\n')
	    ff.write(str(number)+'\n')
	    for ii in xyz:ff.write(ii+'\n')
	    ff.close()	

	    self.Win.destroy()
	#-----------------------------------------------------------------------------
	def stop(widget,data=None):
	    self.Win.destroy()

	def setEntry(widget):
	    global xCoords,yCoords,zCoords
	    aa=self.numCombo.child;number=int(aa.get_text())
	    xCoords=[];yCoords=[];zCoords=[];hboxs=[]

	    aaa=self.locBox.get_children()

	    if len(aaa)!=2:
		for i in range(len(aaa)-2):
		    self.locBox.remove(aaa[i+2])
	    for i in range(number-1):
		xCoords.append(gtk.Entry());yCoords.append(gtk.Entry());zCoords.append(gtk.Entry())		
		hboxs.append(gtk.HBox(False,5))
	        self.locBox.pack_start(hboxs[i],False,False,5)
		xCoords[i].set_size_request(100,28);yCoords[i].set_size_request(100,28);zCoords[i].set_size_request(100,28)
		hboxs[i].pack_start(xCoords[i],False,False,5);hboxs[i].pack_start(yCoords[i],False,False,5)
		hboxs[i].pack_start(zCoords[i],False,False,5)
	    self.Win.show_all()	
	#-- GUI part ---------------------------------------------------------------------------        
        self.Win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.Win.connect('delete_event',self.delete_event);self.Win.connect('destroy',self.destroy)
        self.Win.set_border_width(10);self.Win.set_title('Set Points to probe')
	self.Win.set_position(gtk.WIN_POS_CENTER)

        self.vbox=gtk.VBox(False,5);self.varBox=gtk.VBox(False,5)

	self.regbox=gtk.HBox(False,5);self.vbox.pack_start(self.regbox,False,False,5)
	
	self.varFrame=gtk.Frame()
        self.varFrame.set_label('Probe variables');self.varFrame.set_label_align(0.0,1.0)
        self.varFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        
        self.Win.add(self.vbox);self.vbox.pack_start(self.varFrame,False,False,5)
        self.varFrame.add(self.varBox)

	self.pCheck=gtk.CheckButton('p');self.pCheck.set_active(1)
	self.uCheck=gtk.CheckButton('U')

	self.varBox.pack_start(self.pCheck,False,False,5)
	self.varBox.pack_start(self.uCheck,False,False,5)
	#------------------------------
	self.interBox=gtk.HBox(False,5)
	self.label=gtk.Label('Output interval')
	self.interval=gtk.Entry();self.interval.set_text('1');self.interval.set_size_request(100,28)

	self.vbox.pack_start(self.interBox,False,False,5)
	self.interBox.pack_start(self.label,False,False,5);self.interBox.pack_start(self.interval,False,False,5)

	self.locFrame=gtk.Frame()
        self.locFrame.set_label('Probe Locations');self.locFrame.set_label_align(0.0,1.0)
        self.locFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)

	self.locBox=gtk.VBox(False,5)        
	self.vbox.pack_start(self.locFrame,False,False,5);self.locFrame.add(self.locBox)

	self.nlabel=gtk.Label('Number of Points')
	self.numCombo=gtk.combo_box_entry_new_text();self.numCombo.set_size_request(100,28)
	numList=['0','1','2','3','4','5','6','7','8','9','10']
	for jj in numList:
	    self.numCombo.append_text(jj)
	self.numCombo.set_active(0);self.numCombo.connect('changed',setEntry)

	self.npointbox=gtk.HBox(False,5)
	self.locBox.pack_start(self.npointbox,False,False,5)	
	self.npointbox.pack_start(self.nlabel,False,False,5);self.npointbox.pack_start(self.numCombo,False,False,5)
	self.locEntry1=gtk.Entry();self.locEntry1.set_text('0');self.locEntry1.set_size_request(100,28)
	self.locEntry2=gtk.Entry();self.locEntry2.set_text('0');self.locEntry2.set_size_request(100,28)
	self.locEntry3=gtk.Entry();self.locEntry3.set_text('0');self.locEntry3.set_size_request(100,28)
	self.lochbox=gtk.HBox(False,5)
	self.locBox.pack_start(self.lochbox,False,False,5)
	self.lochbox.pack_start(self.locEntry1,False,False,5);self.lochbox.pack_start(self.locEntry2,False,False,5)
	self.lochbox.pack_start(self.locEntry3,False,False,5)
	#-----------------------------------
	self.buttonBox=gtk.HBox(False,5)
	self.vbox.pack_start(self.buttonBox,False,False,5)

	self.appB=gtk.Button('Apply');self.closeB=gtk.Button('Cancel')
	self.appB.set_size_request(100,28);self.closeB.set_size_request(100,28)
	self.appB.connect('clicked',start);self.closeB.connect('clicked',stop)
	self.buttonBox.pack_end(self.closeB,False,False,5);self.buttonBox.pack_end(self.appB,False,False,5)
	#-----------------------------------

	ggg=glob.glob(self.caseDir+'/temporary/probepoint')
	if len(ggg)!=0:
	    f=open(self.caseDir+'/temporary/probepoint','r');ff=f.readlines();f.close()
	    if len(ff)>4:
	        if ff[0][:-1]=='True':self.pCheck.set_active(1)
	        else:self.pCheck.set_active(0)
	        if ff[1][:-1]=='True':self.uCheck.set_active(1)
	        else:self.uCheck.set_active(0)

	        self.interval.set_text(ff[2][:-1])
	        q1=ff[3][:-1];q2=numList.index(q1)
	        self.numCombo.set_active(q2)
	        savedxyz=[]
		if q1!='0':
	            for i in range(int(q1)):
		        ww=ff[4+i][1:-2];www=ww.split()
		        savedxyz.append([www[0],www[1],www[2]])
	            self.locEntry1.set_text(savedxyz[0][0])
	            self.locEntry2.set_text(savedxyz[0][1])
	            self.locEntry3.set_text(savedxyz[0][2])
	            for j in range(int(q1)-1):
		        xCoords[j].set_text(savedxyz[j+1][0])
		        yCoords[j].set_text(savedxyz[j+1][1])
		        zCoords[j].set_text(savedxyz[j+1][2])
	    else:
        	self.Win.show_all()
		print '!!!! previous point probe setting has some problem'
		md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error loading previous setting")
		md.run()
		md.destroy()

        self.Win.show_all()
    #------------------------------------------------------------------------------------------
    def plotsurface(self):

	a1=glob.glob(self.caseDir+'/temporary/probesurface')
	if len(a1)!=0:
	    f=open(self.caseDir+'/temporary/probesurface','r');ff=f.readlines();f.close()
	    if ff[0][:-1]=='True':pCheck='yes'
	    else:pCheck='no'
	    if ff[1][:-1]=='True':UCheck='yes'
	    else:UCheck='no'
	else:
	    print 'Error!! Probe surface is not set'

	aa=glob.glob(self.caseDir+'/postProcessing/patchAverage_surfaceProbes/*')
	times=[]
	for ii in aa:
	    bb=ii.split('/');times.append(bb[-1])
	times.sort()
	lastTime=times[-1]

	f=open(self.caseDir+'/plotcmd','w')
	f.write('set terminal wxt\n')
	f.write('set xlabel "time"\n')
	path=self.caseDir+'/postProcessing/patchAverage_surfaceProbes/'
	if pCheck=='yes':
	    if UCheck=='yes':
	        f.write("plot '"+path+lastTime+"/p' u 1:2 w l title 'p','"+path+lastTime+"/U' u 1:3 w l title 'Uy'\n")
	    elif UCheck=='no':
	        f.write("plot '"+path+lastTime+"/p' u 1:2 w l title 'p'\n")
	elif pCheck=='no':
	    if UCheck=='yes':
	        f.write("plot '"+path+lastTime+"/U' u 1:3 w l title 'Uy'\n")
	    elif UCheck=='no':
	        pass
	f.close()

	ccc='gnuplot -persist '+self.caseDir+'/plotcmd'
	os.system(ccc)   
    #------------------------------------------------------------------------------------------
    def surfaceProbe(self):

	def start(widget,data=None):

	    selp=self.pCheck.get_active();selu=self.uCheck.get_active();inter=self.interval.get_text()
	    
	    selectedSet=[];tf=[]
	    for i in range(len(bcName)):
		aa=setName[i].get_active()		   
		if aa==True:selectedSet.append(bcName[i])		
	    print 'selected patches for surface probe are ',selectedSet

	    if len(selectedSet)==0:
		aa=glob.glob(self.caseDir+'/system/surfaceProbeFunction')
		if len(aa)!=0:os.system('rm '+self.caseDir+'/system/surfaceProbeFunction')
		bb=glob.glob(self.caseDir+'/temporary/probesurface')
		if len(bb)!=0:os.system('rm '+self.caseDir+'/temporary/probesurface')
	    else:
	        f=open(self.caseDir+'/system/surfaceProbeFunction','w')
	        f.write('    surfaceProbes\n')
	        f.write('    {\n')
	        f.write('        functionObjectLibs ( "libsimpleFunctionObjects.so" );\n')
	        f.write('        type            patchAverage;\n')
	        f.write('        verbose         true;\n')	
	        f.write('        outputControlMode   timeStep;\n')
	        f.write('        outputInterval  '+inter+';\n')
	        f.write('        factor          1;\n')
	        f.write('\n')
	        f.write('        fields\n')
	        f.write('        (\n')
	        if selp==True:f.write('            p\n')
	        if selu==True:f.write('            U\n')
	        f.write('        );\n')
	        f.write('\n')
	        f.write('        patches\n')
	        f.write('        (\n')
	        for i in range(len(selectedSet)):f.write('            '+selectedSet[i]+'\n')
	        f.write('        );\n')
	        f.write('    }\n') 
	        f.close()

	        ff=open(self.caseDir+'/temporary/probesurface','w')
	        if selp==True:ff.write('True'+'\n')
	        else:ff.write('False'+'\n')
	        if selu==True:ff.write('True'+'\n')
	        else:ff.write('False'+'\n')
	        ff.write(inter+'\n')
	        for ii in selectedSet:ff.write(ii+',')
	        ff.close()	

	    self.Win.destroy()
	#-----------------------------------------------------------------------------
	def stop(widget,data=None):
	    self.Win.destroy()

	#-- GUI part ---------------------------------------------------------------------------        
        self.Win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.Win.connect('delete_event',self.delete_event);self.Win.connect('destroy',self.destroy)
        self.Win.set_border_width(10);self.Win.set_title('Set Surface to probe')
	self.Win.set_position(gtk.WIN_POS_CENTER)

	GEN=generalClass(self.caseDir);bcName=GEN.getBCName()

        self.vbox=gtk.VBox(False,5);self.varBox=gtk.VBox(False,5)

	self.regbox=gtk.HBox(False,5);self.vbox.pack_start(self.regbox,False,False,5)
	
	self.varFrame=gtk.Frame()
        self.varFrame.set_label('Probe variables');self.varFrame.set_label_align(0.0,1.0)
        self.varFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        
        self.Win.add(self.vbox);self.vbox.pack_start(self.varFrame,False,False,5)
        self.varFrame.add(self.varBox)

	self.pCheck=gtk.CheckButton('p');self.pCheck.set_active(1)
	self.uCheck=gtk.CheckButton('U')

	self.varBox.pack_start(self.pCheck,False,False,5)
	self.varBox.pack_start(self.uCheck,False,False,5)
	#------------------------------
	self.interBox=gtk.HBox(False,5)
	self.label=gtk.Label('Output interval')
	self.interval=gtk.Entry();self.interval.set_text('1');self.interval.set_size_request(100,28)

	self.vbox.pack_start(self.interBox,False,False,5)
	self.interBox.pack_start(self.label,False,False,5);self.interBox.pack_start(self.interval,False,False,5)

	self.locFrame=gtk.Frame()
        self.locFrame.set_label('Probe Surfaces');self.locFrame.set_label_align(0.0,1.0)
        self.locFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)

	self.vbox.pack_start(self.locFrame,False,False,5)

        self.swin=gtk.ScrolledWindow();self.swin.set_border_width(5);self.swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        self.locFrame.add(self.swin)
        itembox=gtk.VBox(False,0)
        self.swin.add_with_viewport(itembox)
        scheight=len(bcName)*38
        if scheight > 750:scheight=750        
        #self.swin.set_size_request(300,scheight)
        self.swin.set_size_request(300,500)

        setName=[];hbox1=[]
	    
        for i in range(len(bcName)):
            hbox1.append(gtk.HBox(False,5));itembox.pack_start(hbox1[i],False,False,2)                
            setName.append(gtk.CheckButton(bcName[i]));setName[i].set_size_request(180,28)	    
            hbox1[i].pack_start(setName[i],False,False,0)
	#-----------------------------------
	self.buttonBox=gtk.HBox(False,5)
	self.vbox.pack_start(self.buttonBox,False,False,5)

	self.appB=gtk.Button('Apply');self.closeB=gtk.Button('Cancel')
	self.appB.set_size_request(100,28);self.closeB.set_size_request(100,28)
	self.appB.connect('clicked',start);self.closeB.connect('clicked',stop)
	self.buttonBox.pack_end(self.closeB,False,False,5);self.buttonBox.pack_end(self.appB,False,False,5)
	#-----------------------------------
	ggg=glob.glob(self.caseDir+'/temporary/probesurface')
	if len(ggg)!=0:
	    f=open(self.caseDir+'/temporary/probesurface','r');ff=f.readlines();f.close()
	    if len(ff)>2:
	        if ff[0][:-1]=='True':self.pCheck.set_active(1)
	        else:self.pCheck.set_active(0)
	        if ff[1][:-1]=='True':self.uCheck.set_active(1)
	        else:self.uCheck.set_active(0)
	        self.interval.set_text(ff[2][:-1])
	        q1=ff[3][:-1];patches=q1.split(',')
		activepatches=[]
		for ii in patches:activepatches.append(bcName.index(ii))
		for i in range(len(activepatches)):setName[activepatches[i]].set_active(True)
	    else:
        	self.Win.show_all()
		print '!!!! previous point probe setting has some problem'
		md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error loading previous setting")
		md.run()
		md.destroy()

        self.Win.show_all()
    #------------------------------------------------------------------------------------------
    def plotflowrate(self):

	a1=glob.glob(self.caseDir+'/temporary/flowrate')
	if len(a1)!=0:
	    f=open(self.caseDir+'/temporary/flowrate','r');ff=f.readlines();f.close()
	    aa=ff[0][:-1];patches=aa.split(',')
	else:
	    print 'Error!! Probe point is not set'

	aa=glob.glob(self.caseDir+'/postProcessing/patchMassFlows_flowrate/*')
	times=[]
	for ii in aa:
	    bb=ii.split('/')
	    times.append(bb[-1])
	times.sort()
	lastTime=times[-1]

	f=open(self.caseDir+'/plotcmd','w')
	f.write('set terminal wxt\n')
	f.write('set xlabel "time"\n')
	path=self.caseDir+'/postProcessing/patchMassFlows_flowrate/'
	f.write("plot ")
	for i in range(len(patches)):
	    if i+1!=len(patches):
	        f.write("'"+path+lastTime+"/massFlow' u 1:"+str(i+2)+" w l title '"+patches[i]+"',")
	    else:
	        f.write("'"+path+lastTime+"/massFlow' u 1:"+str(i+2)+" w l title '"+patches[i]+"'")
	f.close()

	ccc='gnuplot -persist '+self.caseDir+'/plotcmd'
	os.system(ccc)  
    #------------------------------------------------------------------------------------------
    def flowrate(self):

	def start(widget,data=None):
    
	    selectedSet=[];tf=[]
	    for i in range(len(bcName)):
		aa=setName[i].get_active()		   
		if aa==True:selectedSet.append(bcName[i])		
	    print 'selected patches for surface probe are ',selectedSet

	    if len(selectedSet)==0:
		aa=glob.glob(self.caseDir+'/system/flowRateFunction')
		if len(aa)!=0:os.system('rm '+self.caseDir+'/system/flowRateFunction')
		bb=glob.glob(self.caseDir+'/temporary/flowrate')
		if len(bb)!=0:os.system('rm '+self.caseDir+'/temporary/flowrate')
	    else:
	        f=open(self.caseDir+'/system/flowRateFunction','w')
	        f.write('    flowrate\n')
	        f.write('    {\n')
	        f.write('        functionObjectLibs ( "libsimpleFunctionObjects.so" );\n')
	        f.write('        type            patchMassFlow;\n')
	        f.write('        verbose         true;\n')	
	        f.write('        outputControlMode   timeStep;\n')
	        f.write('        outputInterval  1;\n')
	        f.write('        factor          1;\n')
	        f.write('\n')
	        f.write('\n')
	        f.write('        patches\n')
	        f.write('        (\n')
	        for i in range(len(selectedSet)):f.write('            '+selectedSet[i]+'\n')
	        f.write('        );\n')
	        f.write('    }\n') 
	        f.close()

	        ff=open(self.caseDir+'/temporary/flowrate','w')
	        for ii in selectedSet:ff.write(ii+',')
	        ff.close()	

	    self.Win.destroy()
	#-----------------------------------------------------------------------------
	def stop(widget,data=None):
	    self.Win.destroy()

	#-- GUI part ---------------------------------------------------------------------------        
        self.Win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.Win.connect('delete_event',self.delete_event);self.Win.connect('destroy',self.destroy)
        self.Win.set_border_width(10);self.Win.set_title('Set Surface to check flowrate')
	self.Win.set_position(gtk.WIN_POS_CENTER)

	GEN=generalClass(self.caseDir);bcName=GEN.getBCName()

        self.vbox=gtk.VBox(False,5)
	self.Win.add(self.vbox)

	self.locFrame=gtk.Frame()
        self.locFrame.set_label('patches to check flowrate');self.locFrame.set_label_align(0.0,1.0)
        self.locFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)

	self.vbox.pack_start(self.locFrame,False,False,5)

        self.swin=gtk.ScrolledWindow();self.swin.set_border_width(5);self.swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        self.locFrame.add(self.swin)
        itembox=gtk.VBox(False,0)
        self.swin.add_with_viewport(itembox)
        scheight=len(bcName)*38
        if scheight > 750:scheight=750        
        #self.swin.set_size_request(300,scheight)
        self.swin.set_size_request(300,500)

        setName=[];hbox1=[]
	    
        for i in range(len(bcName)):
            hbox1.append(gtk.HBox(False,5));itembox.pack_start(hbox1[i],False,False,2)      
            setName.append(gtk.CheckButton(bcName[i]));setName[i].set_size_request(180,28)
            hbox1[i].pack_start(setName[i],False,False,0)
	#-----------------------------------
	self.buttonBox=gtk.HBox(False,5)
	self.vbox.pack_start(self.buttonBox,False,False,5)

	self.appB=gtk.Button('Apply');self.closeB=gtk.Button('Cancel')
	self.appB.set_size_request(100,28);self.closeB.set_size_request(100,28)
	self.appB.connect('clicked',start);self.closeB.connect('clicked',stop)
	self.buttonBox.pack_end(self.closeB,False,False,5);self.buttonBox.pack_end(self.appB,False,False,5)
	#-----------------------------------
	ggg=glob.glob(self.caseDir+'/temporary/flowrate')
	if len(ggg)!=0:
	    f=open(self.caseDir+'/temporary/flowrate','r');ff=f.readlines();f.close()
	    if len(ff)>0:
	        q1=ff[0][:-1];patches=q1.split(',')
		activepatches=[]
		for ii in patches:activepatches.append(bcName.index(ii))
		for i in range(len(activepatches)):setName[activepatches[i]].set_active(True)
	    else:
        	self.Win.show_all()
		print '!!!! previous point probe setting has some problem'
		md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error loading previous setting")
		md.run()
		md.destroy()

        self.Win.show_all() 
    #------------------------------------------------------------------------------------------
    def plotforce(self):

	a1=glob.glob(self.caseDir+'/temporary/forcereport')
	if len(a1)!=0:
	    f=open(self.caseDir+'/temporary/forcereport','r');ff=f.readlines();f.close()
	    faces=[]
	    for ii in ff:faces.append(ii[:-1])
	else:
	    print 'Error!! Probe point is not set'

	aa=glob.glob(self.caseDir+'/postProcessing/forceCoeffs/*')
	times=[]
	for ii in aa:
	    bb=ii.split('/')
	    times.append(bb[-1])
	times.sort()
	lastTime=times[-1]

	bb=glob.glob(self.caseDir+'/postProcessing/forceCoeffs/'+lastTime+'/forceCoeff*')
	bb.sort();forcefile=bb[-1]
	f=open(self.caseDir+'/plotcmd','w')
	f.write('set terminal wxt\n')
	f.write('set xlabel "time"\n')
	f.write("plot '"+forcefile+"' u 1:3 w l title 'Cd'\n")
	f.close()

	ccc='gnuplot -persist '+self.caseDir+'/plotcmd'
	os.system(ccc) 
    #------------------------------------------------------------------------------------------
    def forceSet(self):
	GEN=generalClass(self.caseDir);bcnameori=GEN.getBCName();bctype=GEN.getBCType()
        bcname=[]
        for i in range(len(bctype)):
            if bctype[i]=='wall':bcname.append(bcnameori[i])

	def applythis(widget):
	    rho=rhoEntry.get_text();aref=arefEntry.get_text();uref=urefEntry.get_text()
	    cofrx=cxEntry.get_text();cofry=cyEntry.get_text();cofrz=czEntry.get_text()
	    dragx=dragxEntry.get_text();dragy=dragyEntry.get_text();dragz=dragzEntry.get_text()
	    liftx=liftxEntry.get_text();lifty=liftyEntry.get_text();liftz=liftzEntry.get_text()
	    cofr=[cofrx,cofry,cofrz];dragdir=[dragx,dragy,dragz];liftdir=[liftx,lifty,liftz]
	    onOff=[]
	    for i in range(len(bcname)):
		vvv=checkBCs[i].get_active();onOff.append(vvv)
	    faces=[]
	    for i in range(len(bcname)):
	        if onOff[i]==1:faces.append(bcname[i])
	    if len(faces)!=0:
	        f=open(self.caseDir+'/temporary/forceMonitor','w')
	        for ii in faces:f.write(ii+' ')
		f.write('\n')
		f.write(rho+' '+aref+' '+uref+' '+cofr[0]+' '+cofr[1]+' '+cofr[2]+' '+dragdir[0]+' '+dragdir[1]+' '+dragdir[2]+' '+liftdir[0]+' '+liftdir[1]+' '+liftdir[2]+'\n')
	        f.close()
                crFile=writeFileClassIncompressible(self.caseDir);crFile.force(faces,rho,aref,uref,cofr,dragdir,liftdir)
		crFile.customRegexp()
	    else:
		os.system('rm '+self.caseDir+'/customRegexp');os.system('rm '+self.caseDir+'/temporary/forceMonitor');os.system('rm '+self.caseDir+'/system/force*')
	    mwin.destroy()
        
        def closethis(widget):
            mwin.destroy()

        onOff=[]
        for i in range(len(bcname)):onOff.append(0)

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Force');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

	#frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
	#mainbox.pack_start(frame,False,False,5)
	vbox=gtk.VBox(False,5)#;frame.add(vbox)
	mainbox.pack_start(vbox,False,False,5)

        swbc = gtk.ScrolledWindow();swbc.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        swbc.set_size_request(300,300)
	bcbox=gtk.VBox(False,5)
        swbc.add_with_viewport(bcbox)

        vbox.pack_start(swbc,True,True,5)

	bclabel=gtk.Label('Select patches for forces')
	bcbox.pack_start(bclabel,False,False,5)
	checkBCs=[]
	for i in range(len(bcname)):
	    checkBCs.append(gtk.CheckButton(bcname[i]))
	    bcbox.pack_start(checkBCs[i],False,False,5)

	frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
	vbox.pack_start(frame,False,False,5)
	vvbox=gtk.VBox(False,5);frame.add(vvbox)

	rhobox=gtk.HBox(False,5);vvbox.pack_start(rhobox,True,True,5)
	label=gtk.Label('Density [kg/m3]')
	rhoEntry=gtk.Entry();rhoEntry.set_size_request(60,28);rhoEntry.set_text('1.2')
	rhobox.pack_start(label,False,False,5);rhobox.pack_end(rhoEntry,False,False,5)

	arefbox=gtk.HBox(False,5);vvbox.pack_start(arefbox,False,False,5)
	label=gtk.Label('Reference area [m2]')
	arefEntry=gtk.Entry();arefEntry.set_size_request(60,28);arefEntry.set_text('1')
	arefbox.pack_start(label,False,False,5);arefbox.pack_end(arefEntry,False,False,5)

	urefbox=gtk.HBox(False,5);vvbox.pack_start(urefbox,False,False,5)
	label=gtk.Label('Reference velocity [m/s]')
	urefEntry=gtk.Entry();urefEntry.set_size_request(60,28);urefEntry.set_text('1')
	urefbox.pack_start(label,False,False,5);urefbox.pack_end(urefEntry,False,False,5)

	cofrbox=gtk.HBox(False,5);vvbox.pack_start(cofrbox,False,False,5)
	label=gtk.Label('CofR')
	cxEntry=gtk.Entry();cxEntry.set_size_request(60,28);cxEntry.set_text('0')
	cyEntry=gtk.Entry();cyEntry.set_size_request(60,28);cyEntry.set_text('0')
	czEntry=gtk.Entry();czEntry.set_size_request(60,28);czEntry.set_text('0')
	cofrbox.pack_start(label,False,False,5);cofrbox.pack_end(czEntry,False,False,5)
	cofrbox.pack_end(cyEntry,False,False,0);cofrbox.pack_end(cxEntry,False,False,5)

	dragdirbox=gtk.HBox(False,5);vvbox.pack_start(dragdirbox,False,False,5)
	label=gtk.Label('Drag direction')
	dragxEntry=gtk.Entry();dragxEntry.set_size_request(60,28);dragxEntry.set_text('1')
	dragyEntry=gtk.Entry();dragyEntry.set_size_request(60,28);dragyEntry.set_text('0')
	dragzEntry=gtk.Entry();dragzEntry.set_size_request(60,28);dragzEntry.set_text('0')
	dragdirbox.pack_start(label,False,False,5);dragdirbox.pack_end(dragzEntry,False,False,5)
	dragdirbox.pack_end(dragyEntry,False,False,0);dragdirbox.pack_end(dragxEntry,False,False,5)

	liftdirbox=gtk.HBox(False,5);vvbox.pack_start(liftdirbox,False,False,5)
	label=gtk.Label('Lift direction')
	liftxEntry=gtk.Entry();liftxEntry.set_size_request(60,28);liftxEntry.set_text('0')
	liftyEntry=gtk.Entry();liftyEntry.set_size_request(60,28);liftyEntry.set_text('0')
	liftzEntry=gtk.Entry();liftzEntry.set_size_request(60,28);liftzEntry.set_text('1')
	liftdirbox.pack_start(label,False,False,5);liftdirbox.pack_end(liftzEntry,False,False,5)
	liftdirbox.pack_end(liftyEntry,False,False,0);liftdirbox.pack_end(liftxEntry,False,False,5)

        clsB=gtk.Button(label='Close');clsB.connect('clicked',closethis);clsB.set_size_request(100,28)
        appB=gtk.Button(label='Apply');appB.connect('clicked',applythis);appB.set_size_request(100,28)
	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
	buttonbox.pack_end(clsB,False,False,5);buttonbox.pack_end(appB,False,False,5)

	aa=glob.glob(self.caseDir+'/temporary/forceMonitor')
	if len(aa)!=0:
	    f=open(aa[0],'r');ff=f.readlines();f.close()
	    patchs=ff[0][:-2].split(' ')
	    for i in range(len(patchs)):
		bb=bcname.index(patchs[i]);checkBCs[bb].set_active(1)
	    rr=ff[1][:-1].split(' ')
	    rhoEntry.set_text(rr[0]);arefEntry.set_text(rr[1]);urefEntry.set_text(rr[2])
	    cxEntry.set_text(rr[3]);cyEntry.set_text(rr[4]);czEntry.set_text(rr[5])
	    dragxEntry.set_text(rr[6]);dragyEntry.set_text(rr[7]);dragzEntry.set_text(rr[8])
	    liftxEntry.set_text(rr[9]);liftyEntry.set_text(rr[10]);liftzEntry.set_text(rr[11])

        mwin.show_all()
    #------------------------------------------------------------------------------------------
    def openForce(self):
	GEN=generalClass(self.caseDir);bcnameori=GEN.getBCName();bctype=GEN.getBCType()
        bcname=[]
        for i in range(len(bctype)):
            if bctype[i]=='wall':bcname.append(bcnameori[i])

        def force(widget):
	    rho=rhoEntry.get_text();aref=arefEntry.get_text();uref=urefEntry.get_text()
	    cofrx=cxEntry.get_text();cofry=cyEntry.get_text();cofrz=czEntry.get_text()
	    dragx=dragxEntry.get_text();dragy=dragyEntry.get_text();dragz=dragzEntry.get_text()
	    liftx=liftxEntry.get_text();lifty=liftyEntry.get_text();liftz=liftzEntry.get_text()
	    cofr=[cofrx,cofry,cofrz];dragdir=[dragx,dragy,dragz];liftdir=[liftx,lifty,liftz]

	    onOff=[]
	    for i in range(len(bcname)):
		vvv=checkBCs[i].get_active();onOff.append(vvv)

            forceDic=self.reportForce(bcname,onOff,rho,cofr,dragdir,liftdir,uref,aref)

            faces=forceDic.keys()
            strings=[];stringf=''
            string0='# -- Pressure Force x,y,z --- \n'
            ssx=0;ssy=0;ssz=0;pressureForce=[]
            for i in range(len(faces)):
                ss=forceDic[faces[i]];pf=ss[0]
                pressureForce.append([pf[0],pf[1],pf[2]])
                string=faces[i]+' : '+pf[0]+'   '+pf[1]+'   '+pf[2]+' \n'
                strings.append(string)
                ssx=ssx+float(pf[0]);ssy=ssy+float(pf[1]);ssz=ssz+float(pf[2])		
            for i in range(len(faces)):stringf=stringf+strings[i]
            stringsum='total : '+str(ssx)+'    '+str(ssy)+'    '+str(ssz)+' \n'		
            stringpf=string0+stringf+stringsum
            pressureForceTotal=[ssx,ssy,ssz]

            strings=[];stringf=''
            string0='# -- Viscous Force x,y,z --- \n'
            ssx=0;ssy=0;ssz=0;viscousForce=[]
            for i in range(len(faces)):
                ss=forceDic[faces[i]];vf=ss[1]
                viscousForce.append([vf[0],vf[1],vf[2]])
                string=faces[i]+' : '+vf[0]+'   '+vf[1]+'   '+vf[2]+' \n'
                strings.append(string)
                ssx=ssx+float(vf[0]);ssy=ssy+float(vf[1]);ssz=ssz+float(vf[2])
            for i in range(len(faces)):stringf=stringf+strings[i]
            stringsum='total : '+str(ssx)+'    '+str(ssy)+'    '+str(ssz)+' \n'
            stringvf=string0+stringf+stringsum
            viscousForceTotal=[ssx,ssy,ssz]

            strings=[];stringf=''
            string0='# -- Pressure Moment x,y,z --- \n'
            ssx=0;ssy=0;ssz=0;pressureMoment=[]
            for i in range(len(faces)):
                ss=forceDic[faces[i]];pm=ss[2]
                pressureMoment.append([pm[0],pm[1],pm[2]])
                string=faces[i]+' : '+pm[0]+'   '+pm[1]+'   '+pm[2]+' \n'
                strings.append(string)
                ssx=ssx+float(pm[0]);ssy=ssy+float(pm[1]);ssz=ssz+float(pm[2])
            for i in range(len(faces)):stringf=stringf+strings[i]
            stringsum='total : '+str(ssx)+'    '+str(ssy)+'    '+str(ssz)+' \n'
            stringpm=string0+stringf+stringsum
            pressureMomentTotal=[ssx,ssy,ssz]		

            strings=[];stringf=''
            string0='# -- Viscous Moment x,y,z --- \n'
            ssx=0;ssy=0;ssz=0;viscousMoment=[]
            for i in range(len(faces)):
                ss=forceDic[faces[i]];vm=ss[3]
                viscousMoment.append([vm[0],vm[1],vm[2]])
                string=faces[i]+' : '+vm[0]+'   '+vm[1]+'   '+vm[2]+' \n'
                strings.append(string)
                ssx=ssx+float(vm[0]);ssy=ssy+float(vm[1]);ssz=ssz+float(vm[2])
            for i in range(len(faces)):stringf=stringf+strings[i]
            stringsum='total : '+str(ssx)+'    '+str(ssy)+'    '+str(ssz)+' \n'
            stringvm=string0+stringf+stringsum
            viscousMomentTotal=[ssx,ssy,ssz]

            string0='# -- Total Force x,y,z --- \n'
            xForceTotal=pressureForceTotal[0]+viscousForceTotal[0]
            yForceTotal=pressureForceTotal[1]+viscousForceTotal[1]
            zForceTotal=pressureForceTotal[2]+viscousForceTotal[2]
            stringForce=str(xForceTotal)+'    '+str(yForceTotal)+'    '+str(zForceTotal)+'\n'
            stringTotalForce=string0+stringForce

            string0='# -- Total Moment x,y,z --- \n'
            xMomentTotal=pressureMomentTotal[0]+viscousMomentTotal[0]
            yMomentTotal=pressureMomentTotal[1]+viscousMomentTotal[1]
            zMomentTotal=pressureMomentTotal[2]+viscousMomentTotal[2]
            stringMoment=str(xMomentTotal)+'    '+str(yMomentTotal)+'    '+str(zMomentTotal)+'\n'
            stringTotalMoment=string0+stringMoment

            stringtot=stringpf+'\n'+stringvf+'\n'+stringpm+'\n'+stringvm+'\n'+stringTotalForce+'\n'+stringTotalMoment
            textbuffer.set_text(stringtot)

	    faces=[]
	    for i in range(len(bcname)):
	        if onOff[i]==1:faces.append(bcname[i])
	    if len(faces)!=0:
	        f=open(self.caseDir+'/temporary/forcereport','w')
	        for ii in faces:f.write(ii+' ')
		f.write('\n')
		f.write(rho+' '+aref+' '+uref+' '+cofr[0]+' '+cofr[1]+' '+cofr[2]+' '+dragdir[0]+' '+dragdir[1]+' '+dragdir[2]+' '+liftdir[0]+' '+liftdir[1]+' '+liftdir[2]+'\n')
	        f.close()
	    else:
		os.system('rm '+self.caseDir+'/temporary/forcereport')


        def forceCoeff(widget):
	    rho=rhoEntry.get_text();aref=arefEntry.get_text();uref=urefEntry.get_text()
	    cofrx=cxEntry.get_text();cofry=cyEntry.get_text();cofrz=czEntry.get_text()
	    dragx=dragxEntry.get_text();dragy=dragyEntry.get_text();dragz=dragzEntry.get_text()
	    liftx=liftxEntry.get_text();lifty=liftyEntry.get_text();liftz=liftzEntry.get_text()
	    cofr=[cofrx,cofry,cofrz];dragdir=[dragx,dragy,dragz];liftdir=[liftx,lifty,liftz]

	    onOff=[]
	    for i in range(len(bcname)):
		vvv=checkBCs[i].get_active();onOff.append(vvv)

	    orix=cxEntry.get_text();oriy=cyEntry.get_text();oriz=czEntry.get_text()
            forceCoeffList=self.reportForceCoeff(bcname,onOff,rho,cofr,dragdir,liftdir,uref,aref)
	    #print 'ccc',forceCoeffList

            string0='# -- Force Coefficients --- \n'
            string1='\n'+'A_ref : '+aref+'\n'
            string2='U_ref : '+uref+'\n'
            string3='rho_ref : '+rho+'\n'
            string4='center of rotation : ('+cofr[0]+' '+cofr[1]+' '+cofr[2]+')\n'
            cdstr='\n'+'Cd = '+forceCoeffList[0]+'\n';clstr='Cl = '+forceCoeffList[1]+'\n'
            cmstr='Cm = '+forceCoeffList[2]+'\n'
            string=string0+string1+string2+string3+string4+cdstr+clstr+cmstr
            textbuffer.set_text(string)

	    faces=[]
	    for i in range(len(bcname)):
	        if onOff[i]==1:faces.append(bcname[i])
	    if len(faces)!=0:
	        f=open(self.caseDir+'/temporary/forcereport','w')
	        for ii in faces:f.write(ii+' ')
		f.write('\n')
		f.write(rho+' '+aref+' '+uref+' '+cofr[0]+' '+cofr[1]+' '+cofr[2]+' '+dragdir[0]+' '+dragdir[1]+' '+dragdir[2]+' '+liftdir[0]+' '+liftdir[1]+' '+liftdir[2]+'\n')
	        f.close()
	    else:
		os.system('rm '+self.caseDir+'/temporary/forcereport')
        
        def closewin(widget):
            mwin.destroy()

        onOff=[]
        for i in range(len(bcname)):onOff.append(0)

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Force report');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.HBox(False,0)
        leftbox=gtk.VBox(False,5)#;leftbox.set_size_request(250,500);leftbox.set_border_width(10)
        rightbox=gtk.VBox(False,10);rightbox.set_size_request(500,600);rightbox.set_border_width(10)
        bcbox=gtk.VBox(False,5)	  
        mwin.add(mainbox);mainbox.pack_start(leftbox,False,False,0);mainbox.pack_start(rightbox,False,False,0)

        swbc = gtk.ScrolledWindow();swbc.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC);swbc.set_size_request(250,200)
        swbc.add_with_viewport(bcbox)

        leftbox.pack_start(swbc,True,True,5)

	bclabel=gtk.Label('Select patches for forces')
	bcbox.pack_start(bclabel,False,False,5)
	checkBCs=[]
	for i in range(len(bcname)):
	    checkBCs.append(gtk.CheckButton(bcname[i]))
	    bcbox.pack_start(checkBCs[i],False,False,5)

	rhobox=gtk.HBox(False,5);leftbox.pack_start(rhobox,True,True,5)
	label=gtk.Label('Density [kg/m3]')
	rhoEntry=gtk.Entry();rhoEntry.set_size_request(60,28);rhoEntry.set_text('1.2')
	rhobox.pack_start(label,False,False,5);rhobox.pack_end(rhoEntry,False,False,5)

	arefbox=gtk.HBox(False,5);leftbox.pack_start(arefbox,False,False,5)
	label=gtk.Label('Reference area [m2]')
	arefEntry=gtk.Entry();arefEntry.set_size_request(60,28);arefEntry.set_text('1')
	arefbox.pack_start(label,False,False,5);arefbox.pack_end(arefEntry,False,False,5)

	urefbox=gtk.HBox(False,5);leftbox.pack_start(urefbox,False,False,5)
	label=gtk.Label('Reference velocity [m/s]')
	urefEntry=gtk.Entry();urefEntry.set_size_request(60,28);urefEntry.set_text('1')
	urefbox.pack_start(label,False,False,5);urefbox.pack_end(urefEntry,False,False,5)

	cofrbox=gtk.HBox(False,5);leftbox.pack_start(cofrbox,False,False,5)
	label=gtk.Label('CofR')
	cxEntry=gtk.Entry();cxEntry.set_size_request(60,28);cxEntry.set_text('0')
	cyEntry=gtk.Entry();cyEntry.set_size_request(60,28);cyEntry.set_text('0')
	czEntry=gtk.Entry();czEntry.set_size_request(60,28);czEntry.set_text('0')
	cofrbox.pack_start(label,False,False,5);cofrbox.pack_end(czEntry,False,False,5)
	cofrbox.pack_end(cyEntry,False,False,0);cofrbox.pack_end(cxEntry,False,False,5)

	dragdirbox=gtk.HBox(False,5);leftbox.pack_start(dragdirbox,False,False,5)
	label=gtk.Label('Drag dir.')
	dragxEntry=gtk.Entry();dragxEntry.set_size_request(60,28);dragxEntry.set_text('1')
	dragyEntry=gtk.Entry();dragyEntry.set_size_request(60,28);dragyEntry.set_text('0')
	dragzEntry=gtk.Entry();dragzEntry.set_size_request(60,28);dragzEntry.set_text('0')
	dragdirbox.pack_start(label,False,False,5);dragdirbox.pack_end(dragzEntry,False,False,5)
	dragdirbox.pack_end(dragyEntry,False,False,0);dragdirbox.pack_end(dragxEntry,False,False,5)

	liftdirbox=gtk.HBox(False,5);leftbox.pack_start(liftdirbox,False,False,5)
	label=gtk.Label('Lift dir.')
	liftxEntry=gtk.Entry();liftxEntry.set_size_request(60,28);liftxEntry.set_text('0')
	liftyEntry=gtk.Entry();liftyEntry.set_size_request(60,28);liftyEntry.set_text('0')
	liftzEntry=gtk.Entry();liftzEntry.set_size_request(60,28);liftzEntry.set_text('1')
	liftdirbox.pack_start(label,False,False,5);liftdirbox.pack_end(liftzEntry,False,False,5)
	liftdirbox.pack_end(liftyEntry,False,False,0);liftdirbox.pack_end(liftxEntry,False,False,5)

	buttonbox=gtk.VBox(False,5);leftbox.pack_start(buttonbox,False,False,5)

        forceB=gtk.Button(label='force');forceB.connect('clicked',force);forceB.set_size_request(90,28)
        closebutton=gtk.Button(label='close');closebutton.connect('clicked',closewin)
        coeffB=gtk.Button(label='forceCoeff');coeffB.connect('clicked',forceCoeff)
        #applyB=gtk.Button(label='apply');applyB.connect('clicked',applythis)

	bubox1=gtk.HBox(False,5);buttonbox.pack_start(bubox1,False,False,5)
	bubox2=gtk.HBox(False,5);buttonbox.pack_start(bubox2,False,False,5)
	bubox1.pack_start(forceB,True,True,5);bubox1.pack_end(coeffB,True,True,5)
	#bubox2.pack_start(applyB,True,True,5)
	bubox2.pack_end(closebutton,True,True,5)

        sw = gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview = gtk.TextView()
        textbuffer = textview.get_buffer()
        sw.add(textview)
        rightbox.pack_start(sw,True,True,5)
        textbuffer.set_text('#-------------- force report---------------')

	aa=glob.glob(self.caseDir+'/temporary/forcereport')
	if len(aa)!=0:
	    f=open(aa[0],'r');ff=f.readlines();f.close()
	    patchs=ff[0][:-2].split(' ')
	    for i in range(len(patchs)):
		bb=bcname.index(patchs[i]);checkBCs[bb].set_active(1)
	    rr=ff[1][:-1].split(' ')
	    rhoEntry.set_text(rr[0]);arefEntry.set_text(rr[1]);urefEntry.set_text(rr[2])
	    cxEntry.set_text(rr[3]);cyEntry.set_text(rr[4]);czEntry.set_text(rr[5])
	    dragxEntry.set_text(rr[6]);dragyEntry.set_text(rr[7]);dragzEntry.set_text(rr[8])
	    liftxEntry.set_text(rr[9]);liftyEntry.set_text(rr[10]);liftzEntry.set_text(rr[11])

        mwin.show_all()
    #-------------------------------------------------------------------------------------
    def reportForce(self,bcname,onOff,rho,cofr,dragdir,liftdir,Uref,Aref):

	faces=[]
	for i in range(len(bcname)):
	    if onOff[i]==1:faces.append(bcname[i])

	forceList={}

        f=open(self.caseDir+'/system/execFlowFunctionDict','w')
	f.write('FoamFile \n')
	f.write('{ \n')
	f.write('    version    2.0; \n')
	f.write('    format     ascii; \n')
	f.write('    class      dictionary; \n')
	f.write('    object     execFlowFunctionDict; \n')
	f.write('} \n')
	f.write(' \n')
	f.write('functions \n')
	f.write('{ \n')
	f.write('    forces \n')
	f.write('    { \n')
	f.write('	     type          forces; \n')
	f.write('	     functionObjectLibs ( "libforces.so" ); \n')
	f.write('	     outputControl timeStep; \n')
	f.write('	     outputInterval 1; \n')
	f.write('	     patches \n')
	f.write('	     ( \n')
	for ii in faces:f.write('	     '+ii+' \n')
	f.write('	     ); \n')
	f.write('	     rhoName   rhoInf; \n')
	f.write('	     UName     U; \n')
	f.write('	     pName     p; \n')
	f.write('	     log       true; \n')
	f.write('	     rhoInf    '+rho+'; \n')
	f.write('	     CofR      ('+cofr[0]+' '+cofr[1]+' '+cofr[2]+'); \n')
	f.write('    } \n')
	f.write(' \n')
	f.write('} \n')
	f.close()


	os.system('cp '+self.caseDir+'/constant/RASProperties '+self.caseDir+'/constant/oriRASProperties') # temporary 
	crFile=writeFileClassIncompressible(self.caseDir);crFile.RASProperties('kEpsilon') # temporary 

        os.system('execFlowFunctionObjects -case '+self.caseDir+' -dict '+self.caseDir+'/system/execFlowFunctionDict -latestTime > '+self.caseDir+'/forceLog ')

	os.system('cp '+self.caseDir+'/constant/oriRASProperties '+self.caseDir+'/constant/RASProperties') # temporary 

	f=open(self.caseDir+'/forceLog','r');ff=f.readlines();f.close()
	for j in range(len(ff)):
	    aa=ff[j].strip()
	    if aa[:13]=='sum of forces':
		pforce=ff[j+1];vforce=ff[j+2]
	    if aa[:14]=='sum of moments':
		pmoment=ff[j+1];vmoment=ff[j+2]

	pf1=pforce.strip();pf2=pf1.split(':')[1];pf3=pf2.strip()[1:-1]
	pressureforce=pf3.split(' ')
	vf1=vforce.strip();vf2=vf1.split(':')[1];vf3=vf2.strip()[1:-1]
	viscousforce=vf3.split(' ')
	pm1=pmoment.strip();pm2=pm1.split(':')[1];pm3=pm2.strip()[1:-1]
	pressuremoment=pm3.split(' ')
	vm1=vmoment.strip();vm2=vm1.split(':')[1];vm3=vm2.strip()[1:-1]
	viscousmoment=vm3.split(' ')

	for ii in faces:forceList[ii]=[pressureforce,viscousforce,pressuremoment,viscousmoment]

	return forceList
    #-------------------------------------------------------------------------------------
    def reportForceCoeff(self,bcname,onOff,rho,cofr,dragdir,liftdir,Uref,Aref):

	faces=[]
	for i in range(len(bcname)):
	    if onOff[i]==1:faces.append(bcname[i])

	forceCoeffList=[]
	f=open(self.caseDir+'/system/execFlowFunctionsDictCoeff','w')
	f.write('FoamFile \n')
	f.write('{ \n')
	f.write('    version    2.0; \n')
	f.write('    format     ascii; \n')
	f.write('    class      dictionary; \n')
	f.write('    object     execFlowFunctionsDict; \n')
	f.write('} \n')
	f.write(' \n')
	f.write('functions \n')
	f.write('{ \n')
	f.write('forcesCoeffs \n')
	f.write('    { \n')
	f.write('        type          forceCoeffs; \n')
	f.write('        functionObjectLibs ( "libforces.so" ); \n')
	f.write('        outputControl timeStep; \n')
	f.write('        outputInterval 1; \n')
	f.write('        patches \n')
	f.write('        ( \n')
	for ii in faces:f.write('            '+ii+' \n')
	f.write('        ); \n')
	f.write('        rhoName     rhoInf; \n')
	f.write('        log         true; \n')
	f.write('        rhoInf      '+rho+'; \n')
	f.write('	 CofR        ('+cofr[0]+' '+cofr[1]+' '+cofr[2]+'); \n')
	f.write('        liftDir     ('+liftdir[0]+' '+liftdir[1]+' '+liftdir[2]+'); \n')
	f.write('        dragDir     ('+dragdir[0]+' '+dragdir[1]+' '+dragdir[2]+'); \n')
	f.write('        pitchAxis   (0 1 0); \n')
	f.write('        magUInf     '+Uref+'; \n')
	f.write('        lRef        1; \n')
	f.write('        Aref        '+Aref+'; \n')
	f.write('    } \n')
	f.write('} \n')
	f.close()

	os.system('cp '+self.caseDir+'/constant/RASProperties '+self.caseDir+'/constant/oriRASProperties') # temporary 
	crFile=writeFileClassIncompressible(self.caseDir);crFile.RASProperties('kEpsilon') # temporary 

        os.system('execFlowFunctionObjects -case '+self.caseDir+' -dict '+self.caseDir+'/system/execFlowFunctionsDictCoeff -latestTime > '+self.caseDir+'/forceCoeffLog ')

	os.system('cp '+self.caseDir+'/constant/oriRASProperties '+self.caseDir+'/constant/RASProperties') # temporary 

	f=open(self.caseDir+'/forceCoeffLog','r');ff=f.readlines();f.close()
	for j in range(len(ff)):
	    if ff[j][:5]=='force':
	        cd=ff[j+2];cl=ff[j+3];cm=ff[j+1]
	cds=cd.strip();cdst=cds.split();cdstr=cdst[2]
	cls=cl.strip();clst=cls.split();clstr=clst[2]
	cms=cm.strip();cmst=cms.split();cmstr=cmst[2]
	forceCoeffList=[cdstr,clstr,cmstr]

	return forceCoeffList
    #----------------------------------------------------------------------------------------------
    def patchIntegrate(self):

	def applythis(widget):
	    aa=patchCombo.child;patch=aa.get_text()
	    aa=varCombo.child;var=aa.get_text()
	    os.system('patchIntegrate -latestTime -case '+self.caseDir+' '+var+' '+patch+' >'+self.caseDir+'/patchIntegrateLog ')
	    f=open(self.caseDir+'/patchIntegrateLog','r');ff=f.readlines();f.close()
	    res=ff[24:-2];string=''
	    for ii in res:string=string+ii
            textbuffer.set_text(string)	

	def closethis(widget):
	    mwin.destroy()

	GEN=generalClass(self.caseDir);bcname=GEN.getBCName()

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('patch integrate');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

	hbox1=gtk.HBox(False,5);mainbox.pack_start(hbox1,False,False,5)
	hbox2=gtk.HBox(False,5);mainbox.pack_start(hbox2,False,False,5)
	hbox3=gtk.HBox(False,5);hbox3.set_size_request(650,200);mainbox.pack_start(hbox3,False,False,5)

	label=gtk.Label('patch to integrate');label.set_size_request(160,28)
        patchCombo=gtk.combo_box_entry_new_text();patchCombo.set_size_request(140,28)
	for ii in bcname:patchCombo.append_text(ii);patchCombo.set_active(0)
	hbox1.pack_start(label,False,False,5);hbox1.pack_start(patchCombo,False,False,5)

	label=gtk.Label('variable to integrate');label.set_size_request(160,28)
        varCombo=gtk.combo_box_entry_new_text();varCombo.set_size_request(140,28)
	variables=['p','U','k','epsilon','omega']
	for ii in variables:varCombo.append_text(ii);varCombo.set_active(0)
	hbox2.pack_start(label,False,False,5);hbox2.pack_start(varCombo,False,False,5)	
	
        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview = gtk.TextView()
        textbuffer = textview.get_buffer()
        sw.add(textview)
        hbox3.pack_start(sw,True,True,5)

	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
        applyB=gtk.Button(label='Calculate');applyB.connect('clicked',applythis);applyB.set_size_request(140,28)
	buttonbox.pack_end(closeB,False,False,5);buttonbox.pack_end(applyB,False,False,5)

        mwin.show_all()
    #----------------------------------------------------------------------------------------------
    def patchAverage(self):

	def applythis(widget):
	    aa=patchCombo.child;patch=aa.get_text()
	    aa=varCombo.child;var=aa.get_text()
	    os.system('patchAverage -latestTime -case '+self.caseDir+' '+var+' '+patch+' >'+self.caseDir+'/patchAverageLog ')
	    f=open(self.caseDir+'/patchAverageLog','r');ff=f.readlines();f.close()
	    res=ff[24:-2];string=''
	    for ii in res:string=string+ii
            textbuffer.set_text(string)	

	def closethis(widget):
	    mwin.destroy()

	GEN=generalClass(self.caseDir);bcname=GEN.getBCName()

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('patch Average');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

	hbox1=gtk.HBox(False,5);mainbox.pack_start(hbox1,False,False,5)
	hbox2=gtk.HBox(False,5);mainbox.pack_start(hbox2,False,False,5)
	hbox3=gtk.HBox(False,5);hbox3.set_size_request(650,200);mainbox.pack_start(hbox3,False,False,5)

	label=gtk.Label('patch to average');label.set_size_request(160,28)
        patchCombo=gtk.combo_box_entry_new_text();patchCombo.set_size_request(140,28)
	for ii in bcname:patchCombo.append_text(ii);patchCombo.set_active(0)
	hbox1.pack_start(label,False,False,5);hbox1.pack_start(patchCombo,False,False,5)

	label=gtk.Label('variable to average');label.set_size_request(160,28)
        varCombo=gtk.combo_box_entry_new_text();varCombo.set_size_request(140,28)
	variables=['p','U','k','epsilon','omega']
	for ii in variables:varCombo.append_text(ii);varCombo.set_active(0)
	hbox2.pack_start(label,False,False,5);hbox2.pack_start(varCombo,False,False,5)	
	
        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview = gtk.TextView()
        textbuffer = textview.get_buffer()
        sw.add(textview)
        hbox3.pack_start(sw,True,True,5)

	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
        applyB=gtk.Button(label='Calculate');applyB.connect('clicked',applythis);applyB.set_size_request(140,28)
	buttonbox.pack_end(closeB,False,False,5);buttonbox.pack_end(applyB,False,False,5)

        mwin.show_all()
    #----------------------------------------------------------------------------------------------
    def patchSummary(self):

	def closethis(widget):mwin.destroy()

	os.system('patchSummary -expand -time 0 -case '+self.caseDir+' > '+self.caseDir+'/patchSummary')

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Patch Summary');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

	hbox=gtk.HBox(False,5);hbox.set_size_request(400,600);mainbox.pack_start(hbox,True,True,5)

        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview=gtk.TextView()
        textbuffer=textview.get_buffer()
        sw.add(textview)
        hbox.pack_start(sw,True,True,5)

	f=open(self.caseDir+'/patchSummary','r');ff=f.readlines();f.close()
	res=ff[24:-2];string=''
	for ii in res:string=string+ii
        textbuffer.set_text(string)

	buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
        #applyB=gtk.Button(label='Caculate');applyB.connect('clicked',applythis);applyB.set_size_request(140,28)
	buttonbox.pack_end(closeB,False,False,5)#;buttonbox.pack_end(applyB,False,False,5)

        mwin.show_all()
    #----------------------------------------------------------------------------------------------
    def probeLocation(self):

	def start(widget):
	    aa=self.varCombo.child;variable=aa.get_text()
	    aa=self.numCombo.child;number=int(aa.get_text())

	    xyz=[]    
	    for i in range(number):
		xx=self.xCoords[i].get_text();yy=self.yCoords[i].get_text();zz=self.zCoords[i].get_text()
		xyz.append('('+xx+' '+yy+' '+zz+')')

	    f=open(self.caseDir+'/system/probesDict','w')
	    f.write('FoamFile\n');f.write('{\n');f.write('    version         2.0;\n')
	    f.write('    format          ascii;\n');f.write('    class           dictionary;\n')
	    f.write('    location        system;\n');f.write('    object          probesDict;\n')
	    f.write('}\n')
	    f.write('fields\n')
	    f.write('(\n')
	    f.write('    '+variable+'\n')
	    f.write(');\n')
	    f.write('probeLocations\n')
	    f.write('(\n')
	    for ii in xyz:f.write('    '+ii+'\n')
	    f.write(');\n')	    
	    f.close()

	    os.system('probeLocations -latestTime -noFunctionObjects -case '+self.caseDir)

	    aa=glob.glob(self.caseDir+'/postProcessing/probes/*')
	    times=[]
	    for ii in aa:
	        bb=ii.split('/');times.append(bb[-1])
	    times.sort();lastTime=times[-1]

            textbuffer.set_text('ready')
	    aa=glob.glob(self.caseDir+'/postProcessing/probes/'+lastTime+'/'+variable)
	    string=''
	    f=open(aa[0],'r');ff=f.readlines();f.close()
	    for ii in ff:string=string+'  '+ii
            textbuffer.set_text(string)

	    os.system('rm -r '+self.caseDir+'/postProcessing/probes/'+lastTime)
	#-----------------------------------------------------------------------------
	def stop(widget,data=None):
	    self.Win.destroy()

	def setEntry(widget):
	    old=self.itembox.get_children();oldnumber=len(old)
	    oldx=[];oldy=[];oldz=[]
	    for i in range(oldnumber):
		oldx.append(self.xCoords[i].get_text());oldy.append(self.yCoords[i].get_text());oldz.append(self.zCoords[i].get_text())

	    aa=self.numCombo.child;pointnumber=int(aa.get_text())
	    self.xCoords=[];self.yCoords=[];self.zCoords=[];hboxs=[]

	    for i in range(len(old)):self.itembox.remove(old[i])
	    for i in range(pointnumber):
		self.xCoords.append(gtk.Entry());self.yCoords.append(gtk.Entry());self.zCoords.append(gtk.Entry())		
		hboxs.append(gtk.HBox(False,5))
	        self.itembox.pack_start(hboxs[i],False,False,5)
		label=gtk.Label('point'+str(i+1))
		self.xCoords[i].set_size_request(60,28);self.yCoords[i].set_size_request(60,28);self.zCoords[i].set_size_request(60,28)
		hboxs[i].pack_start(label,False,False,5)
		hboxs[i].pack_end(self.zCoords[i],False,False,5);hboxs[i].pack_end(self.yCoords[i],False,False,0)
		hboxs[i].pack_end(self.xCoords[i],False,False,5)
	    self.Win.show_all()

	    if oldnumber > pointnumber:
		for i in range(pointnumber):
		    self.xCoords[i].set_text(oldx[i]);self.yCoords[i].set_text(oldy[i]);self.zCoords[i].set_text(oldz[i])
	    else:
		for i in range(oldnumber):
		    self.xCoords[i].set_text(oldx[i]);self.yCoords[i].set_text(oldy[i]);self.zCoords[i].set_text(oldz[i])
	#-- GUI part ---------------------------------------------------------------------------        
        self.Win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.Win.connect('delete_event',self.delete_event);self.Win.connect('destroy',self.destroy)
        self.Win.set_border_width(10);self.Win.set_title('Set Points to probe')
	self.Win.set_position(gtk.WIN_POS_CENTER)

	self.hbox=gtk.HBox(False,5);self.Win.add(self.hbox)

        self.vbox=gtk.VBox(False,5);self.resultbox=gtk.VBox(True,5)
	self.hbox.pack_start(self.vbox,False,False,5);self.hbox.pack_start(self.resultbox,False,False,5)

	self.regbox=gtk.HBox(False,5)
	self.vbox.pack_start(self.regbox,False,False,5)
	
	label=gtk.Label('Select variables')
	self.varCombo=gtk.combo_box_entry_new_text()
	self.varCombo.set_size_request(140,28)
	variables=['p','p_rgh','U','T','k','epsilon','omega']
	for ii in variables:self.varCombo.append_text(ii)
	self.varCombo.set_active(0)
	self.varBox=gtk.HBox(False,5);self.vbox.pack_start(self.varBox,False,False,5)
	self.varBox.pack_start(label,False,False,5);self.varBox.pack_end(self.varCombo,False,False,5)
	#------------------------------
	self.locFrame=gtk.Frame()
        self.locFrame.set_label('Probe Locations');self.locFrame.set_label_align(0.0,1.0)
        self.locFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)

	self.locBox=gtk.VBox(False,5)        
	self.vbox.pack_start(self.locFrame,False,False,5)
        self.locFrame.add(self.locBox)

	self.nlabel=gtk.Label('Number of Points')
	self.numCombo=gtk.combo_box_entry_new_text()
	self.numCombo.set_size_request(100,28)
	numList=['0','1','2','3','4','5','6','7','8','9','10']
	for jj in numList:self.numCombo.append_text(jj)
	self.numCombo.set_active(0)
	self.numCombo.connect('changed',setEntry)

	self.npointbox=gtk.HBox(False,5)
	self.locBox.pack_start(self.npointbox,False,False,5)	
	self.npointbox.pack_start(self.nlabel,False,False,5);self.npointbox.pack_end(self.numCombo,False,False,5)

        self.swin=gtk.ScrolledWindow();self.swin.set_border_width(5);self.swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        self.locBox.pack_start(self.swin)
        self.itembox=gtk.VBox(False,0)
        self.swin.add_with_viewport(self.itembox)
        self.swin.set_size_request(300,200)
	#-----------------------------------
	self.buttonBox=gtk.HBox(False,5)
	self.vbox.pack_start(self.buttonBox,False,False,5)

	self.appB=gtk.Button('Apply');self.closeB=gtk.Button('Close')
	self.appB.set_size_request(100,28);self.closeB.set_size_request(100,28)
	self.appB.connect('clicked',start);self.closeB.connect('clicked',stop)
	self.buttonBox.pack_end(self.closeB,False,False,5);self.buttonBox.pack_end(self.appB,False,False,5)
	#------------------------------
	self.resFrame=gtk.Frame();self.resFrame.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.resultbox.pack_start(self.resFrame,True,True,5)

        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	sw.set_size_request(300,300)
        textview = gtk.TextView()
        textbuffer = textview.get_buffer()
        sw.add(textview)
        self.resFrame.add(sw)

        self.Win.show_all()
    #----------------------------------------------------------------------------------
    def main(self):
        gtk.main()

if __name__=='__main__':
    solverwin=Win()
    solverwin.main()
