#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for prepare running
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,glob;import pygtk;pygtk.require('2.0');import gtk

from writeFileIncompressibleSub import *;from writeFileHeatTransferSub import *
from incompressible import *;from heatTransfer import *

class runClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.solverWindow.destroy()

    def __init__(self,caseDir):
	self.caseDir=caseDir
    #-----------------------------------------------------------------------------
    def selhostfile(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                        gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            hostfilename=dialog.get_filename()
            print dialog.get_filename(), 'selected'
        elif response == gtk.RESPONSE_CANCEL:
	    hostfilename='None'
            print 'Closed, no files selected'
        dialog.destroy()   
	return hostfilename
    #-----------------------------------------------------------------------------
    def savestop(self):
	f=open(self.caseDir+'/system/controlDict','r');ff=f.readlines();f.close()
	for i in range(len(ff)):
	    if ff[i][:6]=='stopAt':ff[i]='stopAt          writeNow;\n'
	    else:pass
	f=open(self.caseDir+'/system/controlDict','w');
	for jj in ff:f.write(jj)
	f.close()
	print 'Stopping Current Run and Save'
    #-----------------------------------------------------------------------------
    def stop(self):
	f=open(self.caseDir+'/system/controlDict','r');ff=f.readlines();f.close()
	for i in range(len(ff)):
	    if ff[i][:6]=='stopAt':ff[i]='stopAt          noWriteNow;\n'
	    else:pass
	f=open(self.caseDir+'/system/controlDict','w');
	for jj in ff:f.write(jj)
	f.close()
	print 'Stopping Current Run Now'
    #-----------------------------------------------------------------------------
    def pimpleFoamStart(self,in1,in2,in3,solver,mode):

        crFile=writeFileClassIncompressible(self.caseDir)
	RUN=solvingClass(self.caseDir)

	#in1=[viscosity,density,turbulenceModel]
	#in2=[startFrom,startTime,stopAt,endTime,timeStepSize,adjustTimeStep,maxco,maxdt,wcontrol,writeInterval,purgeWrite,writeFormat,
	#     writePrecision,writeCompression,nCore,smpOrCluster,hostfile,plotresidual,potential]
	#in3=[ddt,grad,laplace,snGrad,divU,divTur,pSolver,USolver,corrphi,nout,ncorr,nonOrtho,resp,resU,restur,relaxp,relaxU,relaxtur]
	startFrom=in2[0];startTime=in2[1];stopAt=in2[2];endTime=in2[3];timeStepSize=in2[4];adjustTimeStep=in2[5]
	maxco=in2[6];maxdt=in2[7];wcontrol=in2[8];writeInterval=in2[9]
	purgeWrite=in2[10];writeFormat=in2[11];writePrecision=in2[12];writeCompression=in2[13]
	nCore=in2[14];smpOrCluster=in2[15];hostfile=in2[16];plotresidual=in2[17];potential=in2[18]
	ddt=in3[0];grad=in3[1];laplace=in3[2];interpol='linear';snGrad=in3[3];divU=in3[4];divTur=in3[5]
	pSolver=in3[6];USolver=in3[7];corrphi=in3[8];nout=in3[9];ncorr=in3[10];nonOrtho=in3[11]
	resp=in3[12];resU=in3[13];restur=in3[14]
	relaxp=in3[15];relaxU=in3[16];relaxtur=in3[17]

	inputs=[]
	aa=glob.glob(self.caseDir+'/temporary/importedMesh')
	if len(aa)==0:
            md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"Error! Mesh file is not Selected...")
            md.run();md.destroy()
	else:
	    f=open(self.caseDir+'/temporary/importedMesh','r');meshName=f.readline();f.close()
	    inputs.append(self.caseDir);inputs.append(meshName)
	    inputs.append(startFrom);inputs.append(startTime);inputs.append(stopAt);inputs.append(endTime)
	    inputs.append(timeStepSize);inputs.append(adjustTimeStep);inputs.append(maxco);inputs.append(maxdt);inputs.append(wcontrol)
	    inputs.append(writeInterval);inputs.append(purgeWrite);inputs.append(writeFormat);inputs.append(writePrecision)
	    inputs.append(writeCompression);inputs.append(nCore);inputs.append(smpOrCluster);inputs.append(hostfile)

	    if divU=='upwind':divU='Gauss upwind'
	    elif divU=='linearUpwindV Gauss linear':divU='Gauss linearUpwindV Gauss linear'
	    elif divU=='linearUpwindV cellLimited Gauss linear 1':divU='Gauss linearUpwindV cellLimited Gauss linear 1'
	    elif divU=='limitedLinearV 1':divU='Gauss limitedLinearV 1'

	    if divTur=='upwind':divTur='Gauss upwind'
	    elif divTur=='linearUpwind Gauss linear':divTur='Gauss linearUpwind Gauss linear'
	    elif divTur=='linearUpwind cellLimited Gauss linear 1':divTur='Gauss linearUpwind cellLimited Gauss linear 1'
	    elif divTur=='limitedLinear 1':divTur='Gauss limitedLinear 1'

	    inputs.append(ddt);inputs.append(grad);inputs.append(laplace);inputs.append(interpol);inputs.append(snGrad)
	    inputs.append(divU);inputs.append(divTur)
	    inputs.append(pSolver);inputs.append(USolver)
	    inputs.append(corrphi);inputs.append(nout);inputs.append(ncorr);inputs.append(nonOrtho)
	    inputs.append(resp);inputs.append(resU);inputs.append(restur)
	    inputs.append(relaxp);inputs.append(relaxU);inputs.append(relaxtur)

	    inputs.append(plotresidual)

	    inputs.append(in1[0]);inputs.append(in1[1]);inputs.append(in1[2])#;inputs.append(in1[3]);inputs.append(in1[4])

	    inputs.append(solver);inputs.append(potential)

	    crFile.inputfile(inputs)

	    RUN.runIncompressibleSolver(mode)
    #-----------------------------------------------------------------------------
    def buoyantFoamStart(self,gIn,nIn,rIn,solver,mode):

        crFileHT=writeFileClassHeatTransfer(self.caseDir)
	RUNHT=solvingClassHeatTransfer(self.caseDir)

	#gIn=[transientmode,grav,turbulenceModel,operatingp]
	#nIn=[ddt,grad,laplace,snGrad,divU,divTur,divh,pSolver,USolver,hSolver,momPredictor,nout,ncorr,nonOrtho,relaxp,relaxU,relaxtur,relaxh]
	#rIn=[startFrom,startTime,stopAt,endTime,timeStepSize,adjustTimeStep,maxco,maxdt,wcontrol,writeInterval,purgeWrite,writeFormat,
	#       writePrecision,writeCompression,nCore,smpOrCluster,hostfile,plotresidual,potential]

	startFrom=rIn[0];startTime=rIn[1];stopAt=rIn[2];endTime=rIn[3];timeStepSize=rIn[4];adjustTimeStep=rIn[5]
	maxco=rIn[6];maxdt=rIn[7];wcontrol=rIn[8];writeInterval=rIn[9]
	purgeWrite=rIn[10];writeFormat=rIn[11];writePrecision=rIn[12];writeCompression=rIn[13]
	nCore=rIn[14];smpOrCluster=rIn[15];hostfile=rIn[16];plotresidual=rIn[17];potential=rIn[18]

	ddt=nIn[0];grad=nIn[1];laplace=nIn[2];interpol='linear';snGrad=nIn[3];divU=nIn[4];divTur=nIn[5];divh=nIn[6]
	pSolver=nIn[7];USolver=nIn[8];hSolver=nIn[9];momPredictor=nIn[10];nout=nIn[11];ncorr=nIn[12];nonOrtho=nIn[13]
	relaxp=nIn[14];relaxU=nIn[15];relaxtur=nIn[16];relaxh=nIn[17]

	inputs=[]
	aa=glob.glob(self.caseDir+'/temporary/importedMesh')
	if len(aa)==0:
            md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"Error! Mesh file is not Selected...")
            md.run();md.destroy()
	else:
	    f=open(self.caseDir+'/temporary/importedMesh','r');meshName=f.readline();f.close()
	    inputs.append(self.caseDir);inputs.append(meshName)
	    inputs.append(startFrom);inputs.append(startTime);inputs.append(stopAt);inputs.append(endTime)
	    inputs.append(timeStepSize);inputs.append(adjustTimeStep);inputs.append(maxco);inputs.append(maxdt);inputs.append(wcontrol)
	    inputs.append(writeInterval);inputs.append(purgeWrite);inputs.append(writeFormat);inputs.append(writePrecision)
	    inputs.append(writeCompression);inputs.append(nCore);inputs.append(smpOrCluster);inputs.append(hostfile)

	    if divU=='upwind':divU='Gauss upwind'
	    elif divU=='linearUpwindV Gauss linear':divU='Gauss linearUpwindV Gauss linear'
	    elif divU=='linearUpwindV cellLimited Gauss linear 1':divU='Gauss linearUpwindV cellLimited Gauss linear 1'
	    elif divU=='limitedLinearV 1':divU='Gauss limitedLinearV 1'

	    if divTur=='upwind':divTur='Gauss upwind'
	    elif divTur=='linearUpwind Gauss linear':divTur='Gauss linearUpwind Gauss linear'
	    elif divTur=='linearUpwind cellLimited Gauss linear 1':divTur='Gauss linearUpwind cellLimited Gauss linear 1'
	    elif divTur=='limitedLinear 1':divTur='Gauss limitedLinear 1'

	    if divh=='upwind':divh='Gauss upwind'
	    elif divh=='linearUpwind Gauss linear':divh='Gauss linearUpwind Gauss linear'
	    elif divh=='linearUpwind cellLimited Gauss linear 1':divh='Gauss linearUpwind cellLimited Gauss linear 1'
	    elif divh=='limitedLinear 1':divh='Gauss limitedLinear 1'

	    inputs.append(ddt);inputs.append(grad);inputs.append(laplace);inputs.append(interpol);inputs.append(snGrad)
	    inputs.append(divU);inputs.append(divTur);inputs.append(divh)
	    inputs.append(pSolver);inputs.append(USolver);inputs.append(hSolver)
	    inputs.append(momPredictor);inputs.append(nout);inputs.append(ncorr);inputs.append(nonOrtho)
	    inputs.append(relaxp);inputs.append(relaxU);inputs.append(relaxtur);inputs.append(relaxh)

	    inputs.append(plotresidual)

	    inputs.append(gIn[1]);inputs.append(gIn[2]);inputs.append(gIn[3])#;inputs.append(gIn[4]);inputs.append(gIn[5])

	    inputs.append(solver);inputs.append(potential)

	    crFileHT.inputfile(inputs)

	    RUNHT.runHeatTransferSolver(mode)

    #-----------------------------------------------------------------------------
    def justRunIncompressible(self,startFrom,solver,nCore,smapOrCluster,potential,plotresidual,hostfilename):

	ss=glob.glob(self.caseDir+'/Running')
	if len(ss)==0:

	    f=open(self.caseDir+'/runSolver','w')

	    if nCore=='1':

	        aa=glob.glob(self.caseDir+'/processor*')
	        if len(aa)!=0:f.write('rm -r '+self.caseDir+'/processor* \n')

	        if potential=='yes':
		    os.system('cp -r '+self.caseDir+'/0 '+self.caseDir+'/0.org')
		    os.system('potentialFoam -writep -noFunctionObjects -case '+self.caseDir)
	        if startFrom=='startTime':
	            if plotresidual=='yes':
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamPlotRunner.py --clear --no-bound --no-continuity '+solver+' -case '+self.caseDir+'\n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamRunner.py --clear '+solver+' -case '+self.caseDir+'\n')
		        f.write('rm '+self.caseDir+'/Running \n')
	        else:
	            if plotresidual=='yes':
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamPlotRunner.py --no-bound --no-continuity '+solver+' -case '+self.caseDir+'\n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamRunner.py '+solver+' -case '+self.caseDir+'\n')
		        f.write('rm '+self.caseDir+'/Running \n')

	    else:
	        if potential=='yes':
		    os.system('cp -r '+self.caseDir+'/0 '+self.caseDir+'/0.org')
		    os.system('potentialFoam -writep -noFunctionObjects -case '+self.caseDir)

	        if startFrom=='startTime':
	            aa=glob.glob(self.caseDir+'/processor*')
	            if len(aa)!=0:os.system('rm -r '+self.caseDir+'/processor*')		
		    os.system('pyFoamClearCase.py '+self.caseDir)

		f.write('touch '+self.caseDir+'/Running \n')
	        f.write('decomposePar -force -case '+self.caseDir+'\n')
	        if smpOrCluster=='SMP':
	            if plotresidual=='yes':
		        f.write('pyFoamPlotRunner.py --no-bound --no-continuity mpirun -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('pyFoamRunner.py mpirun -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	        else:
	            if plotresidual=='yes':
		        f.write('pyFoamPlotRunner.py --no-bound --no-continuity mpirun --hostfile '+hostfile+' -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('pyFoamRunner.py  mpirun --hostfile '+hostfile+' -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')

	    f.close()
	    os.system('chmod +x '+self.caseDir+'/runSolver');os.system(self.caseDir+'/runSolver &')

    #-----------------------------------------------------------------------------
    def justRunHeatTransfer(self,startFrom,solver,nCore,smapOrCluster,plotresidual,hostfilename):

	ss=glob.glob(self.caseDir+'/Running')
	if len(ss)==0:

	    f=open(self.caseDir+'/runSolver','w')

	    if nCore=='1':
	        aa=glob.glob(self.caseDir+'/processor*')
	        if len(aa)!=0:os.system('rm -r '+self.caseDir+'/processor*')

	        if startFrom=='startTime':
	            if plotresidual=='yes':
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamPlotRunner.py --clear --no-bound --no-continuity '+solver+' -case '+self.caseDir+' \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamRunner.py --clear '+solver+' -case '+self.caseDir+' \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	        else:
	            if plotresidual=='yes':
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamPlotRunner.py --no-bound --no-continuity '+solver+' -case '+self.caseDir+' \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('touch '+self.caseDir+'/Running \n')
		        f.write('pyFoamRunner.py '+solver+' -case '+self.caseDir+' \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	    else:

	        if startFrom=='startTime':
	            aa=glob.glob(self.caseDir+'/processor*')
	            if len(aa)!=0:os.system('rm -r '+self.caseDir+'/processor*')		
		    os.system('pyFoamClearCase.py '+self.caseDir)

		f.write('touch '+self.caseDir+'/Running \n')
	        f.write('decomposePar -force -case '+self.caseDir+'\n')
	        if smpOrCluster=='SMP':
	            if plotresidual=='yes':
		        f.write('pyFoamPlotRunner.py --no-bound --no-continuity mpirun -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('pyFoamRunner.py mpirun -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	        else:
	            if plotresidual=='yes':
		        f.write('pyFoamPlotRunner.py --no-bound --no-continuity mpirun --hostfile '+hostfile+' -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')
	            else:
		        f.write('pyFoamRunner.py  mpirun --hostfile '+hostfile+' -np '+nCore+' '+solver+' -case '+self.caseDir+' -parallel \n')
		        f.write('rm '+self.caseDir+'/Running \n')

	    f.close()
	    os.system('chmod +x '+self.caseDir+'/runSolver');os.system(self.caseDir+'/runSolver &')

