{
    volScalarField rAU(1.0/UEqn().A());
    volVectorField HbyA("HbyA", U);
    HbyA = rAU*UEqn().H();
    UEqn.clear();

    phi = fvc::interpolate(HbyA) & mesh.Sf();

    fvOptions.makeRelative(phi);

    adjustPhi(phi, U, p);

    // Non-orthogonal pressure corrector loop
    while (simple.correctNonOrthogonal())
    {
        fvScalarMatrix pEqn
        (
            fvm::laplacian(rAU, p) == fvc::div(phi)
        );

        pEqn.setReference(pRefCell, pRefValue);

        pEqn.solve();

        if (simple.finalNonOrthogonalIter())
        {
            phi -= pEqn.flux();
        }
    }

    #include "continuityErrs.H"

    //p.relax();
    U = HbyA - rAU*fvc::grad(p);

    U.correctBoundaryConditions();
    fvOptions.correct(U);

    // Explicitly relax pressure for next momentum predictor
    p.relax();
}
